#!/usr/bin/X11/tixwish

proc editDateDialog {  } {
    global edd_init edd_einl edd_part edd_ext
    global edd_startD edd_stopD edd_startT edd_stopT
    global edd_room edd_flags edd_group 
    global eddo_ok eddo_abb eddo_prvTeilnLines cputype eddo_addButtonTitel
    global fnt12 bfnt  fnt bnft12  curr_perms
    global eddv_titel eddo_titel

    set eddo_prvTeilnLines 0

    toplevel .edd
    raiseLock .edd
    
    frame .edd.h -relief ridge -bd 2
    frame .edd.e
    frame .edd.b
    pack .edd.h .edd.e .edd.b -side top -fill x

    set eddo_titel .edd.h.t
    label .edd.h.l -text "Titel " -width 6 -font $bfnt
    entry $eddo_titel -width 42  -state disabled -font $fnt
    pack .edd.h.l  -side left   -expand 0  -padx 6 
    pack $eddo_titel -side left   -expand 1 -fill both -padx 6 -ipady 2
    bind $eddo_titel <KeyPress> {modiWinTitel}

    tixNoteBook .edd.e.nb 
    .edd.e.nb add times -label "Zeiten, Orte, etc."
    .edd.e.nb add part  -label "Teilnehmer"
    .edd.e.nb add details -label "Details und Kommentar"
    pack .edd.e.nb -side top -fill x


    drawEDDtimes   [.edd.e.nb subwidget times ]
    drawEDDpart    [.edd.e.nb subwidget part ]
    drawEDDdetails [.edd.e.nb subwidget details ]


    set eddo_abb .edd.b.abb
    button $eddo_abb -state disabled -text " Abbruch" -command {
	closeWin .edd
	set eddLock 0
    }
    pack $eddo_abb -side left 

    set eddo_ok .edd.b.ok
    button $eddo_ok -state disabled  -text $eddo_addButtonTitel -command sendDate
    pack $eddo_ok -side right


    centerWin .edd 950 576
    update

    bind .edd <Alt-q> {exitClient}
    focus -force .edd
}

proc modiWinTitel {  } {
    global edd_titel  edd_editTyp
    wm title .edd [format "%s : %s" $edd_editTyp $edd_titel ]
}






proc drawEDDtimes {win } {

     frame $win.l 
     frame $win.r  -relief raised -bd 2
     pack $win.l  $win.r -side left -fill both
  
     frame $win.l.t -relief raised -bd 2
     frame $win.l.m -relief raised -bd 2
     frame $win.l.b -relief raised -bd 2
     pack $win.l.t $win.l.m $win.l.b -side top -fill both -ipady 1 -ipadx 2


    drawEDDtimesZO $win.l.t
    drawEDDtimesProps $win.l.b
    drawEDDtimesRepeat $win.l.m
    drawEDDtimesRemind $win.r
}

proc drawEDDtimesZO {win} {
    global fnt bfnt fnt12 bfnt12 pfnt pbfnt pfnt12 pbfnt12
    global roomList  eddo_room
    global eddo_startDy eddo_startDm eddo_startDd eddo_startTh eddo_startTm 
    global eddo_stopDy eddo_stopDm eddo_stopDd eddo_stopTh eddo_stopTm 
    global eddv_startDy eddv_startDm eddv_startDd eddv_startTh eddv_startTm 
    global eddv_stopDy eddv_stopDm eddv_stopDd eddv_stopTh eddv_stopTm 
    global eddo_repeat eddo_repeat2 eddo_repeat3 eddo_repeat4
    global eddo_noTime eddo_nonBlock

    frame $win.l
    frame $win.v -relief ridge -bd 2
    pack $win.l -side top -fill x -pady 2
    pack $win.v -side top -fill x -pady 2

    frame $win.v.b
    frame $win.v.e 
    frame $win.v.t
    frame $win.v.s
    frame $win.v.r -relief raised -bd 3
    pack $win.v.b $win.v.e  $win.v.s $win.v.t -side top -fill x -pady 1
    pack $win.v.r -side top -fill x -pady 1

    
    label $win.l.l -text "Zeiten und Orte" -font $bfnt12
    pack $win.l.l -side left

    set eddo_startDy $win.v.b.sY
    set eddo_startDm $win.v.b.sM
    set eddo_startDd $win.v.b.sD
    set eddo_startTh $win.v.b.sh
    set eddo_startTm $win.v.b.sm
    tixControl $eddo_startDd  -label "Beginn"  -state disabled -min 0 -max 31 -integer 1 -command updateTTcurDate \
	-options {  entry.width 2 label.width 14 } -selectmode immediate -autorepeat true
    tixControl $eddo_startDm -options { entry.width 2} -label "." -state disabled -min 0 -max 12 -integer 1 -validatecmd adoptMaxStartDay  -command updateTTcurDate -selectmode immediate -autorepeat true
    tixControl $eddo_startDy -options { entry.width 4} -label "." -state disabled -min 1999 -max 2100 -integer 1  -command updateTTcurDate -selectmode immediate -autorepeat true
    tixControl $eddo_startTh -options { entry.width 2} -label "    -    " -state disabled -min 0 -max 23 -integer 1  -command updateTTcurDate -selectmode immediate -autorepeat true
    tixControl $eddo_startTm -options { entry.width 2} -label ":" -state disabled -min 0 -max 59 -integer 1  -command updateTTcurDate -selectmode immediate -autorepeat true
    label $win.v.b.l -text " " -width 1 -font $bfnt
    pack  $eddo_startDd $eddo_startDm $eddo_startDy $eddo_startTh $eddo_startTm $win.v.b.l -side left

    set eddo_stopDy $win.v.e.sY
    set eddo_stopDm $win.v.e.sM
    set eddo_stopDd $win.v.e.sD
    set eddo_stopTh $win.v.e.sg
    set eddo_stopTm $win.v.e.sm
    tixControl $eddo_stopDd -label "Ende" -state disabled -min 0 -max 31 -integer 1  -command updateTTcurDate -options {  entry.width 2 label.width 14 } -selectmode immediate -autorepeat true

    tixControl $eddo_stopDm -options { entry.width 2} -label "." -state disabled -min 0 -max 12 -integer 1 -validatecmd adoptMaxStopDay  -command updateTTcurDate -selectmode immediate -autorepeat true
    tixControl $eddo_stopDy -options { entry.width 4} -label "." -state disabled -min 1999 -max 2100 -integer 1  -command updateTTcurDate -selectmode immediate -autorepeat true
    tixControl $eddo_stopTh -options { entry.width 2} -label "    -    " -state disabled -min 0 -max 23 -integer 1  -command updateTTcurDate -selectmode immediate -autorepeat true
    tixControl $eddo_stopTm -options { entry.width 2} -label ":" -state disabled -min 0 -max 59 -integer 1  -command updateTTcurDate -selectmode immediate -autorepeat true
    label $win.v.e.l -text " " -width 1 -font $bfnt
    pack  $eddo_stopDd $eddo_stopDm $eddo_stopDy $eddo_stopTh $eddo_stopTm $win.v.e.l -side left


    set datelem "$eddo_stopDd $eddo_stopDm $eddo_stopDy $eddo_stopTh $eddo_stopTm $eddo_startDd $eddo_startDm $eddo_startDy $eddo_startTh $eddo_startTm"
    foreach w $datelem {
	$w subwidget entry configure  -font $pfnt
	$w subwidget label configure  -font $bfnt
	}

    set eddo_noTime $win.v.t.c
    label $win.v.t.l -text " " -width 14 -font $bfnt
    checkbutton $eddo_noTime -text "Termin ohne Uhrzeit" -font $bfnt
    pack $win.v.t.l $eddo_noTime -side left

    set eddo_nonBlock $win.v.s.c
    label $win.v.s.l -text " " -width 14 -font $bfnt
    checkbutton $eddo_nonBlock -text "schwebender Termin" -font $bfnt
    pack $win.v.s.l $eddo_nonBlock -side left

    frame $win.v.o 
    pack  $win.v.o -side top -fill x

    set eddo_room $win.v.o.m
    tixOptionMenu $eddo_room  -options {menubutton.width 14 label.width 14 } -label "Ort" -state disabled  -command {updateTT}
    $eddo_room subwidget label configure -font $bfnt
    $eddo_room subwidget menubutton configure  -font $bfnt12
    pack   $eddo_room -side left 
    foreach room $roomList { $eddo_room add command $room -label $room }

}

proc drawEDDtimesProps { win } {
    global groupList  eddo_group eddo_priv eddo_gpri  eddo_prior
    global bfnt fnt pbfnt pfnt bfnt12


    frame $win.l 
    frame $win.g -relief ridge -bd 2
    frame $win.s -relief ridge -bd 2
    frame $win.p -relief ridge -bd 2
    pack $win.l -side top -fill both  -ipady 1  -pady 3
    pack $win.g $win.s  $win.p -side top -fill both  -ipady 2 -pady 1

    label $win.l.l -text "weitere Eigenschaften" -font $bfnt12
    pack $win.l.l -side left

    set eddo_group $win.g.m
    tixOptionMenu $eddo_group -options {menubutton.width 14 label.width 16 label.font $pbfnt} -label "Gruppe" -state disabled  
    $eddo_group subwidget label configure -font $bfnt
    $eddo_group subwidget menubutton configure  -font $fnt
    pack $eddo_group -side left -expand 0
    foreach group $groupList { 
	$eddo_group add command $group -label $group 
    }
    $eddo_group subwidget menubutton configure  -font $bfnt12

    set eddo_priv $win.s.p
    set eddo_gpri $win.s.g
    label $win.s.l -text "Privat-Status"  -font $bfnt -width 16
    checkbutton $eddo_priv -text "privat          " -state disabled   -font $fnt
    checkbutton $eddo_gpri -text "gruppenintern" -state disabled   -font $fnt
    pack $win.s.l $eddo_priv $eddo_gpri -side left

    set eddo_prior $win.p.s
    label $win.p.l -text "Prioritt   "  -font $bfnt -width 16
    label $win.p.n -text "niedrig "  -font $fnt 
    scale $eddo_prior -state disabled -from 0 -to 7  -length  163 -resolution 1 -orient horizontal -showvalue 0
    label $win.p.h -text " hoch"  -font $fnt 
    pack $win.p.l $win.p.n $eddo_prior $win.p.h -side left 
}

proc     drawEDDtimesRepeat {win} {
    global edd_repEna edd_repTyp edd_repIntervall edd_repInterTyp edd_repCount edd_repInf
    global eddo_repEna eddo_repTyp eddo_repInf eddo_repCount eddo_repInter eddo_repItyp
    global eddo_repL1 eddo_repL2 eddo_repL3
    global bfnt fnt pbfnt pfnt fnt12 bfnt12
    global eddv_repTyp eddv_repUnit

    frame $win.l 
    frame $win.u -relief ridge -bd 2
    pack  $win.l $win.u  -side top -fill x -pady 3

    label $win.l.l -text "Wiederholungen" -font $bfnt12
    pack $win.l.l -side left

    frame $win.u.1
    frame $win.u.2
    frame $win.u.3
    frame $win.u.4
    pack  $win.u.1 $win.u.2 $win.u.3 $win.u.4 -side top -fill x -padx 2 -pady 2

    set eddo_repEna   $win.u.1.c
    set eddo_repTyp   $win.u.2.t
    set eddo_repL1    $win.u.3.l
    set eddo_repL2    $win.u.3.m
    set eddo_repL3    $win.u.4.l
    set eddo_repInf   $win.u.3.i
    set eddo_repCount $win.u.3.c
    set eddo_repInter $win.u.4.i
    set eddo_repItyp  $win.u.4.t

    checkbutton $eddo_repEna -text "Termin regelmig wiederholen" -font $bfnt -command {toggleRepeat} 
    pack $eddo_repEna -side left
    
    tixOptionMenu $eddo_repTyp  -options {menubutton.width 19 label.width 14 } -label "Intervall " -state disabled
    #Mit C-define und eddv_repTyp (-> initPartStatus) asyncron halten
    $eddo_repTyp add command tag   -label "tglich"
    $eddo_repTyp add command wtag  -label "wochen-tglich"
    $eddo_repTyp add command woche -label "wchentlich"
    $eddo_repTyp add command monat -label "monatlich"
    $eddo_repTyp add command jeden -label "jeden x.. des Monats"
    $eddo_repTyp add command alle  -label "alle"
    $eddo_repTyp subwidget menubutton configure  -font $bfnt12
    $eddo_repTyp subwidget label configure  -font $bfnt
    pack $eddo_repTyp -side left

    label $eddo_repL1 -text "Hufigkeit " -width 14 -font $bfnt  -foreground grey65
    checkbutton $eddo_repInf -variable edd_repEna -text "unbegrenzt, " -font $bfnt -command {toggleRepeatCount}  -state disabled
    label $win.u.3.s -text " " -width 2
    tixControl $eddo_repCount  -min 0 -max 31 -options {  entry.width 2  } -state disabled -selectmode immediate -autorepeat true
    label $eddo_repL2 -text " mal wiederholen" -font $bfnt -foreground grey65
    pack $eddo_repL1  $eddo_repInf $win.u.3.s $eddo_repCount  $eddo_repL2  -side left

    label $eddo_repL3 -text "Wiederholung " -width 14 -font $bfnt  -foreground grey65
    tixControl $eddo_repInter  -min 0 -max 31 -options {  entry.width 2  label.foreground grey65} \
	-label "alle " -state disabled -selectmode immediate -autorepeat true
    $eddo_repInter subwidget label configure -font $bfnt
    label $win.u.4.s -text "  " -width 1
    tixOptionMenu $eddo_repItyp  -options {menubutton.width 8} -state disabled
    #Mit C-define und eddv_repUnit (-> initPartStatus) asyncron halten
    $eddo_repItyp add command stunden -label "Stunden"
    $eddo_repItyp add command tage    -label "Tage"
    $eddo_repItyp add command woche   -label "Wochen"
    $eddo_repItyp add command monate  -label "Monate"
    $eddo_repItyp add command jahre   -label "Jahre"
    $eddo_repItyp subwidget menubutton configure  -font $bfnt12
    
    pack $eddo_repL3  $eddo_repInter $win.u.4.s $eddo_repItyp -side left
    $eddo_repTyp configure -command {toggleRepeatSpecial}
}
proc drawEDDtimesRemind { win } {
    global bfnt fnt pbfnt pfnt fnt12 bfnt12
    global eddo_reminder
    global edd_part
    global eddo_remWann1 eddo_remWann2 eddo_remWie eddo_remWer eddo_remAls1 eddo_remAls2
    global eddv_remVal eddv_remUnit eddv_remWeg eddv_remZiel eddv_remAls


    set eddv_remAls R

    frame $win.l
    frame $win.r 
    frame $win.d
    pack $win.l  -side top -fill x -pady 2 -ipady 1
    pack $win.r $win.d -side top -fill x

    label $win.l.l -text "Erinnerungen " -font $bfnt12
    pack $win.l.l -side left

    set eddo_reminder $win.r.r
    tixCObjView $eddo_reminder -width 520  -height 362 -scrollbar   y
    $eddo_reminder subwidget vsb configure -width 12
    pack $eddo_reminder -side top


    frame $win.d.l 
    frame $win.d.r 
    pack $win.d.l -side left -fill both
    pack $win.d.r -side right -fill both

    frame $win.d.l.a
    frame $win.d.l.t
    frame $win.d.l.m
    pack $win.d.l.a $win.d.l.t $win.d.l.m -side top -fill x

    set eddo_remAls1  $win.d.l.a.einl
    set eddo_remAls2 $win.d.l.a.rem
    set eddo_remWann1 $win.d.l.t.wann1
    set eddo_remWann2 $win.d.l.t.wann2 
    set eddo_remWie $win.d.l.t.wie
    set eddo_remWer $win.d.l.m.wer
    
    label $win.d.l.a.l -text "Schicke   "  -font $bfnt12
    radiobutton $eddo_remAls1 -value "E" -text "Einladung     " -font $bfnt12 -variable eddv_remAls
    radiobutton $eddo_remAls2 -value "R" -text "Erinnerung    " -font $bfnt12 -variable eddv_remAls
    pack $win.d.l.a.l  $eddo_remAls1 $eddo_remAls2 -side left

    label $win.d.l.t.s -text "   " -font $bfnt12 -width 8
    set eddv_remVal 1
    tixControl $eddo_remWann1  -min 1 -max 31 -options {  entry.width 4  } -variable eddv_remVal -selectmode immediate -autorepeat true
    tixOptionMenu $eddo_remWann2  -options {menubutton.width 9} -variable eddv_remUnit
    $eddo_remWann2 add command Tage -label "Tage"
    $eddo_remWann2 add command Stunden -label "Stunden"
    $eddo_remWann2 add command Minuten -label "Minuten"
    $eddo_remWann2  subwidget menubutton configure  -font $bfnt12
    label $win.d.l.t.wann3 -text " vorher als " -font $bfnt12
    
    tixOptionMenu $eddo_remWie  -options {menubutton.width 9 }  -variable eddv_remWeg
    $eddo_remWie add command E-mail -label "E-mail"
    $eddo_remWie add command Fenster -label "Fenster"
    $eddo_remWie add command Signal -label "Signalton"
    $eddo_remWie disable Fenster
    $eddo_remWie disable Signal 
    $eddo_remWie  subwidget menubutton configure  -font $bfnt12
    pack  $win.d.l.t.s $eddo_remWann1 $eddo_remWann2 $win.d.l.t.wann3 $eddo_remWie -side left
    

    label $win.d.l.m.s -text "   " -font $bfnt12 -width 8
    label $win.d.l.m.l -text "  an " -font $bfnt12 -width 7
    tixOptionMenu $eddo_remWer  -options {menubutton.width 34}  -variable eddv_remZiel
    updateReminderUser
    label $win.d.l.m.s2 -text "   " -font $bfnt12 -width 4
 
    $eddo_remWer subwidget menubutton configure  -font $bfnt12
    pack $win.d.l.m.s $win.d.l.m.l $eddo_remWer $win.d.l.m.s2 -side left

    button $win.d.r.go -text "hinzufgen" -font $bfnt12 -command {addRemind}
    pack $win.d.r.go -side bottom -pady 2

}

proc drawEDDpart { win } {

    frame $win.l -relief ridge -bd 2
    frame $win.r 
    pack $win.l $win.r -side left -fill x

    frame $win.r.t -relief ridge -bd 2
    frame $win.r.b -relief ridge -bd 2
    pack $win.r.t $win.r.b -side top -fill x

    drawEDDlist $win.l
    drawEDDselect $win.r.t
    drawEDDtimeTable $win.r.b
}

proc drawEDDdetails { win } {
    global fnt bfnt fnt12 bfnt12 pfnt pbfnt pfnt12 pbfnt12
    global eddo_comm eddo_commb eddo_detail eddo_newComm

    frame $win.l -relief ridge -bd 2
    frame $win.r  -relief ridge -bd 2
    pack $win.l $win.r -side left -fill x -padx 2 -pady 1

   
    #details
    set lwin $win.l
    set eddo_detail $lwin.text
    label $lwin.l -text "Details:" -font $bfnt
    tixScrolledText $eddo_detail -width 468 -height 452
    $eddo_detail subwidget text configure -font $fnt
    $eddo_detail subwidget text configure -state disabled
    $eddo_detail subwidget hsb configure -width 12
    $eddo_detail subwidget vsb configure -width 12
    pack  $lwin.l $eddo_detail -side top    -fill x   -padx 2
 
    set eddo_newComm $win.r.n
    label $win.r.l -text "neuer Kommentar" -font $bfnt
    tixScrolledText $eddo_newComm  -width 320 -height 100
    pack $win.r.l $eddo_newComm  -side top -fill x   -padx 2
    $eddo_newComm  subwidget vsb configure -width 12
    $eddo_newComm  subwidget hsb configure -width 12

    set eddo_commb $win.r.b
    button $eddo_commb -text " neuen Kommentar hinzufgen " -command addComm
    pack $eddo_commb -side top -pady 8   -padx 2
    
    set eddo_comm $win.r.text
    label $win.r.u -text " Kommentare" -font $bfnt
    tixScrolledText $eddo_comm -width 455 -height 290
    $eddo_comm  subwidget hsb configure -width 12
    $eddo_comm  subwidget vsb configure -width 12
    $eddo_comm subwidget text configure -state disabled
    $eddo_comm subwidget text configure -font $fnt12
    pack $win.r.u  -side top   -padx 2
    pack  $eddo_comm -side top   -expand 1 -fill both   -padx 2
  
}





#PERM einbauen

proc toggleRepeat {  } {
    global edd_repEna curr_perms
    global eddo_repEna eddo_repTyp eddo_repInf eddo_repCount eddo_repInter eddo_repItyp
    global eddo_repL1 eddo_repL2 eddo_repL3 
    global edd_shiftCount

    if { $edd_repEna == 1} {
	if { $curr_perms(rz) == 1} {
	    $eddo_repTyp   configure -state normal
	    $eddo_repInf   configure -state normal
	}
	$eddo_repL1    configure -foreground black
    } else {
	$eddo_repTyp   configure -state disabled
	$eddo_repInf   configure -state disabled
	$eddo_repL1    configure -foreground grey65
    }
    toggleRepeatCount 
    toggleRepeatSpecial x
}

proc toggleRepeatCount {  } {
    global edd_repInf edd_repEna curr_perms
    global eddo_repCount 
    global eddo_repL2

    if { $edd_repInf == 0 && $edd_repEna == 1} {
	if { $curr_perms(rz) == 1} {
	    $eddo_repCount configure -state normal
	}
	$eddo_repL2    configure -foreground black
    } else {
	$eddo_repCount configure -state disabled
	$eddo_repL2    configure -foreground grey65
    }
}
proc toggleRepeatSpecial { val } {
    global edd_repTyp edd_repEna
    global eddo_repInter eddo_repItyp
    global eddo_repL3 curr_perms

#    puts "edd_repTyp ='$edd_repTyp'"
    if { $edd_repTyp == "alle" && $edd_repEna == 1} {
	if { $curr_perms(rz) == 1} {
	    $eddo_repInter configure -state normal
	    $eddo_repItyp  configure -state normal
	}
	$eddo_repInter subwidget label configure -foreground black
	$eddo_repL3    configure -foreground black
    } else {
	$eddo_repInter configure -state disabled
	$eddo_repItyp  configure -state disabled
	$eddo_repL3    configure -foreground grey65
	$eddo_repInter subwidget label configure -foreground grey65
    }
}


proc updateReminderUser { } {
    global eddo_remWer edd_part curr_perms fullUsername edd_groupsOfUser
    global username

    set entList [$eddo_remWer entries]
    foreach ent $entList { $eddo_remWer delete $ent }

    if { $curr_perms(wt) == 1 && $curr_perms(wz) == 1} {
	$eddo_remWer add command alle -label "Alle"	
	$eddo_remWer add command intern -label "interne Teilnehmer"
	$eddo_remWer add command extern -label "externe Teilnehmer"
    }
    foreach part $edd_part { 
	if { $curr_perms(wt) == 1 && $curr_perms(wz) == 1} {
	    $eddo_remWer add command [lindex $part 1] -label [lindex $part 5]
	} else { 
	    if { [lindex $part 6] == "u" } {
		if { $username == [lindex $part 1] } {
		    $eddo_remWer add command [lindex $part 1] -label [lindex $part 5]
		}
	    } elseif { [lindex $part 6] == "g" } {
		if { [lsearch $edd_groupsOfUser [lindex $part 1] ] >= 0} {
		    $eddo_remWer add command [lindex $part 1] -label [lindex $part 5]
		}		    
	    }
	}
    }    
}
proc addRemind { } {
    global eddv_remVal eddv_remUnit eddv_remWeg eddv_remZiel eddv_remAls 
    global edd_reminder eddo_remWer

    set full [ $eddo_remWer entrycget $eddv_remZiel -label ]

    lappend edd_reminder "$eddv_remVal $eddv_remUnit $eddv_remWeg $eddv_remZiel {$full} $eddv_remAls"
    fillReminder
}

proc adoptMaxStartDay { mon } {
    global eddo_startDd monlen

    $eddo_startDd configure -max [ lindex monlen  $mon ]
    return $mon
}
proc adoptMaxStopDay { mon } {
    global eddo_stopDd monlen

    $eddo_stopDd configure -max [ lindex monlen  $mon ]
    return $mon
}
    

proc drawEDDlist { win } {
    global eddo_teilnehmer eddo_teilnehmer_sel eddo_teilTitel
    global cputype
    global fnt12 pfnt12 bfnt12 sbfnt12 bfnt11 bfnt10

    frame $win.t 
    frame $win.l
    pack $win.t $win.l -side top -fill both -expand 1 
    
    set eddo_teilTitel $win.t
    label $win.t.1 -relief raised -bd 2 -text "     Name" -width 33 -font $bfnt12 -height 0
    label $win.t.2 -relief raised -bd 2 -text "     Status     " -font $bfnt12 -height 0
    label $win.t.3 -relief raised -bd 2 -text "       Rechte        " -font $bfnt12 -height 0
    label $win.t.4 -relief raised -bd 2 -text " X " -font $bfnt12 -height 0
    label $win.t.5 -relief raised -bd 2 -text "   " -font $bfnt12 -height 0
    pack $win.t.1 $win.t.2 $win.t.3 $win.t.4 $win.t.5 -side left -expand 0    -ipady 0 -pady 0    
    
#    puts stdout [$win.t.1 cget -height]

    set eddo_teilnehmer $win.c 
#    tixCObjView $eddo_teilnehmer -width 470  -height 220 -scrollbar y
    tixCObjView $eddo_teilnehmer -width 470  -height 450 -scrollbar y
    $eddo_teilnehmer subwidget hsb configure -width 12
    $eddo_teilnehmer subwidget vsb configure -width 12
    $eddo_teilnehmer subwidget canvas configure -background grey95
    pack $eddo_teilnehmer -side left -expand 0  -fill y      
    set eddo_teilnehmer_sel ""
}

proc drawEDDselect { win } {
    global bfnt12

    tixNoteBook $win.nb -ipadx 2 -ipady 0  
    $win.nb subwidget nbframe configure  -font $bfnt12
    $win.nb add userGroups -label  " User / Groups " -underline -1
    $win.nb add addressen -label  " externe Teilnehmer" -underline -1
    $win.nb add defPerms -label  " Standardrechte " -underline -1
    pack $win.nb -fill x
    
    drawEDDselectLocal [ $win.nb subwidget userGroups ]
    drawEDDselectExtern [ $win.nb subwidget addressen ]
    drawEDDdefPerms [ $win.nb subwidget defPerms ]
}

proc drawEDDselectLocal { win } {
    global groupList userList
    global eddo_users eddo_groups
    global eddo_addEinl eddo_addTeiln eddo_addInfo
    global fnt bfnt

    frame $win.b
    frame $win.u
    frame $win.g
    pack $win.b -side left
    pack $win.u -side left -padx 4
    pack $win.g -side left

#    check4NewLists
    set eddo_addEinl  $win.b.addE
    set eddo_addTeiln $win.b.addG
    set eddo_addInfo  $win.b.addI
    button $eddo_addEinl  -command {addSelection E} -text "<- Einladener" -font $fnt
    button $eddo_addTeiln -command {addSelection T} -text "<- Teilnehmer" -font $fnt
    button $eddo_addInfo  -command {addSelection i} -text "<-Information" -font $fnt
    pack $eddo_addEinl $eddo_addTeiln $eddo_addInfo -side top -pady 10

    set eddo_users $win.u.b
    tixScrolledListBox $eddo_users -scrollbar auto -height 182 -width 168 -options {listbox.selectMode extended}
    $eddo_users subwidget vsb configure -width 12
    $eddo_users subwidget hsb configure -width 12
    $eddo_users subwidget listbox configure -font $fnt
    pack $eddo_users -fill both
    foreach user $userList { 
	$eddo_users subwidget listbox insert end  $user
    }

    set eddo_groups $win.g.b
    tixScrolledListBox $eddo_groups -scrollbar auto -height 182 -width 160 -options {listbox.selectMode extended}
    $eddo_groups subwidget listbox configure -font $fnt
    pack $eddo_groups -fill both
    foreach group $groupList { 
	$eddo_groups subwidget listbox insert end  $group
    }
    $eddo_groups subwidget vsb configure -width 12
    $eddo_groups subwidget hsb configure -width 12
}
proc drawEDDselectExtern { win } {
    global extList
    global eddo_extern
    global eddo_addExt
    global fnt bfnt

    frame $win.b
    frame $win.e
    pack $win.b -side left
    pack $win.e -side left -padx 4

#    check4NewLists
    set eddo_addExt   $win.b.addE
    button $eddo_addExt -command {addSelection A} -text "<- Teilnehmer" -font $fnt
    pack  $eddo_addExt -side top -pady 10

    set eddo_extern $win.e.b
    tixScrolledListBox $eddo_extern -scrollbar auto -height 182 -width 320 -options {listbox.selectMode extended}
    $eddo_extern subwidget vsb configure -width 12
    $eddo_extern subwidget hsb configure -width 12
    $eddo_extern subwidget listbox configure -font $fnt
    pack $eddo_extern -fill both
    foreach user $extList { 
	$eddo_extern subwidget listbox insert end  $user
    }
}
proc drawEDDdefPerms { win } {
    global edd_defPerm_ELZ edd_defPerm_ELU edd_defPerm_ELT edd_defPerm_ELR 
    global edd_defPerm_ESZ edd_defPerm_ESU edd_defPerm_EST edd_defPerm_ESR
    global edd_defPerm_TLZ edd_defPerm_TLU edd_defPerm_TLT edd_defPerm_TLR 
    global edd_defPerm_TSZ edd_defPerm_TSU edd_defPerm_TST edd_defPerm_TSR
    global edd_defPerm_ALZ edd_defPerm_ALU edd_defPerm_ALT edd_defPerm_ALR 
    global edd_defPerm_ASZ edd_defPerm_ASU edd_defPerm_AST edd_defPerm_ASR
    global edd_defPerm_ILZ edd_defPerm_ILU edd_defPerm_ILT edd_defPerm_ILR 
    global edd_defPerm_ISZ edd_defPerm_ISU edd_defPerm_IST edd_defPerm_ISR
    global edd_defPerm_ED  edd_defPerm_TD  edd_defPerm_AD  edd_defPerm_ID  
    global up_defEinlPerm up_defTeilnPerm up_defInfoPerm up_defExtPerm
    global bfnt fnt bfnt12 fnt12

    if { [ string range $up_defEinlPerm 0 0] != "-" } { set edd_defPerm_ELZ 1} else { set edd_defPerm_ELZ 0}
    if { [ string range $up_defEinlPerm 1 1] != "-" } { set edd_defPerm_ELU 1} else { set edd_defPerm_ELU 0}
    if { [ string range $up_defEinlPerm 2 2] != "-" } { set edd_defPerm_ELT 1} else { set edd_defPerm_ELT 0}
    if { [ string range $up_defEinlPerm 3 3] != "-" } { set edd_defPerm_ELR 1} else { set edd_defPerm_ELR 0}
    if { [ string range $up_defEinlPerm 4 4] != "-" } { set edd_defPerm_ESZ 1} else { set edd_defPerm_ESZ 0}
    if { [ string range $up_defEinlPerm 5 5] != "-" } { set edd_defPerm_ESU 1} else { set edd_defPerm_ESU 0}
    if { [ string range $up_defEinlPerm 6 6] != "-" } { set edd_defPerm_EST 1} else { set edd_defPerm_EST 0}
    if { [ string range $up_defEinlPerm 7 7] != "-" } { set edd_defPerm_ESR 1} else { set edd_defPerm_ESR 0}
    if { [ string range $up_defEinlPerm 8 8] != "-" } { set edd_defPerm_ED  1} else { set edd_defPerm_ED  0}

    if { [ string range $up_defTeilnPerm 0 0] != "-" } { set edd_defPerm_TLZ 1} else { set edd_defPerm_TLZ 0}
    if { [ string range $up_defTeilnPerm 1 1] != "-" } { set edd_defPerm_TLU 1} else { set edd_defPerm_TLU 0}
    if { [ string range $up_defTeilnPerm 2 2] != "-" } { set edd_defPerm_TLT 1} else { set edd_defPerm_TLT 0}
    if { [ string range $up_defTeilnPerm 3 3] != "-" } { set edd_defPerm_TLR 1} else { set edd_defPerm_TLR 0}
    if { [ string range $up_defTeilnPerm 4 4] != "-" } { set edd_defPerm_TSZ 1} else { set edd_defPerm_TSZ 0}
    if { [ string range $up_defTeilnPerm 5 5] != "-" } { set edd_defPerm_TSU 1} else { set edd_defPerm_TSU 0}
    if { [ string range $up_defTeilnPerm 6 6] != "-" } { set edd_defPerm_TST 1} else { set edd_defPerm_TST 0}
    if { [ string range $up_defTeilnPerm 7 7] != "-" } { set edd_defPerm_TSR 1} else { set edd_defPerm_TSR 0}
    if { [ string range $up_defTeilnPerm 8 8] != "-" } { set edd_defPerm_TD  1} else { set edd_defPerm_TD  0}

    if { [ string range $up_defExtPerm 0 0] != "-" } { set edd_defPerm_ALZ 1} else { set edd_defPerm_ALZ 0}
    if { [ string range $up_defExtPerm 1 1] != "-" } { set edd_defPerm_ALU 1} else { set edd_defPerm_ALU 0}
    if { [ string range $up_defExtPerm 2 2] != "-" } { set edd_defPerm_ALT 1} else { set edd_defPerm_ALT 0}
    if { [ string range $up_defExtPerm 3 3] != "-" } { set edd_defPerm_ALR 1} else { set edd_defPerm_ALR 0}
    if { [ string range $up_defExtPerm 4 4] != "-" } { set edd_defPerm_ASZ 1} else { set edd_defPerm_ASZ 0}
    if { [ string range $up_defExtPerm 5 5] != "-" } { set edd_defPerm_ASU 1} else { set edd_defPerm_ASU 0}
    if { [ string range $up_defExtPerm 6 6] != "-" } { set edd_defPerm_AST 1} else { set edd_defPerm_AST 0}
    if { [ string range $up_defExtPerm 7 7] != "-" } { set edd_defPerm_ASR 1} else { set edd_defPerm_ASR 0}
    set edd_defPerm_AD 0

    if { [ string range $up_defInfoPerm 1 1] != "-" } { set edd_defPerm_ILZ 1} else { set edd_defPerm_ILZ 0}
    if { [ string range $up_defInfoPerm 2 2] != "-" } { set edd_defPerm_ILU 1} else { set edd_defPerm_ILU 0}
    if { [ string range $up_defInfoPerm 3 3] != "-" } { set edd_defPerm_ILT 1} else { set edd_defPerm_ILT 0}
    if { [ string range $up_defInfoPerm 4 4] != "-" } { set edd_defPerm_ILR 1} else { set edd_defPerm_ILR 0}



    frame $win.t -relief raised -bd 1
    frame $win.b
    pack $win.t  -side top -fill x -ipady 0 -pady 0
    pack $win.b -side top -fill x -pady 2


    
    frame $win.t.1
    frame $win.t.2 
    frame $win.t.3 
    frame $win.t.4 
    frame $win.t.5
    pack $win.t.1 $win.t.2 $win.t.3 $win.t.4   $win.t.5 -side left -fill x

    label $win.t.1.l -text "  "
    frame $win.t.1.c -relief flat -bd 2
    pack $win.t.1.l $win.t.1.c  -side top -padx 1 -pady 2
    label $win.t.2.l -text "Einladene" -font $bfnt
    frame $win.t.2.c -relief ridge -bd 2
    pack  $win.t.2.l $win.t.2.c  -side top -padx 1 -pady 2
    label $win.t.3.l -text "Teilnehmer" -font $bfnt
    frame $win.t.3.c -relief ridge -bd 2
    pack  $win.t.3.l $win.t.3.c  -side top -padx 1 -pady 2
    label $win.t.4.l -text "externe" -font $bfnt
    frame $win.t.4.c -relief ridge -bd 2
    pack  $win.t.4.l $win.t.4.c  -side top -padx 1 -pady 2
    label $win.t.5.l -text "Inform." -font $bfnt
    frame $win.t.5.c -relief ridge -bd 2
    pack  $win.t.5.l $win.t.5.c  -side top -padx 1 -pady 2
    
    frame  $win.t.1.c.0
    frame  $win.t.1.c.1
    frame  $win.t.1.c.2
    frame  $win.t.1.c.3
    frame  $win.t.1.c.4
    frame  $win.t.1.c.5
    pack $win.t.1.c.0 $win.t.1.c.1 $win.t.1.c.2 $win.t.1.c.3 $win.t.1.c.4 $win.t.1.c.5 -side top -fill x
    label $win.t.1.c.0.l -text "   "
    label $win.t.1.c.1.l -text "Zeiten & Orte " -font $bfnt
    label $win.t.1.c.2.l -text "berschrift   " -font $bfnt
    label $win.t.1.c.3.l -text "Teilnehmer    " -font $bfnt
    label $win.t.1.c.4.l -text "Kommentare    " -font $bfnt
    label $win.t.1.c.5.l -text "Termin lschen" -font $bfnt
    
    pack $win.t.1.c.0.l -side left -fill x -pady 3
    pack $win.t.1.c.1.l $win.t.1.c.2.l $win.t.1.c.3.l $win.t.1.c.4.l $win.t.1.c.5.l -side left -fill x -pady 3




    frame  $win.t.2.c.0
    frame  $win.t.2.c.1
    frame  $win.t.2.c.2
    frame  $win.t.2.c.3
    frame  $win.t.2.c.4
    frame  $win.t.2.c.5
    pack $win.t.2.c.0 $win.t.2.c.1 $win.t.2.c.2 $win.t.2.c.3 $win.t.2.c.4 $win.t.2.c.5 -side top -fill x
    label $win.t.2.c.0.l -text "Lesen " -font $bfnt12
    label $win.t.2.c.0.s -text "ndern" -font $bfnt12
    checkbutton $win.t.2.c.1.l -variable edd_defPerm_ELZ
    checkbutton $win.t.2.c.2.l -variable edd_defPerm_ELU
    checkbutton $win.t.2.c.3.l -variable edd_defPerm_ELT
    checkbutton $win.t.2.c.4.l -variable edd_defPerm_ELR
    checkbutton $win.t.2.c.1.s -variable edd_defPerm_ESZ
    checkbutton $win.t.2.c.2.s -variable edd_defPerm_ESU
    checkbutton $win.t.2.c.3.s -variable edd_defPerm_EST
    checkbutton $win.t.2.c.4.s -variable edd_defPerm_ESR
    checkbutton $win.t.2.c.5.d -variable edd_defPerm_ED
    pack $win.t.2.c.0.l $win.t.2.c.1.l $win.t.2.c.2.l $win.t.2.c.3.l $win.t.2.c.4.l -side left -fill x -pady 0
    pack $win.t.2.c.0.s $win.t.2.c.1.s $win.t.2.c.2.s $win.t.2.c.3.s $win.t.2.c.4.s -side right -fill x -pady 0
    pack $win.t.2.c.5.d -side top

    frame  $win.t.3.c.0
    frame  $win.t.3.c.1
    frame  $win.t.3.c.2
    frame  $win.t.3.c.3
    frame  $win.t.3.c.4
    frame  $win.t.3.c.5
    pack $win.t.3.c.0 $win.t.3.c.1 $win.t.3.c.2 $win.t.3.c.3 $win.t.3.c.4 $win.t.3.c.5 -side top -fill x
    label $win.t.3.c.0.l -text "Lesen " -font $bfnt12
    label $win.t.3.c.0.s -text "ndern" -font $bfnt12
    checkbutton $win.t.3.c.1.l -variable edd_defPerm_TLZ
    checkbutton $win.t.3.c.2.l -variable edd_defPerm_TLU
    checkbutton $win.t.3.c.3.l -variable edd_defPerm_TLT
    checkbutton $win.t.3.c.4.l -variable edd_defPerm_TLR
    checkbutton $win.t.3.c.1.s -variable edd_defPerm_TSZ
    checkbutton $win.t.3.c.2.s -variable edd_defPerm_TSU
    checkbutton $win.t.3.c.3.s -variable edd_defPerm_TST
    checkbutton $win.t.3.c.4.s -variable edd_defPerm_TSR
    checkbutton $win.t.3.c.5.d -variable edd_defPerm_TD
    pack $win.t.3.c.0.l $win.t.3.c.1.l $win.t.3.c.2.l $win.t.3.c.3.l $win.t.3.c.4.l -side left -fill x -pady 0
    pack $win.t.3.c.0.s $win.t.3.c.1.s $win.t.3.c.2.s $win.t.3.c.3.s $win.t.3.c.4.s -side right -fill x -pady 0
    pack $win.t.3.c.5.d -side top 

    frame  $win.t.4.c.0
    frame  $win.t.4.c.1
    frame  $win.t.4.c.2
    frame  $win.t.4.c.3
    frame  $win.t.4.c.4
    frame  $win.t.4.c.5
    pack $win.t.4.c.0 $win.t.4.c.1 $win.t.4.c.2 $win.t.4.c.3 $win.t.4.c.4 $win.t.4.c.5 -side top -fill x
    label $win.t.4.c.0.l -text "Lesen " -font $bfnt12
    label $win.t.4.c.0.s -text "ndern" -font $bfnt12
    checkbutton $win.t.4.c.1.l -variable edd_defPerm_ALZ
    checkbutton $win.t.4.c.2.l -variable edd_defPerm_ALU
    checkbutton $win.t.4.c.3.l -variable edd_defPerm_ALT
    checkbutton $win.t.4.c.4.l -variable edd_defPerm_ALR
    checkbutton $win.t.4.c.1.s -variable edd_defPerm_ASZ
    checkbutton $win.t.4.c.2.s -variable edd_defPerm_ASU
    checkbutton $win.t.4.c.3.s -variable edd_defPerm_AST
    checkbutton $win.t.4.c.4.s -variable edd_defPerm_ASR
    label $win.t.4.c.5.d  -text " "
    set edd_defPerm_AD 0
    pack $win.t.4.c.0.l $win.t.4.c.1.l $win.t.4.c.2.l $win.t.4.c.3.l $win.t.4.c.4.l -side left -fill x -pady 0
    pack $win.t.4.c.0.s $win.t.4.c.1.s $win.t.4.c.2.s $win.t.4.c.3.s $win.t.4.c.4.s -side right -fill x -pady 0
    pack $win.t.4.c.5.d -side top -pady 2

    frame  $win.t.5.c.0
    frame  $win.t.5.c.1
    frame  $win.t.5.c.2
    frame  $win.t.5.c.3
    frame  $win.t.5.c.4
    frame  $win.t.5.c.5
    pack $win.t.5.c.0 $win.t.5.c.1 $win.t.5.c.2 $win.t.5.c.3 $win.t.5.c.4 $win.t.5.c.5 -side top -fill x
    label $win.t.5.c.0.l -text " Lesen " -font $bfnt12
    checkbutton $win.t.5.c.1.l -variable edd_defPerm_ILZ -text "  "
    checkbutton $win.t.5.c.2.l -variable edd_defPerm_ILU -text "  "
    checkbutton $win.t.5.c.3.l -variable edd_defPerm_ILT -text "  "
    checkbutton $win.t.5.c.4.l -variable edd_defPerm_ILR -text "  "
    label $win.t.5.c.5.d  -text " "
    set edd_defPerm_ISZ 0
    set edd_defPerm_ISU 0 
    set edd_defPerm_IST 0
    set edd_defPerm_ISR 0
    set edd_defPerm_ID 0
    pack $win.t.5.c.0.l  -side left -fill x
    pack $win.t.5.c.1.l $win.t.5.c.2.l $win.t.5.c.3.l $win.t.5.c.4.l -side right -fill x -pady 0
    pack $win.t.5.c.5.d -side top -pady 2

    button $win.b.ok -text "bernehmen" -command {acceptPerms -}
    button $win.b.save  -text "bernehmen & Speichern" -command {acceptPerms s}
    pack $win.b.ok $win.b.save -side right -padx 5
}
proc acceptPerms { mode } {
    global edd_defPerm_ELZ edd_defPerm_ELU edd_defPerm_ELT edd_defPerm_ELR 
    global edd_defPerm_ESZ edd_defPerm_ESU edd_defPerm_EST edd_defPerm_ESR
    global edd_defPerm_TLZ edd_defPerm_TLU edd_defPerm_TLT edd_defPerm_TLR 
    global edd_defPerm_TSZ edd_defPerm_TSU edd_defPerm_TST edd_defPerm_TSR
    global edd_defPerm_ALZ edd_defPerm_ALU edd_defPerm_ALT edd_defPerm_ALR 
    global edd_defPerm_ASZ edd_defPerm_ASU edd_defPerm_AST edd_defPerm_ASR
    global edd_defPerm_ILZ edd_defPerm_ILU edd_defPerm_ILT edd_defPerm_ILR 
    global edd_defPerm_ISZ edd_defPerm_ISU edd_defPerm_IST edd_defPerm_ISR
    global edd_defPerm_ED  edd_defPerm_TD  edd_defPerm_AD  edd_defPerm_ID  
    global up_defEinlPerm up_defTeilnPerm up_defInfoPerm up_defExtPerm


    set up_defEinlPerm  [ rlist2str "$edd_defPerm_ELZ $edd_defPerm_ELU $edd_defPerm_ELT $edd_defPerm_ELR $edd_defPerm_ESZ $edd_defPerm_ESU $edd_defPerm_EST $edd_defPerm_ESR $edd_edfPerm_ED" ]
    set up_defTeilnPerm [ rlist2str "$edd_defPerm_TLZ $edd_defPerm_TLU $edd_defPerm_TLT $edd_defPerm_TLR $edd_defPerm_TSZ $edd_defPerm_TSU $edd_defPerm_TST $edd_defPerm_TSR $edd_edfPerm_TD" ]
    set up_defExtPerm   [ rlist2str "$edd_defPerm_ALZ $edd_defPerm_ALU $edd_defPerm_ALT $edd_defPerm_ALR $edd_defPerm_ASZ $edd_defPerm_ASU $edd_defPerm_AST $edd_defPerm_ASR $edd_edfPerm_AD" ]
    set up_defInfoPerm [ rlist2str "$edd_defPerm_ILZ $edd_defPerm_ILU $edd_defPerm_ILT $edd_defPerm_ILR $edd_defPerm_ISZ $edd_defPerm_ISU $edd_defPerm_IST $edd_defPerm_ISR $edd_edfPerm_ID" ]
    if {$mode == "s"} { writeUserPrefs}
}

proc rlist2str { list } {

    set clist "z  t k z  t k d"
    set pstr ""
    for {set i 0 } { $i<9} { incr i} {
	if { [lindex $list $i] == 1 } { 
	    set c [lindex $clist $i ]
	} else  {
	    set c "-"
	}
	set pstr "$pstr$c"
    }
    return  $pstr
}

proc addSelection { type } {
    global eddo_users eddo_groups edd_currUserPerm  eddo_extern
    global groupList userList edd_part edd_part_quick extList
    global up_defEinlPerm up_defTeilnPerm up_defInfoPerm up_defExtPerm
    global edd_teilnChange curr_perms
    

    set edd_teilnChange 1
    set selection  [$eddo_users subwidget listbox curselection]
    set newTeiln ""
    foreach sel $selection {
	set user [lindex $userList $sel]
	if { [lsearch $edd_part_quick $user] <0} {
	    switch $type {
		E { set perm $up_defEinlPerm}
		T { set perm $up_defTeilnPerm}
		A { set perm $up_defExtPerm}
		i { set perm $up_defInfoPerm}
		* { set perm $up_defTeilnPerm}
	    }
	    set ent [format "$type $user  UKN - $perm {%s} u" [ getFullUserName $user u]]
	    lappend edd_part $ent
	}
    }
    set selection  [$eddo_groups subwidget listbox curselection]
    foreach sel $selection {
	set group [lindex $groupList $sel]
	if { [lsearch $edd_part_quick $group] <0} {
	    switch $type {
		E { set perm $up_defEinlPerm}
		T { set perm $up_defTeilnPerm}
		A { set perm $up_defExtPerm}
		i { set perm $up_defInfoPerm}
		* { set perm $up_defTeilnPerm}
	    }
	    set ent "$type $group  UKN - $perm {Gruppe $group} g"
	    lappend edd_part $ent
	}
    }

     set selection  [$eddo_extern subwidget listbox curselection]
     foreach sel $selection {
 	set user [lindex $extList $sel]
 	if { [lsearch $edd_part_quick $user] <0} {
 	    switch $type {
 		E { set perm $up_defEinlPerm}
 		T { set perm $up_defTeilnPerm}
 		A { set perm $up_defExtPerm}
 		i { set perm $up_defInfoPerm}
 		* { set perm $up_defTeilnPerm}
 	    }
 	    set ent "$type {$user}  UKN - $perm {$user} a"
 	    lappend edd_part $ent
 	}
     }
   
    if { $curr_perms(rt) == 1} {
	fillTeiln 
    }
    updateReminderUser
}

proc drawEDDtimeTable { win } {
    global eddo_tt  eddo_tt_list


    set eddo_tt $win.c
    canvas $eddo_tt -width 470 -height 223
    pack $eddo_tt -side left 
    set eddo_tt_list ""
    __drawEDDtimeTable
}
proc redrawEDDtimeTable {  } {
    global eddo_tt 

    $eddo_tt delete all
    __drawEDDtimeTable
    fillTimeTable
}

proc __drawEDDtimeTable { } {
    global eddo_tt 
    global eddv_day eddv_mon eddv_year
    global  eddtt_x0 eddtt_y0 eddtt_dx eddtt_dy
    global tt_wList tt_startDay tt_stopDay


    set wt "Mo Di Mi Do Fr Sa So"

    set day   $eddv_day
    set mon   $eddv_mon
    set year $eddv_year

    set ret [ calcDate $eddv_day $eddv_mon $eddv_year 6 ]
    set tt_startDay [ format "%4d%02d%02d" $eddv_year $eddv_mon $eddv_day ]
    set tt_stopDay [ format "%4d%02d%02d" [lindex $ret 2] [lindex $ret 1] [lindex $ret 0] ]
    set tt_wList "$tt_startDay "
    for { set i 1} {$i<7} {incr i} {
	set ret [ calcDate $eddv_day $eddv_mon $eddv_year $i ]
	lappend tt_wList [ format "%4d%02d%02d" [lindex $ret 2] [lindex $ret 1] [lindex $ret 0] ]
    }

#    puts "tt: $tt_wList $tt_startDay $tt_stopDay"

    set eddtt_x0 40
    set eddtt_dx 56
    set eddtt_y0 30
    set eddtt_dy  8
    set dx05 [expr $eddtt_dx/2]

    $eddo_tt create rectangle 0 0 470 223 -fill grey95 -outline grey95
    $eddo_tt create rectangle 1 1 470 223 -fill grey95 -outline grey25

    for {set i 0} { $i <8 } { incr i} {
	set x [ expr $eddtt_x0 +$eddtt_dx*$i]
	$eddo_tt create line $x 0 $x 221
	set x [ expr $eddtt_x0 +$dx05 +$eddtt_dx*$i]
	if { $i<7 } {
	    $eddo_tt create text $x 16 -anchor n -justify center -text [ format "%2d.%2d.%02d"  $day $mon [expr $year %100] ] 
	    $eddo_tt create text $x 3 -anchor n -justify center -text [lindex $wt [weekDayByDate $day $mon $year]]
	    set ret  [ calcDate $day $mon $year 1 ]
	    set day  [ lindex $ret 0]
	    set mon  [ lindex $ret 1]
	    set year [ lindex $ret 2]
	}
    }

    set fnt -b&h-lucidatypewriter-bold-r-*-*-14-*-*-*-*-*-*-*
    rButton $eddo_tt 4 3 38 15 TTweekBackB
    rButton $eddo_tt 4 16 38 28 TTweekForwB
    rButton $eddo_tt 434 3 469 15 TTdayBackB
    rButton $eddo_tt 434 16 469 28 TTdayForwB

    $eddo_tt create text 16 14 -text "   <<  " -anchor n -justify left -font  $fnt -tag TTweekBack
    $eddo_tt create text 448 14 -text "   >>  " -anchor n -justify left -font  $fnt -tag TTweekForw
    $eddo_tt create text 16 1 -text "   <  " -anchor n -justify left -font $fnt -tag TTdayBack
    $eddo_tt create text 448 1 -text "   >  " -anchor n -justify left -font $fnt -tag TTdayForw
    $eddo_tt bind TTweekBack  <ButtonPress> {changeTimeTable -7}
    $eddo_tt bind TTweekForw  <ButtonPress> {changeTimeTable 7}
    $eddo_tt bind TTdayBack   <ButtonPress> {changeTimeTable -1}
    $eddo_tt bind TTdayForw   <ButtonPress> {changeTimeTable 1}
    $eddo_tt bind TTweekBackB <ButtonPress> {changeTimeTable -7}
    $eddo_tt bind TTweekForwB <ButtonPress> {changeTimeTable 7}
    $eddo_tt bind TTdayBackB  <ButtonPress> {changeTimeTable -1}
    $eddo_tt bind TTdayForwB  <ButtonPress> {changeTimeTable 1}
    
    for { set i 0} { $i<=24} {incr i 2} {
	set y [ expr $eddtt_y0 + $eddtt_dy*$i]
	$eddo_tt create line 0  $y 470 $y
	set y [ expr $eddtt_y0 + $eddtt_dy+ $eddtt_dy*$i]
	$eddo_tt create line 40 $y 431 $y
	if { $i>0 } {
	    set y [ expr 30+$i*8 +2]
	    $eddo_tt create text 6 $y -text [format "%2d:00" $i] -anchor sw
	    $eddo_tt create text 434 $y -text [format "%2d:00" $i] -anchor sw
	}
    }
}

proc rButton { win x0 y0 x1 y1 tag} {


    set fc grey80
    set uc white
    set lc grey40
    $win create rectangle $x0 $y0 $x1 $y1 -fill $fc -outline $fc -tag $tag
    $win create line $x0 $y1 $x0 $y0 -fill $uc
    $win create line $x0 $y0 $x1 $y0 -fill $uc
    $win create line $x0 $y1 $x1 $y1  -fill $lc
    $win create line $x1 $y1 $x1 $y0 -fill $lc
    
    incr x0
    incr y0
    incr x1 -1
    incr y1 -1
    $win create line $x0 $y1 $x0 $y0 -fill $uc
    $win create line $x0 $y0 $x1 $y0 -fill $uc
    $win create line $x0 $y1 $x1 $y1  -fill $lc
    $win create line $x1 $y1 $x1 $y0 -fill $lc
}
proc changeTimeTable { step } {
    global eddv_day eddv_mon eddv_year eddo_tt_list
    set ret  [ calcDate $eddv_day $eddv_mon $eddv_year $step ]
    set eddv_day  [ lindex $ret 0]
    set eddv_mon  [ lindex $ret 1]
    set eddv_year [ lindex $ret 2]


    redrawEDDtimeTable
}

proc updateTTcurDate { val } {
    global waitTT
    if { $waitTT == 0 } { fillTimeTableCurDate}
}

proc updateTT { val } {
    global waitTT
    if { $waitTT == 0 } { fillTimeTable}
}

proc fillAll { } {
    global waitTT

    set waitTT 1
    fillTitel
    fillTimes
    fillRepeats
    fillReminder
    set waitTT 0
    fillTeiln
    fillRest
}

proc fillTimeTable { } {
    global edd_part
    global eddv_day eddv_mon eddv_year
    global eddtt_x0 eddtt_y0 eddtt_dx eddtt_dy eddo_tt eddo_tt_list
    global edd_teilnChange  edd_TTdateList
    global edd_startDy edd_startDm edd_startDd edd_startTh edd_startTm 
    global edd_stopDy edd_stopDm edd_stopDd edd_stopTh edd_stopTm 
    global edd_room
    global TTcacheTime TTcacheUser TTcache TTcacheCtime
    global tt_wList tt_startDay tt_stopDay
    global isLock

    if { [llength $eddo_tt_list] > 0}  {
	foreach tag $eddo_tt_list { $eddo_tt delete $tag}
	set eddo_tt_list ""
	update
    }

    if { $isLock ==0} { 
	doLock
	set selfLocked 1
    } else {
	set selfLocked 0
    }

    set updateCache 0
    if { [lindex $TTcacheTime 0] != $tt_startDay || [lindex $TTcacheTime 1] != $tt_stopDay } {
	set updateCache 1
	set TTcacheTime "$tt_startDay $tt_stopDay"
	set TTcacheCtime [ request lastChangeDate ]
	if { [string first $TTcacheCtime "ServerDown"] >=0 } {ServerDownDialog}
    }

    set tim [ request lastChangeDate ]
    if { [string first $tim "ServerDown"] >=0 } {ServerDownDialog}
    if { $TTcacheCtime < $tim} { 
	set updateCache 1 
    }    
    if { $updateCache == 1} { 
	set TTcacheUser "" 
    }

#Cache auffllen
    set uList ""
    set ustrList  ""
#    puts ""
    foreach part $edd_part {
	
	set ustr [format "%s-%s" [lindex $part 0] [lindex $part 1] ]
	if { [ lsearch $TTcacheUser $ustr] <0 } {
	    set str [format "%s {%s}" [lindex $part 6] [lindex $part 1]]
	    set uList "$uList $str"
	    lappend ustrList $ustr
	}
    }
    set ustr [format "r-%s" $edd_room ]
    if { [ lsearch $TTcacheUser $ustr] <0 } {
	set str [format "r {%s}" $edd_room]
	set uList "$uList $str"
	lappend ustrList $ustr
    }
#     puts "edd_part=$edd_part"
#     puts "ustrList=$ustrList"
#     puts "uList   =$uList"

    if { [llength  $uList] >1 } {
	set dates [request getBlockedTimes $tt_startDay $tt_stopDay $uList]
	if { [string first $dates "ServerDown"] >=0 } {ServerDownDialog}
    }
    for {set i 0 } { $i < [ llength $ustrList] } {incr i } {
	set ustr [lindex $ustrList $i ]
	lappend TTcacheUser $ustr
	set TTcache($ustr) [format "%s {%s}" [string range $ustr 0 0 ] [ lindex $dates $i ]]
	lappend edd_TTdateList $TTcache($ustr)
    }
    
#Cache auslesen
#    puts ""
#    puts "reading cache"
    set edd_TTdateList ""
    foreach part $edd_part {
	set ustr [format "%s-%s" [lindex $part 0] [lindex $part 1] ]
	lappend edd_TTdateList $TTcache($ustr)
    }
    set ustr [format "r-%s" $edd_room ]
    lappend edd_TTdateList $TTcache($ustr)
#    puts " => $edd_TTdateList"	


#TieTabel zeichenn    
    foreach val $edd_TTdateList {
	set type [lindex $val 0]
	set dates [lindex $val 1]
#	puts "$type: $dates"
	foreach date  $dates {
	    set startD [lindex $date 0]
	    set startT [lindex $date 1]
	    set stopD  [lindex $date 2]
	    set stopT  [lindex $date 3]

	    set day0 [ lsearch $tt_wList $startD]
	    set day1 [ lsearch $tt_wList $stopD]

	    if {$day0<0} {set day0 0}
	    if {$day1>6} {set day1 6}

#	    puts "    >  $type $startD $startT - $stopD $stopT   =   $day0 - $day1"
	    for {set day $day0} {$day<=$day1} {incr day} {
		if { [lindex $tt_wList $day] == $startD} {
		    set t0 $startT
		} else {
		    set t0 0
		}
		if { [lindex $tt_wList $day] == $stopD} {
		    set t1 $stopT
		} else {
		    set t1 2359
		}
		
		switch $type {
		    I {	drawDate2TT  $day $t0 $t1 red        0  f }
		    E {	drawDate2TT  $day $t0 $t1 DarkOrange 1  f }
		    T {	drawDate2TT  $day $t0 $t1 green4     2  f }
		    r {	drawDate2TT  $day $t0 $t1 brown      3  f }
		}
	    }
	}
    }
    for { set i 0} { $i<=24} {incr i 2} {
	set y [ expr $eddtt_y0 + $eddtt_dy*$i]
	$eddo_tt create line 40  $y 431 $y
	set y [ expr $eddtt_y0 + $eddtt_dy+ $eddtt_dy*$i]
	$eddo_tt create line 40 $y 431 $y
    }
    fillTimeTableCurDate
    if { $selfLocked ==1} { unLock }
}
proc fillTimeTableCurDate { } {
    global edd_part
    global eddtt_x0 eddtt_y0 eddtt_dx eddtt_dy eddo_tt eddo_tt_list
    global edd_startDy edd_startDm edd_startDd edd_startTh edd_startTm 
    global edd_stopDy edd_stopDm edd_stopDd edd_stopTh edd_stopTm 
    global tt_wList tt_startDay tt_stopDay

    $eddo_tt delete currDateTag

    set startD [format "%4d%02d%02d" $edd_startDy $edd_startDm $edd_startDd ]
    set stopD [format "%4d%02d%02d" $edd_stopDy $edd_stopDm $edd_stopDd ]
    if { $stopD > [lindex $tt_wList 0] } {
	if { $startD < [lindex $tt_wList 6] } {
	
	    if { $startD < [lindex $tt_wList 0] } {
		set day0 0
		set min0 0
	    } else {
		set day0 [ lsearch $tt_wList $startD]
		set min0 [ expr $edd_startTh*60+$edd_startTm ]
	    }
	    if { $stopD > [lindex $tt_wList 6] } {
		set day1 6
		set min1 1439
	    } else {
		set day1 [ lsearch $tt_wList $stopD]
		set min1 [ expr $edd_stopTh*60+$edd_stopTm ]
	    }
	    set x0 [expr $eddtt_x0 +$day0*$eddtt_dx +2]
	    set x1 [expr $eddtt_x0 +$day0*$eddtt_dx +$eddtt_dx -1 ]
	    set y0 [expr $eddtt_y0 + int(floor(double($min0)/60 * $eddtt_dy)) ]
	    set y1 [expr $eddtt_y0 + int(ceil(double($min1)/60 * $eddtt_dy)) ]
	    
	    box $eddo_tt $x0 $y0 $x1 $y1 yellow currDateTag
	}
    }
}
proc box { can x0 y0 x1 y1 color tag } {
    $can create line $x0 $y0 $x1 $y0 -fill $color -width 2 -tag $tag
    $can create line $x1 $y0 $x1 $y1 -fill $color -width 2 -tag $tag
    $can create line $x1 $y1 $x0 $y1 -fill $color -width 2 -tag $tag
    $can create line $x0 $y1 $x0 $y0 -fill $color -width 2 -tag $tag
}
proc drawDate2TT { day start stop color l stat } {
    global  eddtt_x0 eddtt_y0 eddtt_dx eddtt_dy eddo_tt eddo_tt_list
    
    set dx [expr $eddtt_dx -2 ]

    set t0 [ expr double($start)/100 + double($start%100)/60]
    set t1 [ expr double($stop) /100 + double($start%100)/60]

    set x0 [expr $eddtt_x0 +$day *$eddtt_dx +$l*$dx/4  +3]
    set x1 [expr $eddtt_x0 +$day *$eddtt_dx +($l+1)*$dx/4 ]
    set y0 [expr $eddtt_y0 + int(floor($t0 * $eddtt_dy)) ]
    set y1 [expr $eddtt_y0 + int(ceil($t1 * $eddtt_dy)) ]
    
    if { $stat == "f" } {
	$eddo_tt create rectangle $x0 $y0 $x1 $y1 -fill $color -outline $color -tag tt
    } else {
	box $eddo_tt $x0 $y0 $x1 $y1 $color tt
    }
    lappend eddo_tt_list tt
}

proc fillTimes { } {
    global eddo_startDy eddo_startDm eddo_startDd eddo_startTh eddo_startTm 
    global eddo_stopDy eddo_stopDm eddo_stopDd eddo_stopTh eddo_stopTm 
    global edd_startDy edd_startDm edd_startDd edd_startTh edd_startTm 
    global edd_stopDy edd_stopDm edd_stopDd edd_stopTh edd_stopTm 
    global curr_perms
    global eddo_room edd_room
    global eddo_noTime edd_noTime
    global eddo_nonBlock edd_nonBlock
    global edd_shiftCount edd_repEna


    if { $curr_perms(rz) == 1} {
	$eddo_startDd configure -state normal
	$eddo_startDm configure -state normal
	$eddo_startDy configure -state normal
	$eddo_startTh configure -state normal
	$eddo_startTm configure -state normal
	
	$eddo_stopDd configure -state normal
	$eddo_stopDm configure -state normal
	$eddo_stopDy configure -state normal
	$eddo_stopTh configure -state normal
	$eddo_stopTm configure -state normal

	$eddo_startDd configure -variable edd_startDd
	$eddo_startDm configure -variable edd_startDm
	$eddo_startDy configure -variable edd_startDy
	$eddo_startTh configure -variable edd_startTh
	$eddo_startTm configure -variable edd_startTm

 	$eddo_stopDd configure -variable edd_stopDd
	$eddo_stopDm configure -variable edd_stopDm
	$eddo_stopDy configure -variable edd_stopDy
	$eddo_stopTh configure -variable edd_stopTh
	$eddo_stopTm configure -variable edd_stopTm

	$eddo_room  configure -state normal
 	$eddo_room  configure -variable edd_room

	$eddo_noTime configure -state normal
	$eddo_noTime configure -variable edd_noTime
	$eddo_noTime configure -command toggleTimes
	$eddo_nonBlock configure -state normal
	$eddo_nonBlock configure -variable edd_nonBlock

    }
    if { $curr_perms(wz) == 0 } {
	$eddo_startDd configure -state disabled
	$eddo_startDm configure -state disabled
	$eddo_startDy configure -state disabled
	$eddo_startTh configure -state disabled
	$eddo_startTm configure -state disabled
	
	$eddo_stopDd configure -state disabled
	$eddo_stopDm configure -state disabled
	$eddo_stopDy configure -state disabled
	$eddo_stopTh configure -state disabled
	$eddo_stopTm configure -state disabled

	$eddo_room  configure -state disabled
	$eddo_noTime configure -state disabled
	$eddo_nonBlock configure -state disabled
    }

    puts " >>>> $edd_shiftCount  // $edd_repEna"
    if { $edd_shiftCount >0 && $edd_repEna == 1} {
	$eddo_startDd configure -state disabled
	$eddo_startDm configure -state disabled
	$eddo_startDy configure -state disabled
	$eddo_startTh configure -state disabled
	$eddo_startTm configure -state disabled
    }
    toggleTimes
} 
proc toggleTimes { } {
    global edd_noTime  eddo_startTh eddo_startTm eddo_stopTh eddo_stopTm
    global curr_perms edd_shiftCount edd_repEna 

    if { $edd_noTime == 1} {
	$eddo_startTh configure -state disabled
	$eddo_startTm configure -state disabled
	$eddo_stopTh configure -state disabled
	$eddo_stopTm configure -state disabled
    } else {
	if { $curr_perms(wz) == 1 } {
	    if {$edd_shiftCount >0 && $edd_repEna == 1} {
		$eddo_startTh configure -state disabled
		$eddo_startTm configure -state disabled
	    } else {
		$eddo_startTh configure -state normal
		$eddo_startTm configure -state normal
	    }
	    $eddo_stopTh configure -state normal
	    $eddo_stopTm configure -state normal
	}
    }
}
proc fillTitel {  } {
    global edd_titel eddo_titel edd_editTyp curr_perms
    global eddo_detail edd_detail
    
    if { $curr_perms(r) ==1} {
	$eddo_detail subwidget text configure -state normal
	$eddo_detail subwidget text delete 0.0 end
	$eddo_detail subwidget text insert end $edd_detail

	$eddo_titel configure -textvariable edd_titel
	$eddo_titel configure -state normal
	wm title .edd [format "%s : %s" $edd_editTyp $edd_titel ]
    } 
    if {  $curr_perms(w) ==0} {
	$eddo_titel configure -state disabled 
	$eddo_detail subwidget text configure -state disabled
    }
}

proc fillRepeats { } {
    global edd_repEna edd_repTyp edd_repIntervall edd_repInterTyp edd_repCount edd_repInf
    global eddo_repEna eddo_repTyp eddo_repInf eddo_repCount eddo_repInter eddo_repItyp
    global eddo_repL1 eddo_repL2 eddo_repL3
    global bfnt fnt pbfnt pfnt fnt12 bfnt12  curr_perms
    global edd_shiftCount

    if { $curr_perms(rz) == 1} {
	$eddo_repEna configure -state normal
	$eddo_repTyp configure -state normal
	$eddo_repInf configure -state normal
	$eddo_repCount configure -state normal
	$eddo_repInter configure -state normal
	$eddo_repItyp  configure -state normal

	$eddo_repEna configure -variable edd_repEna
	$eddo_repTyp configure -variable edd_repTyp
	$eddo_repInf configure -variable edd_repInf
	$eddo_repCount configure -variable edd_repCount
	$eddo_repInter configure -variable edd_repIntervall
	$eddo_repItyp  configure -variable edd_repInterTyp

	$eddo_repEna configure -state disabled
	$eddo_repTyp configure -state disabled
	$eddo_repInf configure -state disabled
	$eddo_repCount configure -state disabled
	$eddo_repInter configure -state disabled
	$eddo_repItyp  configure -state disabled
    }
    if { $curr_perms(wz) == 1} {
	if { $edd_shiftCount == 0} {
	    $eddo_repEna configure -state normal
	} else {
	    $eddo_repEna configure -state disabled
	}
    }
    toggleRepeat 
}

proc fillReminder { } {
    global edd_reminder eddo_reminder
    global fnt bfnt fnt12 bfnt12 pfnt12 pbfnt
    global eddv_remVal eddv_remUnit eddv_remWeg eddv_remZiel
    global curr_perms edd_groupsOfUser groupList username
    global curr_perms

    set y 15
    set dy 16
    set can [$eddo_reminder subwidget canvas]
    $can delete all
    set c 0
    set rn 0
    foreach reminder $edd_reminder {
#	puts $reminder
	set off  [lindex $reminder 0]
	set unit [lindex $reminder 1]
	set weg  [lindex $reminder 2]
	set user [lindex $reminder 3]
	set ziel [lindex $reminder 4]
	set als  [lindex $reminder 5]
	
	set prm 0
	if { $curr_perms(rt)==1 && $curr_perms(rz)==1} {
	    set prm 1
	} else {
	    if { $user == "alle" } {
		set prm 2
	    } else {
		if { [lsearch $groupList $user] < 0 } {
		    if {$user == $username } {
			set prm 3
		    } 
		} else {
		    if { [lsearch $edd_groupsOfUser $user] >=0 } {
			set prm 4
		    } 
		}
	    }
	}

	if { $prm > 0} {
	    if { $als == "E" } {
		set tstr "Einladung"
	    } else {
		set tstr "Erinnerung"
	    }
	    $can create text 2 $y -text [format "%5.2f %7s vorher via %7s an %-21s (%10s)"\
					     $off $unit $weg [nameStrTrunc $ziel 21] $tstr] \
		-font $pfnt12 -justify left -anchor sw
	    if { $user == $username  || ($curr_perms(wt) == 1 && $curr_perms(wz)==1)} {
		$can create text 492 [expr $y-0]  -text "X" -anchor sw -tag del -font $pbfnt -fill red 
	    }
	    $can create line 0 $y 520 $y -fill grey98

	    incr c
	    incr y $dy
	    incr rn
	}
    }
    $eddo_reminder adjustscrollregion
    $can bind del <Button> { removeReminder %y}
}

proc removeReminder { y } {
    global edd_reminder eddo_reminder 

    set h [expr 16 * [llength $edd_reminder]]
    set f [lindex [$eddo_reminder subwidget vsb get] 0]
    set yk [ expr int(floor($f*$h)) +$y]
    set nr [expr int(floor($yk /16))]
    set edd_reminder [lreplace $edd_reminder $nr $nr ]
    fillReminder
    $eddo_reminder adjustscrollregion
}

proc fillRest {  } {
    global eddo_comm edd_comm   eddo_commb
    global curr_perms edd_cmd


#    puts "Kommentar $curr_perms(rk) $curr_perms(wk)"
    if { $curr_perms(rk) ==1} {
	$eddo_comm   subwidget text configure -state normal
	$eddo_comm   subwidget text delete 0.0 end
	$eddo_comm   subwidget text insert end $edd_comm
    }
#FIXME Auch bei neuen Terminen Kommentare einfgen 
    if { $curr_perms(wk) == 0 || $edd_cmd == "addDate" } { 
	$eddo_commb  configure -state disabled
    } else {
	$eddo_commb  configure -state normal
    }
    
    
}
proc addCommDialog { } {
    global bfnt fnt eddo_newComm

    toplevel .ac
    frame .ac.t -relief flat -bd 1
    frame .ac.b 
    pack  .ac.t .ac.b -side top -fill x

    frame .ac.t.1
    frame .ac.t.2
    pack  .ac.t.1 .ac.t.2 -side top -fill x

    label .ac.t.1.l -text "Kommentar" -font $bfnt
    pack .ac.t.1.l -side left
    set new_comm ""

    set eddo_newComm .ac.t.2.e
    tixScrolledText .ac.t.2.e  -width 280 -height 100
    pack .ac.t.2.e  -side left
    .ac.t.2.e subwidget vsb configure -width 12
    .ac.t.2.e subwidget hsb configure -width 12

    button .ac.b.can -text " Abbruch " -command {closeWin .ac}
    button .ac.b.add -text " Hinzufgen " -command {addComm }
    pack .ac.b.can  -side left
    pack .ac.b.add  -side right

    wm title .ac "Kommentar hinzufgen"
    centerWin .ac 284 148
    grab .ac
}
proc addComm { } {
    global  username edd_comm edd_did  eddo_newComm

    set list [ $eddo_newComm subwidget text dump -text 0.0 end]
    set new_comm ""
    set l [llength $list]
    for { set i 1} {$i < $l } {incr i 3 } {
	set new_comm [format "%s%s" $new_comm [ lindex $list $i] ]
    }
    set new_comm [string trim $new_comm]
#    set new_comm "$new_comm\""

#    puts $new_comm
    set ret [transfer addComm $edd_did $username $new_comm]
    if { [string first  "ServerDown" $ret] >=0 } {ServerDownDialog}
#    puts [format "$ret -> %s" [string first $ret "ServerDown"]]

    set edd_comm [ request updateComm $edd_did]
    if { [string first "ServerDown" $edd_comm] >=0 } {ServerDownDialog}
    closeWin .ac
    fillRest
}
proc fillTeiln {  } {
    global edd_init  edd_part eddo_teilnehmer edd_part_quick edd_teil_dy
    global partStatus partStatusStr edd_currUser
    global eddo_addEinl eddo_addTeiln eddo_addInfo eddo_prvTeilnLines edd_groupsOfUser
    global eddo_priv eddo_gpri edd_priv edd_gpri 
    global username edd_currUserPerm eddo_teilTitel
    global curr_perms fnt12 bfnt12 pfnt12 pbfnt12
    global eddv_part   eddo_prior edd_priority edd_group eddo_group
    
    $eddo_teilnehmer subwidget canvas delete all
#    $eddo_teilnehmer subwidget canvas create rectangle 0 0 464 220 -fill grey95 -outline grey95
    
    for { set i 0} { $i < $eddo_prvTeilnLines} {incr i} { 
	$eddo_teilnehmer subwidget canvas bind perm$i <ButtonPress> {} 
	$eddo_teilnehmer subwidget canvas bind stat$i <ButtonPress> {} 
	$eddo_teilnehmer subwidget canvas bind del$i <ButtonPress> {}
	$eddo_teilnehmer subwidget canvas bind art$i <ButtonPress> {} 
    }

    set y 3
    set dy 15
    set edd_teil_dy $dy

    set edd_part_quick ""
    set own_glist ""
    set c 0
    set eddv_part ""
    set eddt_tmp_part ""

    foreach val $edd_part {
	set type  [ lindex $val 0]
	set name  [ lindex $val 1]
	set stat  [ lindex $val 2]
	set flags [ lindex $val 3]
	set uperm [ lindex $val 4]
	set fulln [ lindex $val 5]
	set ugType [ lindex $val 6]
	
	if { $ugType =="g" } {
	    if { [lsearch $edd_groupsOfUser $name] >0 } {
		lappend own_glist $c 
	    }
	}
	    
	lappend edd_part_quick $name
	if { $curr_perms(rt)   ==1 || $edd_currUser == $name} {

	    lappend eddv_part $val
	    lappend eddt_tmp_part  $name

#	    puts "$val -> /$type/$name/$stat/$flags/$uperm"
	    $eddo_teilnehmer subwidget canvas create oval 2 [expr $y -1] 15 [expr $y+$dy -2 ] -fill white -outline grey80
	    set y2 [expr $y +2]
	    switch $type {
		I {	$eddo_teilnehmer subwidget canvas create text 8 $y2 -text " I " -anchor n -justify center -fill red -font $pbfnt12}
		E {	$eddo_teilnehmer subwidget canvas create text 9 $y2 -text " E " -anchor n -justify center -fill DarkOrange -font $pbfnt12}
		T {	$eddo_teilnehmer subwidget canvas create text 8 $y2 -text " T " -anchor n -justify center -fill green4 -font $pbfnt12}
		A {	$eddo_teilnehmer subwidget canvas create text 8 $y2 -text " A " -anchor n -justify center -fill blue2 -font $pbfnt12} 
		i {	$eddo_teilnehmer subwidget canvas create text 8 $y2 -text " i " -anchor n -justify center -fill black -font $pbfnt12} 
		* {	$eddo_teilnehmer subwidget canvas create text 8 $y2 -text " T " -anchor n -justify center -fill green3 -font $pbfnt12} 
	    }
	    $eddo_teilnehmer subwidget canvas addtag art$c closest 8 [expr $y+4] 
	    
	    $eddo_teilnehmer subwidget canvas create text 24 $y -text [nameStrTrunc $fulln 30]  -anchor nw -tag name$c -font $pfnt12
	    set id [lsearch $partStatus $stat ]
	    if { $id <=0} { set id 0 }
	    $eddo_teilnehmer subwidget canvas create text 240 $y -text [ lindex $partStatusStr $id] -anchor nw -tag stat$c -font $pfnt12
	    
	    set admin 0
	    if { $name == $username } {
		if { $edd_currUserPerm != $uperm } {
		    set admin 1
		}
	    }
	    if { $admin == 0} {
		set str [format "r=%4s w=%-5s" [string range $uperm 0 3] [string range $uperm 4 8] ]
		$eddo_teilnehmer subwidget canvas create text 326 $y -text $str -anchor nw -tag perm$c -font $pfnt12
	    } else {
		set str [format "r=%4s w=%-5s" [string range $edd_currUserPerm 0 3] [string range $edd_currUserPerm 4 8] ]
		$eddo_teilnehmer subwidget canvas create text 326 $y -text $str -anchor nw -tag perm$c \
		    -font $pfnt12 -fill IndianRed4
#		puts stdout ">> $edd_currUserPerm -> /$str/"
		regsub -all -- - $uperm " " p2
		set str [format "r=%4s w=%-5s" [string range $p2 0 3] [string range $p2 4 8] ]
#		puts stdout ">> $uperm -> $p2  -> /$str/"
		$eddo_teilnehmer subwidget canvas create text 326 $y -text $str -anchor nw -tag perm$c\
		    -font $pfnt12
	    }
	    if { $name != $edd_init && $curr_perms(wt) ==1} {
		$eddo_teilnehmer subwidget canvas create text 432 [expr $y -2 ] -text ">>" -anchor nw -tag del$c -font -b&h-lucidatypewriter-bold-r-*-*-14-*-*-*-*-*-*-* -fill red
	    }
	    
	    incr c
	    incr y $dy
	    set y1 [expr $y-2]
	    $eddo_teilnehmer subwidget canvas create line 0 $y1 448 $y1 -fill grey75
	}
    }
    
    if { $c == 0} {
	$eddo_teilTitel.1 configure -foreground grey60
	$eddo_teilTitel.2 configure -foreground grey60
	$eddo_teilTitel.3 configure -foreground grey60
	$eddo_teilTitel.4 configure -foreground grey60
    } else {
	$eddo_teilTitel.1 configure -foreground black
	$eddo_teilTitel.2 configure -foreground black
	$eddo_teilTitel.3 configure -foreground black
	$eddo_teilTitel.4 configure -foreground black
    }

    if { $curr_perms(wt) ==1} {
	for { set i 0} { $i < $c} {incr i} { 
	    $eddo_teilnehmer subwidget canvas bind perm$i <ButtonPress> {changePermDialog  %y %X %Y} 
	    $eddo_teilnehmer subwidget canvas bind stat$i <ButtonPress> {changeStatusDialog %x %y %X %Y} 
	    if { $name != $edd_init} {
		$eddo_teilnehmer subwidget canvas bind del$i <ButtonPress> {removeTeilnehmer %y}
	    }
	    $eddo_teilnehmer subwidget canvas bind art$i <ButtonPress> {changeTypeDialog %y %X %Y} 
	}
	$eddo_addEinl  configure -state normal
	$eddo_addTeiln configure -state normal
	$eddo_addInfo  configure -state normal
	
    } else {
	set i [ lsearch $eddt_tmp_part $edd_currUser ]
#	puts "FT: currUser='$edd_currUser' is #$i"
	if { $i >= 0} {
	    $eddo_teilnehmer subwidget canvas bind stat$i <ButtonPress> {changeStatusDialog  %x %y %X %Y}
	    if { $edd_currUser == $edd_init} {
		$eddo_teilnehmer subwidget canvas bind perm$i <ButtonPress> {changePermDialog  %y %X %Y} 
	    }
	}
	foreach i $own_glist {
	    $eddo_teilnehmer subwidget canvas bind stat$i <ButtonPress> {changeStatusDialog  %x %y %X %Y}
	}
	
	
	$eddo_addEinl  configure -state disabled
	$eddo_addTeiln configure -state disabled
	$eddo_addInfo  configure -state disabled
    }
    set eddo_prvTeilnLines $c    


    #    if { $curr_perms(rt)   ==1 || $edd_currUser == $name} { }
    if { $curr_perms(rt)   ==1 } {
	$eddo_priv  configure -state normal
	$eddo_gpri  configure -state normal
	$eddo_group configure -state normal
	$eddo_prior configure -state normal
	$eddo_group configure -variable edd_group
	$eddo_priv  configure -variable edd_priv
	$eddo_gpri  configure -variable edd_gpri
	$eddo_prior configure -variable edd_priority
    }
    #    if { $curr_perms(wt)   ==1 || $edd_currUser == $name} {}
    if { $curr_perms(wt)   ==0} {
	$eddo_group configure -state disabled
	$eddo_priv  configure -state disabled
	$eddo_gpri  configure -state disabled
	$eddo_prior configure -state disabled
    }
    $eddo_teilnehmer adjustscrollregion
    fillTimeTable
}

proc removeTeilnehmer { y } { 
    global edd_teil_dy  edd_part edd_currUserPerm edd_teilnChange eddo_teilnehmer

    set h [expr 16 * [llength $edd_part]]
    set f [lindex [$eddo_teilnehmer subwidget vsb get] 0]
    set yk [ expr int(floor($f*$h)) +$y]

    set id [expr int(floor($yk/$edd_teil_dy) ) ]
    set edd_part [lreplace $edd_part $id $id  ]
    fillTeiln 
    set edd_teilnChange 1
}

proc changeTypeDialog { y gx gy } {
    global edd_part edd_teil_dy edd_current_ent eddo_teilnehmer eddv_part

    

    set id [expr int(floor($y/$edd_teil_dy) ) ]
    set edd_current_ent [ lindex $eddv_part $id]
    set oldType [lindex $edd_current_ent 0]
    if { $oldType == "E" || $oldType == "T"|| $oldType == "i" } {
	toplevel .ctd
	button .ctd.einl -text "Einladener" -command {setType E}
	button .ctd.teil -text "Teilnehmer" -command {setType T}
	button .ctd.info -text "Information" -command {setType i}
	button .ctd.abbr -text "Abbruch" -command {closeWin .ctd }
	pack .ctd.einl .ctd.teil .ctd.info .ctd.abbr  -side top -fill x
	wm geometry .ctd  +$gx+$gy
	update
	grab .ctd
    }
}

proc setType { type } {
    global edd_part  edd_current_ent eddo_teilnehmer edd_currUserPerm
    set id [ lsearch $edd_part $edd_current_ent]
    set ent [lreplace $edd_current_ent 0 0 $type ]
    set edd_part [lreplace $edd_part $id $id $ent]
    closeWin .ctd
    fillTeiln 
    closeWin .ctd
}
proc changeStatusDialog { x y gx gy } {
    global edd_part edd_teil_dy edd_current_ent eddo_teilnehmer eddv_part

#    puts "changeTypeDialog"
#FIXME gekrzte Listen


    set id [expr int(floor($y/$edd_teil_dy) ) ]
    set edd_current_ent [lindex $eddv_part $id]
    set oldType [lindex $edd_current_ent 0]
    toplevel .csd
    button .csd.unk -text "unbekannt" -command {setStatus UKN}
    button .csd.ok  -text " O.K." -command {setStatus OK}
    button .csd.opn -text " unsicher." -command {setStatus OPEN}
    button .csd.no  -text "abgesagt" -command {setStatus NO}
    button .csd.psh  -text "verschieben" -command {setStatus PUSH}
    button .csd.ign  -text "ignorieren" -command {setStatus IGNO}
    button .csd.abb -text "Abbruch" -command {closeWin .csd }
    pack .csd.ok .csd.opn .csd.no .csd.unk .csd.psh .csd.ign .csd.abb  -side top -fill x
    wm geometry .csd  +$gx+$gy
    #	wm title .cpd [format "ndere Rechte fr %s" [ lindex edd_current_ent 1 ]]
    update
    grab .csd
}

proc setStatus { stat } {
    global edd_part  edd_current_ent eddo_teilnehmer edd_currUserPerm eddv_part
#    puts "cur=$edd_current_ent"
    set id [ lsearch $edd_part $edd_current_ent]
    set ent [lreplace $edd_current_ent 2 2 $stat ]
    set edd_part [lreplace $edd_part $id $id $ent]
#    puts "$stat, $id -> part : $edd_part"
    closeWin .csd
    fillTeiln 
}

proc changePermDialog { y gx gy} {
    global edd_part edd_teil_dy edd_current_ent eddv_part
    global edd_cb_rz edd_cb_ru edd_cb_rt edd_cb_rk
    global edd_cb_wz edd_cb_wu edd_cb_wt edd_cb_wk edd_cb_d
    
    set id [expr int(floor($y/$edd_teil_dy) ) ]
    set edd_current_ent [ lindex $eddv_part $id]
    set perm  [lindex $edd_current_ent 4] 

#    puts $perm
    if { [ string range  $perm 0 0]  != "-"} { set edd_cb_rz 1} else { set edd_cb_rz 0}
    if { [ string range  $perm 1 1]  != "-"} { set edd_cb_ru 1} else { set edd_cb_ru 0}
    if { [ string range  $perm 2 2]  != "-"} { set edd_cb_rt 1} else { set edd_cb_rt 0}
    if { [ string range  $perm 3 3]  != "-"} { set edd_cb_rk 1} else { set edd_cb_rk 0}
    if { [ string range  $perm 4 4]  != "-"} { set edd_cb_wz 1} else { set edd_cb_wz 0}
    if { [ string range  $perm 5 5]  != "-"} { set edd_cb_wu 1} else { set edd_cb_wu 0}
    if { [ string range  $perm 6 6]  != "-"} { set edd_cb_wt 1} else { set edd_cb_wt 0}
    if { [ string range  $perm 7 7]  != "-"} { set edd_cb_wk 1} else { set edd_cb_wk 0}
    if { [ string range  $perm 8 8]  != "-"} { set edd_cb_d  1} else { set edd_cb_d  0}

    toplevel .cpd 
    frame .cpd.v -relief raised -bd 1
    frame .cpd.b -relief flat
    pack .cpd.v .cpd.b  -side top

    frame .cpd.v.0
    frame .cpd.v.1
    frame .cpd.v.2
    frame .cpd.v.3
    frame .cpd.v.4
    frame .cpd.v.5
    pack .cpd.v.0 .cpd.v.1 .cpd.v.2 .cpd.v.3 .cpd.v.4 .cpd.v.5 -side top -fill x

    label .cpd.v.0.l -text "Lesen    ndern"
    pack .cpd.v.0.l -side right

    label .cpd.v.1.l -text "Zeiten & Zeiten"
    label .cpd.v.2.l -text "berschrift"
    label .cpd.v.3.l -text "Teilnehmer"
    label .cpd.v.4.l -text "Kommentar "
    label .cpd.v.5.l -text "Termin lschen"

    pack .cpd.v.1.l .cpd.v.2.l .cpd.v.3.l .cpd.v.4.l .cpd.v.5.l -side left

    checkbutton .cpd.v.1.r -variable edd_cb_rz
    checkbutton .cpd.v.2.r -variable edd_cb_ru
    checkbutton .cpd.v.3.r -variable edd_cb_rt
    checkbutton .cpd.v.4.r -variable edd_cb_rk
    checkbutton .cpd.v.1.w -variable edd_cb_wz
    checkbutton .cpd.v.2.w -variable edd_cb_wu
    checkbutton .cpd.v.3.w -variable edd_cb_wt
    checkbutton .cpd.v.4.w -variable edd_cb_wk
    checkbutton .cpd.v.5.d -variable edd_cb_d
    label .cpd.v.1.s -text "       "
    label .cpd.v.2.s -text "       "
    label .cpd.v.3.s -text "       "
    label .cpd.v.4.s -text "       "
    pack .cpd.v.1.w .cpd.v.2.w .cpd.v.3.w .cpd.v.4.w -side right
    pack .cpd.v.1.s .cpd.v.2.s .cpd.v.3.s .cpd.v.4.s -side right
    pack .cpd.v.1.r .cpd.v.2.r .cpd.v.3.r .cpd.v.4.r -side right
    pack .cpd.v.5.d  -side top
   
    button .cpd.b.abb -text " Abbruch " -command {closeWin .cpd}
    button .cpd.b.ok  -text " Rechte ndern " -command {changePerm}
    pack .cpd.b.abb -side left
    pack .cpd.b.ok -side right
    wm geometry .cpd +$gx+$gy
    wm title .cpd [format "ndere Rechte fr %s" [ lindex edd_current_ent 1 ]]
    update
    grab .cpd
}
proc changePerm { } {
    global edd_part edd_current_ent edd_currUserPerm edd_currUser
    global edd_cb_rz edd_cb_ru edd_cb_rt edd_cb_rk
    global edd_cb_wz edd_cb_wu edd_cb_wt edd_cb_wk edd_cb_d
    
    set id [ lsearch $edd_part $edd_current_ent]
    set prm [ rlist2str "$edd_cb_rz $edd_cb_ru $edd_cb_rt $edd_cb_rk $edd_cb_wz $edd_cb_wu $edd_cb_wt $edd_cb_wk $edd_cb_d"]
    set ent [lreplace $edd_current_ent 4 4 $prm]
    set edd_part [lreplace $edd_part $id $id $ent]
    
    closeWin .cpd
    if { [lindex $edd_current_ent 1] == $edd_currUser } {
	set edd_currUserPerm  $prm 
	set perm  [perm2rw $edd_currUserPerm ]
	fillTimes 
	fillTitel 
	fillTeiln 
	fillRest  
    } else {
	fillTeiln 
    }
}

proc cancleDate { } {
    global edd_cmd edd_did

    if { $edd_cmd == "modifyDate" } {
	set ret [request cancelEditDate $edd_did]
	if { [string first $ret "ServerDown"] >=0 } {ServerDownDialog}
    }
}
proc sendDate { } {
    global edd_init  edd_part edd_titel edd_detail edd_comm edd_currUserPerm
    global edd_startDy edd_startDm edd_startDd edd_startTh edd_startTm 
    global edd_stopDy edd_stopDm edd_stopDd edd_stopTh edd_stopTm 
    global edd_noTime edd_nonBlock
    global edd_room edd_igni edd_priv edd_gpri edd_group
    global userList groupList roomList
    global edd_currUser edd_editTyp edd_groupsOfUser
    global edd_cmd username edd_did
    global eddo_comm eddo_detail edd_priority
    global ewList eddLock
    global edd_repEna edd_repTyp edd_repIntervall edd_repInterTyp edd_repCount edd_repInf
    global edd_reminder eddv_repTyp eddv_repUnit 


    set commList [$eddo_comm   subwidget text dump -text 0.0 end ]
    set l [llength $commList]
    set edd_comm ""
    for { set i 1} {$i < $l } {incr i 3 } {
	set edd_comm [format "%s%s" $edd_comm [ lindex $commList $i] ]
    }
    set edd_comm [string trim $edd_comm]
    set commList [$eddo_detail   subwidget text dump -text 0.0 end ]
    set l [llength $commList]
    set edd_detail ""
    for { set i 1} {$i < $l } {incr i 3 } {
	set edd_detail [format "%s%s" $edd_detail  [ lindex $commList $i] ]
    }
    set edd_detail [string trim $edd_detail]


    set eList ""
    set tList ""
    set aList ""
    set iList ""
    foreach val $edd_part {
	set type  [ lindex $val 0]
	set name  [ lindex $val 1]
	set stat  [ lindex $val 2]
	set flags [ lindex $val 3]
	set uperm [ lindex $val 4]
	set ugType [ lindex $val 6]
	
	set ent [format "{%s} %d %d %d %d %s"  $name \
		     [ statusVal $stat] [flagVal $flags] [permVal $uperm] [isGroup $ugType] $type]
	lappend tList $ent
    }	

    set startD [format "%4d%02d%02d" $edd_startDy $edd_startDm $edd_startDd]
    set startT [format "%2d%02d"  $edd_startTh $edd_startTm]
    set stopD [format "%4d%02d%02d"   $edd_stopDy $edd_stopDm $edd_stopDd]
    set stopT [format "%2d%02d"  $edd_stopTh $edd_stopTm ]

    if { $edd_repInf == 1 } { set edd_repCount 0 }
    set repTyp [lsearch $eddv_repTyp $edd_repTyp]
    if {$edd_repEna == 0 }  { set repTyp 0 }
    set repUnit [lsearch $eddv_repUnit $edd_repInterTyp]

    set ret [transfer $edd_cmd $edd_did $username $edd_init $tList $startD $startT $stopD $stopT  $edd_titel $edd_detail $edd_room $edd_group $edd_priv $edd_gpri $repTyp $edd_repCount $edd_repIntervall $repUnit $edd_priority $edd_reminder $edd_noTime $edd_nonBlock]
    if { [string first $ret "ServerDown"] >=0 } {ServerDownDialog}
    if { [string range $ret 0 2] == "ERR" } {
	ErrorDialog $ret
    }
    closeWin .edd
    drawUsersCalendar
    if { $edd_cmd == "modifyDate" } {
	if { [string range $ret 0 3] == "WARN" } {
	    set ewList [ lrange $ret 3 end ]
	    modifyIncompleteDialog 
	}
    }
    set eddLock 0
}

proc statusVal { str } {
    global partStatus
    return [ lsearch $partStatus $str]
}
proc flagVal { str } {
    if { $str == "-" } {
	return 0
    }
    return 0
}
proc val2flag { val } {
    return "-"
}
proc permVal { str } {
    
    set ref "ztkztkd"
    set sum 0
    set w 1
    for { set i 0 } {$i <9 } {incr i} {
	set j [expr $i +4]
	if { [ string range $str $i $i ] == [ string range $ref $i $i ] } { incr sum $w }
	set w [ expr $w *2]
    }
    return [expr $sum]
}

proc val2perm { val } {
    set perm ""
    if { [ expr $val & 256 ] > 0 } { set perm "d$perm"} else { set perm "-$perm"}
    if { [ expr $val & 128 ] > 0 } { set perm "k$perm"} else { set perm "-$perm"}
    if { [ expr $val &  64 ] > 0 } { set perm "t$perm"} else { set perm "-$perm"}
    if { [ expr $val &  32 ] > 0 } { set perm "$perm"} else { set perm "-$perm"}
    if { [ expr $val &  16 ] > 0 } { set perm "z$perm"} else { set perm "-$perm"}
    if { [ expr $val &   8 ] > 0 } { set perm "k$perm"} else { set perm "-$perm"}
    if { [ expr $val &   4 ] > 0 } { set perm "t$perm"} else { set perm "-$perm"}
    if { [ expr $val &   2 ] > 0 } { set perm "$perm"} else { set perm "-$perm"}
    if { [ expr $val &   1 ] > 0 } { set perm "z$perm"} else { set perm "-$perm"}
#    puts "PERM: $val -> $perm"
    return $perm
} 
proc isGroup { str } {
    if { $str == "g" } {
	return 1
    }
    if { $str == "a" } {
	return 2
    }
    return 0
}

proc modifyIncompleteDialog {  } {
    global fnt bfnt edd_did
    
    toplevel .ew
    frame .ew.t -relief raised -bd 2
    frame .ew.b 
    pack .ew.t .ew.b -side top -fill x
    
    label .ew.t.l -text "Achtung"  -anchor n  -justify center -font $bfnt
    message .ew.t.m -width 380 -text "Ein anderer Benutzer hat zwischenzeitlich den termin gendert. Es wurden nur nderungen angenommen, die unabhnigig sind." -font $fnt
    pack .ew.t.l .ew.t.m -side top -fill x

    button .ew.b.hlp -text "  Erklrung  " -command modifyErkl
    button .ew.b.det -text "   Details   " -command modifyIncompleteDetails
    button .ew.b.edi -text " Wiederholen " -command {
	destroy .ew 
	editDate $edd_did}
    button .ew.b.clo -text "    O.K.     " -command {closeWin .ew}
    pack .ew.b.hlp .ew.b.det -side left 
    pack .ew.b.clo .ew.b.edi -side right
    
    grab .ew
    centerWin .ew 400 112
}

proc modifyIncompleteDetails { } {
    global fnt bfnt fnt10 ewList

    toplevel .ewd
    frame .ewd.t -relief raised -bd 2
    frame .ewd.b 
    pack .ewd.t .ewd.b  -side top -fill x


    label .ewd.t.l -text "nderungen im Detail"  -anchor n  -justify center -font $bfnt
    frame .ewd.t.u 
    pack .ewd.t.l  .ewd.t.u -side top -fill x

    frame .ewd.t.u.l
    frame .ewd.t.u.r
    pack .ewd.t.u.l .ewd.t.u.r -side left -fill x

    label .ewd.t.u.l.l -text "Angenommene nderungen" -font $fnt
    tixScrolledText .ewd.t.u.l.t -width 200 -height 150
    pack .ewd.t.u.l.l .ewd.t.u.l.t -side top
    .ewd.t.u.l.t   subwidget text configure -font  $fnt10

#    puts stdout "l>> $ewList <<"
    
    set list [lindex $ewList 0]
    set str [ join $list '\n' ]
    .ewd.t.u.l.t   subwidget text insert end $str
#    puts "d>>> $list"

    label .ewd.t.u.r.l -text "Abgelehnete nderungen" -font $fnt
    tixScrolledText .ewd.t.u.r.t -width 200 -height 150
    pack .ewd.t.u.r.l .ewd.t.u.r.t -side top
    .ewd.t.u.r.t   subwidget text configure -font  $fnt10

    set list [lindex $ewList 1]
    set str [ join $list '\n' ]
    .ewd.t.u.r.t   subwidget text insert end $str
 #   puts "R>>> $list"
    
 

    button .ewd.b.c -text "  O.K.  " -command {destroy .ewd}
    pack .ewd.b.c -side right

    grab .ewd

    centerWin .ewd 408 222
}

proc modifyErkl { } {
    global progname
    global fnt bfnt

    toplevel .ewh
    
    frame .ewh.t -relief raised -bd 2
    frame .ewh.b 
    pack .ewh.t .ewh.b -side top -fill x
    
    label .ewh.t.l -text "Erklrung"  -anchor n  -justify center -font $bfnt
    message .ewh.t.m -width 280 -text "
  Wenn zwei Nutzer gleichzeitig einen Termin 
bearbeiten,kann es passieren, dass sie dieselbe 
Eigenschaft eines Termins in unterschiedlicher-
weise ndern.In diesem Fall bernimmt $progname 
alle nderungen desjenigen Nutzers der zuerst 
den Dialog beendet hat. 
  Alle Nutzer, die davor mit dem Bearbeiten 
begonnen haben, aber ihre nderungen erst 
dannach abschicken, werden anders behandelt.
Bei ihnen werden nur nderungen von solchen 
Eigenschaften des fraglichen Termins 
bernommen, die nicht schon von dem ersten 
Nutzer verndert wurden. 
  Sie werden aber mit einem Dialog auf diese 
Tatsache hingewiesen. Welche Eigenschaften 
gendert wurden und welchenicht, kann mit dem 
Knopf 'Details' abgefragt werden.
  Wird ader nderungsdialog gestartet nachdem 
der erste Nutzer seinen nderungen abgeschickt 
hat, so ist dieser Vorgang vollkommen unabhnig 
davon.
"

    pack .ewh.t.l .ewh.t.m -side top -fill x -padx 4 -pady 4


    button .ewh.b.clo -text "    O.K.     " -command {closeWin .ewh}
    pack .ewh.b.clo  -side right
    
    centerWin .ewh 306 400
    grab .ewh
#    update
#    puts [wm geometry .ewh]
}

proc newDate {user startD startT } {
    invite $user - - $startD $startT
}
proc invite { user who wig startD startT } {
    global edd_init  edd_part edd_titel edd_detail edd_comm edd_currUserPerm
    global edd_startDy edd_startDm edd_startDd edd_startTh edd_startTm 
    global edd_stopDy edd_stopDm edd_stopDd edd_stopTh edd_stopTm 
    global edd_noTime edd_nonBlock
    global edd_room edd_igni edd_priv edd_gpri edd_group
    global userList groupList roomList edd_priority
    global edd_currUser edd_editTyp edd_groupsOfUser
    global eddv_day eddv_mon eddv_year
    global edd_cmd eddo_addButtonTitel edd_teilnChange
    global edd_did eddo_ok eddo_abb 
    global edd_repEna edd_repTyp edd_repIntervall edd_repInterTyp edd_repCount edd_repInf
    global edd_reminder
    global fullUsername curr_perms
    global waitTT eddo_tt_list
    global TTcacheTime TTcacheUser TTcache TTcacheCtime
    global edd_shiftCount

    

    doLock
    set edd_did -1
    set edd_teilnChange 1
    set edd_cmd "addDate"
    getLists
    set edd_groupsOfUser [request groupListByUser $user]
    if { [string first $edd_groupsOfUser "ServerDown"] >=0 } {ServerDownDialog}

    set edd_currUserPerm "ztkztkd"
    set edd_init $user
    set edd_currUser $user 
    if { $who == "-" } {
	set edd_part "{I $user UKN - ztkztkd {$fullUsername} u}" 
    } else {
	#FIXME
	set full [getFullUserName $who $wig ]
	set edd_part "{I $user UKN - ztkztkd {$fullUsername} u} {T $who UKN - ztkztkd {$full} $wig}" 
    }
    set edd_startDy [expr $startD /10000 ]
    set edd_startDm [expr ($startD /100) % 100 ]
    set edd_startDd [expr $startD %100 ]

    set edd_stopDy [expr $startD /10000 ]
    set edd_stopDm [expr ($startD /100) %100 ]
    set edd_stopDd [expr $startD %100 ]

    if { $startT >=0} {
	set edd_startTh [expr $startT /100 ]
	set edd_startTm [expr $startT %100 ]
	set edd_stopTh [expr ($startT /100)+1 ]
	set edd_stopTm [expr $startT %100 ]
	if { $edd_stopTh >=24} {
	    set edd_stopTh 23
	    set edd_stopTm 59
	}
	set edd_noTime 0
    } else {
	set edd_startTh 8
	set edd_startTm 0
	set edd_stopTh 18
	set edd_stopTm 0
	set edd_noTime 1
    }
    set ret [ calcDate $edd_startDd $edd_startDm $edd_startDy -3]
    set eddv_day  [ lindex $ret 0 ]
    set eddv_mon  [ lindex $ret 1 ]
    set eddv_year [ lindex $ret 2 ]

    set edd_room [lindex $roomList 0]
    set edd_group [getPrimGroup $user]
    set edd_igno  0
    set edd_priv  0
    set edd_gpri  0
    set edd_titel "Neuer Termin"
    set edd_detail "Keine Details"
    set edd_repEna 0
    set edd_repTyp "woche"
    set edd_repIntervall 0
    set edd_repInterTyp "tage"
    set edd_repCount 0
    set edd_repInf   1
    set edd_reminder ""
    set edd_nonBlock 0
#    set edd_reminder "{1 Stunden E-mail alle} {15 Minuten E-mail $fullUsername}"

    set edd_comm   ""
    set edd_shiftCount 0
    set edd_priority 3



    set eddo_addButtonTitel "Termin hinzufgen"

    perm2rw $edd_currUserPerm
    set waitTT 1
    set eddo_tt_list ""
    set TTcacheUsers ""
    set TTcacheTime  "0 0"
    set TTcacheCtime 0
    editDateDialog 
    set edd_editTyp "Termin hinzufgen"

    wm title .edd [format "%s : %s" $edd_editTyp $edd_titel ]
    fillAll
    update
    $eddo_abb configure -state normal
    $eddo_ok configure -state normal
    unLock
}

proc editDate { did } {
    global edd_init  edd_part edd_titel edd_detail edd_comm edd_currUserPerm
    global edd_startDy edd_startDm edd_startDd edd_startTh edd_startTm 
    global edd_stopDy edd_stopDm edd_stopDd edd_stopTh edd_stopTm 
    global edd_room edd_igni edd_priv edd_gpri edd_group
    global userList groupList roomList edd_priority
    global edd_currUser edd_editTyp edd_groupsOfUser edd_priority
    global eddv_day eddv_mon eddv_year 
    global edd_repEna edd_repTyp edd_repIntervall edd_repInterTyp edd_repCount edd_repInf
    global edd_reminder edd_noTime edd_nonBlock
    global edd_cmd username
    global partStatus partStatusStr permValues curr_perms
    global eddo_addButtonTitel edd_teilnChange
    global edd_did  eddo_ok eddo_abb 
    global eddv_repTyp eddv_repUnit
    global waitTT eddo_tt_list
    global TTcacheTime TTcacheUser TTcache TTcacheCtime
    global curr_perms
    global edd_shiftCount

    doLock

    set edd_did $did
    set edd_teilnChange 1
    set ret [ request getDate $username $did]
    if { [string first $ret "ServerDown"] >=0 } {ServerDownDialog}
    set rt [request aquireDate $username $did]
    if { [string first $rt "ServerDown"] >=0 } {ServerDownDialog}

    set edd_currUserPerm [val2perm [ lindex $ret  0]]
    set edd_currUser $username
    set edd_init [ lindex $ret  1]
    set part [ lindex $ret  2]
    set edd_part ""
    foreach val $part {
	set ent [ format "%s {%s} %s %s %s {%s} %s" [lindex $val 5] [lindex $val 0] \
		      [lindex $partStatus [lindex $val 1]] [val2flag [lindex $val 2]] \
		      [ val2perm [lindex $val 3] ] [lindex $val 6] [lindex $val 4] ]
		      
	lappend edd_part $ent
    }

    set startD [ lindex $ret  3]
    set startT [ lindex $ret  4]
    set edd_startDy [expr $startD /10000 ]
    set edd_startDm [expr ($startD /100) % 100 ]
    set edd_startDd [expr $startD %100 ]
    set edd_startTh [expr $startT /100 ]
    set edd_startTm [expr $startT %100 ]
    set stopD  [ lindex $ret  5]
    set stopT  [ lindex $ret  6]
    set edd_stopDy [expr $stopD /10000 ]
    set edd_stopDm [expr ($stopD /100) % 100 ]
    set edd_stopDd [expr $stopD %100 ]
    set edd_stopTh [expr $stopT /100 ]
    set edd_stopTm [expr $stopT %100 ]
    set val [ calcDate $edd_startDd $edd_startDm $edd_startDy -3]
    set eddv_day  [ lindex $val 0 ]
    set eddv_mon  [ lindex $val 1 ]
    set eddv_year [ lindex $val 2 ]

    set edd_titel [ lindex $ret  7]
    set edd_detail [ lindex $ret  8]
    set edd_room [ lindex $ret  9]
    set edd_group [ lindex $ret 10]
    set edd_priv [ lindex $ret 11]
    set edd_gpri [ lindex $ret 12]

    #FIXME Repaet und reminder aus Termin

    set v [lindex $ret 13]
    if {$v == 0 } {
	set edd_repEna 0
	set edd_repTyp "tag"
    } else {
	set edd_repEna 1
	set edd_repTyp [lindex $eddv_repTyp $v]
    }
    set edd_repCount [lindex $ret 14] 
    set edd_repIntervall [lindex $ret 15] 
    set edd_repInterTyp [lindex $eddv_repUnit [lindex $ret 16] ] 
    set edd_priority [lindex $ret 17]
    set edd_reminder [lindex $ret 18]
    set edd_noTime [lindex $ret 19]
    set edd_comm [ lindex $ret 20]
    set edd_shiftCount [lindex $ret 21]
    set edd_nonBlock [lindex $ret 22]
#    puts "NOT: $edd_noTime"

    set edd_cmd "modifyDate"
    set eddo_addButtonTitel "Termin ndern"
    getLists
    set edd_groupsOfUser [request groupListByUser $username]
    if { [string first $edd_groupsOfUser "ServerDown"] >=0 } {ServerDownDialog}

    perm2rw $edd_currUserPerm
    set edd_editTyp "Termin ndern:"

    set waitTT 1
    set eddo_tt_list ""
    set TTcacheUsers ""
    set TTcacheTime  "0 0"
    set TTcacheCtime 0
#    puts "edd_groupsOfUser =$edd_groupsOfUser"

    editDateDialog 
    if { $curr_perms(rt) == 1} {
	wm title .edd [format "%s : %s" $edd_editTyp $edd_titel ]
    }
    fillAll 
    update
    $eddo_abb configure -state normal
    $eddo_ok configure -state normal
    unLock
}

proc perm2rw { perm } {
    global curr_perms

    set curr_perms(rz) 0
    set curr_perms(r) 0
    set curr_perms(rt) 0
    set curr_perms(rk) 0
    set curr_perms(wz) 0
    set curr_perms(w) 0
    set curr_perms(wt) 0
    set curr_perms(wk) 0
    set curr_perms(dd) 0
    set curr_perms(w)  0
    set curr_perms(r)  0
    
    if { [string range $perm 8 8] == "d" } { set curr_perms(dd) 1 }
    if { [string range $perm 7 7] == "k" } { set curr_perms(wk) 1 }
    if { [string range $perm 3 3] == "k" } { set curr_perms(rk) 1 }
    if { [string range $perm 6 6] == "t" } { set curr_perms(wt) 1 }
    if { [string range $perm 2 2] == "t" } { set curr_perms(rt) 1 }
    if { [string range $perm 5 5] == "" } { set curr_perms(w) 1 }
    if { [string range $perm 1 1] == "" } { set curr_perms(r) 1 }
    if { [string range $perm 4 4] == "z" } { set curr_perms(wz) 1 }
    if { [string range $perm 0 0] == "z" } { set curr_perms(rz) 1 }

    if { [expr  $curr_perms(rz)+$curr_perms(r)+$curr_perms(rt)+$curr_perms(rk)] >0 } { set curr_perms(r) 1}
    if { [expr  $curr_perms(wz)+$curr_perms(w)+$curr_perms(wt)+$curr_perms(wk)] >0 } { set curr_perms(w) 1}

#    puts "PERM $perm ->   $curr_perms(rz) $curr_perms(r) $curr_perms(rt) $curr_perms(rk) $curr_perms(wz) $curr_perms(w) $curr_perms(wt) $curr_perms(wk) "
}
 

#Request an Server

proc getPrimGroup { user} {
    set pg "Office"
    return $pg
}


proc initPartStatus { } {
    global partStatus partStatusStr permValues
    global lastUserList lastGroupList lastRoomList
    global eddv_repTyp eddv_repUnit eddv_repTypStr
    
    set lastUserList 0 
    set lastGroupList 0 
    set lastRoomList 0

    set partStatus "??? UKN OK NO OPEN PUSH IGNO"
    set partStatusStr "unbekannt unbekannt zugesagt abgesagt unsicher verschieben ignorieren ??? ??? ??? ??? ???"

    set eddv_repTyp "off tag woche monat jeden alle wtag"
    set eddv_repTypStr "off tglich wchentlich monatlich {jeden ...} {alle ...} {wochen-tglich}"
    set eddv_repUnit "stunden tage woche monate jahre"

}
