#!/usr/bin/X11/tixwish     

proc displayHelp { } {
    global docPath
    _displayHelp 0
    renderHelp $docPath/index.html
}

proc displayLoginHelp { } {
    global docPath
    _displayHelp 1
    renderHelp $docPath/index.html\#login
}

proc _displayHelp { doGrab } {
    global docPath fnt12 bfnt buglfile
    
    set buglfile ""
    toplevel .hlp
    wm title .hlp "Minkowsky-Hilfe"
    frame .hlp.t
    frame .hlp.h -relief raised -bd 1
    frame .hlp.b 
    pack .hlp.t .hlp.h .hlp.b -fill x -side top  -expand 1
    
    button .hlp.t.i  -width 14 -text "Inhaltsverzeichnis" -relief raised -bd 1 -command {renderHelp $docPath/index.html} -font $fnt12
    button .hlp.t.e  -width 11 -text "Einfhrung" -relief raised -bd 1 -command {renderHelp $docPath/index.html\#intro} -font $fnt12
    button .hlp.t.k  -width 11 -text "Kalender" -relief raised -bd 1 -command {renderHelp $docPath/kal.html} -font $fnt12
    button .hlp.t.t  -width 16 -text "Aufgaben & Projekte" -relief raised -bd 1 -command {renderHelp $docPath/proj.html} -font $fnt12
    button .hlp.t.a  -width 11 -text "Addressbuch" -relief raised -bd 1 -command {renderHelp $docPath/address.html} -font $fnt12
    button .hlp.t.z  -width 14 -text "Zugriffsrechte" -relief raised -bd 1 -command {renderHelp $docPath/rechte.html}
    button .hlp.t.f  -width 11 -text "FAQ" -relief raised -bd 1 -command {renderHelp $docPath/FAQ.html} -font $fnt12
    button .hlp.t.g  -width 14 -text "Benutzergruppen" -relief raised -bd 1 -font $fnt12 -command {
	set buglfile [format "/tmp/minko-%05d-bugl.html" [pid] ]
	exportUsersAndGroups $buglfile
	renderHelp $buglfile
    }
    pack  .hlp.t.i .hlp.t.e .hlp.t.k .hlp.t.t  .hlp.t.a .hlp.t.z .hlp.t.f  .hlp.t.g -side left -fill x
    
    button .hlp.b.ok -text "Schlieen" -command {
	if { $buglfile != "" } {
	    catch {file delete  $buglfile}
	}
	destroy .hlp
    }  -font $bfnt
    pack .hlp.b.ok -side right
    
    htmlView .hlp.h.html  960 700
    pack .hlp.h.html -side left -fill x  -expand 1
    centerWin .hlp 962 760
    update
#    renderHelp $docPath/index.html
    if { $doGrab == 1} { grab .hlp }
#    puts [wm geometry .hlp]
}

proc renderHelp { fname} {
    .hlp.b.ok configure -state disable
    renderHTML $fname
    .hlp.b.ok configure -state normal
}
