#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <errno.h>  
#include <time.h>  

#define ADDRESS 
#include "termin.h"

int fillStr2Address(char *tp[],Address *adr);
int adress2str(char *t,Address *adr);
int access2Adr(int uid, Address *adr);
int readNotiz(Address *adr);
int writeNotiz(Address *adr);


void initAdrList()
{
 adrList = new ( Address *) [DATEBLOCKSIZE];
 adrAnz=0;
 adrBlocks=1;
 adrMax = DATEBLOCKSIZE;
}
void clearAdrList ()
{
 delete adrList;
}

void extendAdrList()
{
 Address **tmp;
 int anz,anz0;
 int i;
 
 printf("extending space for addresses\n");

 adrBlocks++;
 anz= adrBlocks * DATEBLOCKSIZE;
 tmp= new ( Address *) [anz];
 adrMax=anz;
 anz0= (adrBlocks-1)  * DATEBLOCKSIZE;

 memcpy(tmp,adrList,anz0*sizeof(Date *));
 delete adrList;
 adrList=tmp;
 for(i=anz0;i<anz; i++)
  adrList[i]=NULL;
}

int updateDateCountsInAddress()
{
 int i,j,idx;
 Date *d;

 for(i=0; i<adrAnz; i++)
  adrList[i]->dateCount =0;

 for(i=0;i<dateAnz; i++)
  {
   d= dateList[i];
   if(d!=NULL)
    for(j=0;j<d->partAnz; j++)
     if(d->part[j].id >=ADDRESOFFSET && d->part[j].id <=MAX_ID)
      {
       idx = aid2idx(d->part[j].id-ADDRESOFFSET);
       printf("idx=%d\n",idx);
       if(idx>=0)
	adrList[idx]->dateCount++;
      }
  }
}
int deleteAddress(int socket,char *str)
{
 char *tp[4],buffer[8192];
 int aid,uid;
 Address *adr;

 split(str,tp,4);
 uid = uname2uid(tp[0]);
 aid=atoi(tp[1]);
 adr = adrList[aid2idx(aid)];

 if(access2Adr(uid,adr))
  adr->deleted=true;
 
 send2Client(socket,"done");
}

int changeAdress(int socket,char *ds)
{
 char *tp[32],*t,*s,buffer[16384];
 int aid;
 Address *adr;

 t=skip2nonWS(ds);
 if(*t!='{' && *t!='"')
  {
   s=buffer+1;
   buffer[0]=' ';
  }
 else
  s=buffer;
 strcpy(s,t);

 split(s,tp,32);

 aid=atoi(tp[0]);
 if(aid<0)
  {
   lastAid++;
   aid=lastAid;
   adr = new Address;
   adrList[adrAnz] = adr;
   adrAnz++;
   if(adrAnz >adrMax)
    extendAdrList();
   adr->id=lastAid;
   adr->dateCount=0;
   adr->notiz=NULL;
   fillStr2Address(tp,adr);
  }
 else
  {
   adr =adrList[aid2idx(aid)];
   if(!adr->deleted)
    fillStr2Address(tp,adr);
  }
 sprintf(buffer,"%d",adr->id);
 send2Client(socket,buffer);
 writeAdrList();
}
int fillStr2Address(char *tp[],Address *adr)
{
 int id;
 strcpy(adr->titel     ,strTrim(tp[ 1]));
 strcpy(adr->name1     ,strTrim(tp[ 2]));
 strcpy(adr->name2     ,strTrim(tp[ 3]));
 strcpy(adr->compShort ,strTrim(tp[ 4]));
 strcpy(adr->company   ,strTrim(tp[ 5]));
 strcpy(adr->fon[0]    ,strTrim(tp[ 6]));
 strcpy(adr->fon[1]    ,strTrim(tp[ 7]));
 strcpy(adr->fax       ,strTrim(tp[ 8]));
 strcpy(adr->mail      ,strTrim(tp[ 9]));
 strcpy(adr->www       ,strTrim(tp[10]));
 strcpy(adr->addres[0] ,strTrim(tp[11]));
 strcpy(adr->addres[1] ,strTrim(tp[12]));
 strcpy(adr->addres[2] ,strTrim(tp[13]));
 strcpy(adr->addres[3] ,strTrim(tp[14]));
 strcpy(adr->addres[4] ,strTrim(tp[15]));
 strcpy(adr->descrShort,strTrim(tp[16]));
 strcpy(adr->descr     ,strTrim(tp[17]));
 if(strcmp(tp[18],"Allgemein")==0)
  adr->owner=-1;
 else
  {
   id=uname2uid(tp[18]);
   if(id>=0)
    adr->owner=id;
   else
    {
     id=gname2gid(tp[18]);
     if(id>=0)
      adr->owner=id+GROUPOFFSET;
     else
      adr->owner=-1;
    }
  }
}

int readAdrList()
{
 FILE *fp;
 char file[4096];
 int i,anz,j;
 struct stat fstat;
 Address *adr;

 sprintf(file,"%s/address",dataDir);
 if((i=stat(file,&fstat))<0)
  {
   if(errno == ENOENT)
    {
     fp=fopen(file,"w");
     fclose(fp);
     if(stat(file,&fstat)<0)
      {
       printf("Can't open or create %s\n",file);
       exit(-1);
      }
    }
   else
    {
     char msg[1024];
     perror("");
     printf("Bad file  %s \n",file);
     exit(-1);
    }
  }
 
 adrAnz = (fstat.st_size/sizeof(Address));
 printf("reading %d addresses (%d)\n",adrAnz,i);
 if(adrAnz==0)
  return(0);
 
 while(adrAnz>adrMax)
  extendAdrList();

 fp=fopen(file,"r");
 if(fp==NULL)
  {
   printf("can't open %s\n",file);
   exit(-1);
  }

 adr = new Address [adrAnz+1];
 fread(adr,sizeof(Address),adrAnz,fp);
 fclose(fp);

 lastAid=-1;
 for(i=0;i<adrAnz; i++)
  {
   adrList[i] = adr+i;
   adrList[i]->notiz=NULL;
   if(adrList[i]->id>lastAid)
    lastAid = adrList[i]->id;
  }
}
int writeAdrList()
{
 FILE *fp;
 char file[4096];
 int i;

 sprintf(file,"%s/address",dataDir);
 fp=fopen(file,"w");
 if(fp==NULL)
  {
   printf("can't open %s\n",file);
   exit(-1);
  }
 for(i=0;i<adrAnz; i++)
  if(adrList[i]!=NULL)
   if(! adrList[i]->deleted)
    fwrite(adrList[i],sizeof(Address),1,fp);

 fclose(fp);
}
int sendBriefAdressList(int socket,char *str)
{ 
 int uid,i,perm,gid,j;
 char buffer[250000],txt[128];
 char *tp[4];

 split (str,tp,4);
 // uid=atoi(tp[0]);
 uid = uname2uid(tp[0]);

 strcpy(buffer,"");
 for(i=0;i<adrAnz; i++)
  {
   if(access2Adr(uid,adrList[i]))
    {
     adrIdx2cname(i,txt);
     printf("titel: '%s' %d\n",adrList[i]->titel,adrList[i]->titel[0]);
//      if(adrList[i]->titel[0] == '\0')
//       sprintf(txt,"{%s %s} ",adrList[i]->name1,adrList[i]->name2);
//      else
//       sprintf(txt,"{%s %s %s} ",adrList[i]->titel,adrList[i]->name1,adrList[i]->name2);
     strcat(buffer,txt);
    }
  }
 send2Client(socket,buffer);
}
int sendAddresssList(int socket,char *str)
{
 char *tp[4],buffer[1024000],txt[8192];
 int i,uid;

 split(str,tp,4);
 uid = uname2uid(tp[0]);
 // uid=atoi(tp[0]);
 
 strcpy(buffer,"");
 for(i=0;i<adrAnz; i++)
  if(access2Adr(uid,adrList[i]))
   {
    txt[0]='{';
    adress2str(txt+1,adrList[i]);
    strcat(txt,"} ");
    strcat(buffer,txt);
   }

 send2Client(socket,buffer);
}
int sendAddress(int socket,char *str)  // request 
{
 char *tp[4],buffer[8192];
 int aid,uid;
 Address *adr;

 split(str,tp,4);
 uid = uname2uid(tp[0]);
 // uid=atoi(tp[0]);
 aid=atoi(tp[1]);
 adr = adrList[aid2idx(aid)];

 if(access2Adr(uid,adr))
  adress2str(buffer,adr);
 
 send2Client(socket,buffer);
}

int adress2str(char *t,Address *adr)
{
 char owner[32];
 int status=0;

 if(adr->owner <0)
  strcpy(owner,"Allgemein");
 else if(adr->owner >=GROUPOFFSET)
  strcpy(owner,groupList[adr->owner-GROUPOFFSET].name);
 else
  strcpy(owner,userList[adr->owner].name);

 if(adr->dateCount>0)
  status=1;

 sprintf(t,"%d {%s} {%s} {%s} {%s} {%s} {%s} {%s} {%s} {%s} {%s} {%s} {%s} {%s} {%s} {%s} {%s} {%s} %s %d",
	 adr->id,adr->titel,adr->name1,adr->name2,adr->compShort,adr->company,adr->fon[0],adr->fon[1],adr->fax,
	 adr->mail,adr->www,adr->addres[0],adr->addres[1],adr->addres[2],adr->addres[3],adr->addres[4],
	 adr->descrShort,adr->descr,owner,status);
}

int access2Adr(int uid, Address *adr)
{
 int perm,j,gid;
 
 if(adr->deleted)
  return(false);

 perm=false;
 if(adr->owner == -1)
  perm=true;
 else if(adr->owner >=GROUPOFFSET)
  {
   gid = adr->owner -GROUPOFFSET;
   for(j=0;groupList[gid].anz; j++)
    if(groupList[gid].membr[j] == uid)
     {
      perm=true;
      break;
     }
  }
 else if(adr->owner == uid)
  perm=true;
 return(perm);
}

int addNotiz(int socket,char *str)
{
 char *tp[4],*buffer,dstr[32],txt[54],*nstr,*t,*s;
 int uid,aid;
 Address *adr;
 time_t tim;
 struct tm *tmp;
 int anz;

 split(str,tp,4);
 uid = uname2uid(tp[0]);
 // uid=atoi(tp[0]);
 aid=atoi(tp[1]);
 adr = adrList[aid2idx(aid)];

 anz  = 0;
 for(t=tp[2];*t!='\0' ; t++)
  if(*t=='\n')
   anz++;

 nstr = new char [strlen(tp[2]) +anz +16];
 s=nstr;
 t=tp[2];
 *s='\t';
 s++;
 while(*t != '\0')
  {
   *s=*t;
   if(*t =='\n')
    {
     s++;
     *s='\t';
    }
   s++;
   t++;
  }
 *s='\0';
 if(access2Adr(uid,adr))
  {
   tim=time(NULL);
   tmp=localtime(&tim);
   strftime(dstr,31,"%d.%m.%Y, %H:%M",tmp);
   sprintf(txt,"%s; %s:",dstr,userList[uid].name);
   if(adr->notiz==NULL)
    {
     adr->notiz = new char [strlen(nstr)+32];
     sprintf(adr->notiz,"%s\n%s\n",txt,nstr);
    }
   else
    {
     buffer = new char [strlen(adr->notiz) + strlen(nstr) +128];
     sprintf(buffer,"%s\n%s\n%s\n",adr->notiz,txt,nstr);
     delete adr->notiz;
     adr->notiz = new char [strlen(buffer)+16];
     strcpy(adr->notiz,buffer);
    }
   writeNotiz(adr);
  }
 send2Client(socket,"done");

}
int getNotiz(int socket,char *str)
{
 char *tp[4],*buffer;
 int uid,aid;
 Address *adr;

 split(str,tp,4);
 uid = uname2uid(tp[0]);
 // uid=atoi(tp[0]);
 aid=atoi(tp[1]);
 adr = adrList[aid2idx(aid)];

 if(access2Adr(uid,adr))
  {
   if(adr->notiz==NULL)
    {
     if(!readNotiz(adr))
      {
       send2Client(socket,"");
       return(true);
      }
    }
   //   printf("notiz:\n%s\n",adr->notiz);
   int l; 
   l = strlen(adr->notiz);
    //   printf ("len=%d\n",l);
   buffer= new char [l +16];
   sprintf(buffer,"{%s}",adr->notiz);
   send2Client(socket,buffer);
   usleep(1000);
   delete buffer;
  }
 else
  send2Client(socket,"Noaccess to address");
}
int readNotiz(Address *adr)
{
 struct stat fstat;
 char file[1024];
 FILE *fp;

 sprintf(file,"%s/notiz/adr%08d.txt",dataDir,adr->id);
 if(stat(file,&fstat)<0)
  return(false);

 adr->notiz =  new char [ fstat.st_size+16];
 
 fp=fopen(file,"r");
 if(fp==NULL)
  {
   printf("can't open %s\n",file);
   delete adr->notiz;
   adr->notiz=NULL;
   return(false);
  }
 fread(adr->notiz,sizeof(char),fstat.st_size,fp);
 fclose(fp);
 return(true);
}
int writeNotiz(Address *adr)
{
 char file[1024];
 FILE *fp;

 sprintf(file,"%s/notiz/adr%08d.txt",dataDir,adr->id);
 fp=fopen(file,"w");
 if(fp==NULL)
  {
   printf("can't open %s\n",file);
   return(-1);
  }
 fwrite(adr->notiz,sizeof(char),strlen(adr->notiz),fp);
 fclose(fp);
}




int aname2aid(char *name)
{
 int i=-1;
 char cname[256];

 for(i=0; i<adrAnz; i++)
  {
   adrIdx2name(i,cname);
   printf("cname='%s' name='%s'\n",cname,name);
   if(strcmp(name,cname)==0)
    return(adrList[i]->id);
  }
 return(-1);
}

int aname2idx(char *name)
{
 int i;
 char cname[256];

 for(i=0; i<adrAnz; i++)
  {
   adrIdx2name(i,cname);
   if(strcmp(name,cname)==0)
    return(i);
  }
 return(-1);
}

int aid2idx(int aid)
{
 int i=-1;
 for(i=0;i<adrAnz; i++)
  if(adrList[i]->id==aid)
   return(i);
 return(-1);
}

char * aid2name(int aid,char *t)
{
 Address *adr;
 int idx;

 idx =aid2idx(aid);
 if(idx<0)
  *t='\0';
 adr= adrList[idx];

 if(adr->titel[0] == '\0')
  sprintf(t,"%s %s",adr->name1,adr->name2);
 else
  sprintf(t,"%s %s %s",adr->titel,adr->name1,adr->name2);
 return(t);
}
char * adrIdx2name(int idx,char *t)
{
 Address *adr;

 if(idx<0)
  *t='\0';

 adr= adrList[idx];

 if(adr->titel[0] == '\0')
  sprintf(t,"%s %s",adr->name1,adr->name2);
 else
  sprintf(t,"%s %s %s",adr->titel,adr->name1,adr->name2);
 return(t);
}
char * aid2cname(int aid,char *t)
{
 int idx;
 char tx[256];

 idx =aid2idx(aid);
 sprintf(t,"{%s} ",adrIdx2name(idx,tx));
 return(t);
}
char * adrIdx2cname(int idx,char *t)
{
 char tx[256];

 sprintf(t,"{%s} ",adrIdx2name(idx,tx));
 return(t);
}
