#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <errno.h>  
#include <time.h>  
 
#include "termin.h"
void extendDateList();
int fillUserListInDateList(UserInDate *uid,char *names);
int fillUserInDateList(UserInDate *uid,char *str);
void fillUserInDate(UserInDate *uid, int id,int stat,int flag,int perm);
 //int fillUserInDateList(UserInDate *uid,char *names,int stat);
//void fillUserInDate(UserInDate *uid, int id,char *comm,int stat);
char * id2string(int id);
void exportDate(Date *d,char *file);
void addDate2Calendar(Date*d, int id);
int  addDate2RoomCalendar(Date *d, int uid);
int  addDate2UserCalendar(Date *d, int uid);
int  addDate2GroupCalendar(Date *d, int gid);
void sortDateList(Date **list,int anz);
int compareDateByStartTime(const void * p1,const void *p2);
int UiDlist2str(UserInDate *ul, char *t,int anz);
int changed (int v1, int v2);
int changed (int v1a, int v1b,int v2a, int v2b);
int changed (char* v1, char * v2);
int UiDlist2BriefStr(UserInDate *ul, Date *d, char *t,int anz,int init,int refDate, int RefTime);
int  modifyPartList(UserInDate *ref,int refAnz, UserInDate *cur,int curAnz, UserInDate *chg,int chgAnz,char *reject, char* done);
int modifySingleUserInDate(UserInDate *ref,UserInDate *cur,UserInDate *chg,UserInDate *tmp,char *reject, char* done);
UserInDate * findEntry4User(int id,UserInDate* list, int anz);
int skip2next(CalendarItem *ci,Date *d);
int addReminderList2Date(char *t,Date *d);
int getBlockedTimes4User(int startDay,int stopDay,Calendar *cal, char *buffer);
int modifyReminder(char *t,Date *cur, Date*ref,char *reject, char *done);
void addUserCal2Buffer(int uid,int cid,int gid, int startDay, int stopDay,int igno,char *buffer,int ignoInfo);
int nextDateAfterDate (CalendarItem *ci,CalendarItem *oci,Date *d, int datum, int tim);
int removeDateFromUserCal(Date *d,int  uid);
#ifdef V037
void initDateShiftList(Date *d);
void extendDateShiftList(Date *d);
void extendDatShiftMasterList();
int skip2next(CalendarItem *ici,CalendarItem *oci,Date *d);
CalendarItem *shiftDateIfNeeded(CalendarItem *ici,CalendarItem *oci,Date *d);
int compareDateShiftsByDate(const void *v1, const void * v2);;
int readDateShifts();
void initCalendarItem(Date *d ,CalendarItem *ci);
#endif
UserDateModification *getUserModification4Date(int did,int uid);
void initDateUserModification(UserDateModification *umodi);
int dateIsIgnoredByMe(int did,int uid);
int dateOnlyAsInfo(Date *d,int uid);
void clearDateShifts ();
void clearDateUserModification ();

void initDateList()
{
 int i;
 dateList = new ( Date *) [DATEBLOCKSIZE];
 dateAnz=0;
 dateBlocks=1;
 dateMax = DATEBLOCKSIZE;
 for(i=0;i<dateMax; i++)
  dateList[i]=NULL;

 dateShiftList = new (DateShift *) [DATEBLOCKSIZE];
 dateShiftAnz=0;
 dateShiftMax=DATEBLOCKSIZE;
}
void clearDateList ()
{
 int i,j;
 // FIXME memory leak. einzelne Objekte auf die dateList und dateShiftList zeigen lschen

 clearDateShifts ();
 clearDateUserModification();

 for(i=0; i<dateAnz; i++)
  if(dateList[i] != NULL)
   {
    //     if(dateList[i]->shifts!=NULL)
    //      for(j=0;j<dateList[i]->dateShiftAnz; j++)
    //       delete dateList[i]->shifts[j];
    //     delete dateList[i];
   }
 delete dateList;
 // delete dateShiftList;
}

void extendDateList()
{
 Date **tmp;
 int anz,anz0;
 int i;
 
 dateBlocks++;
 anz= dateBlocks * DATEBLOCKSIZE;
 tmp= new ( Date *) [anz];
 dateMax=anz;
 anz0= (dateBlocks-1)  * DATEBLOCKSIZE;
 memcpy(tmp,dateList,anz0*sizeof(Date *));
 delete dateList;
 dateList=tmp;
 for(i=anz0;i<anz; i++)
  dateList[i]=NULL;
}

void extendCalList(Calendar *cal)
{
 Date **tmp;
 int anz;
 
 anz= cal->max + DATEBLOCKSIZE;
 tmp= new ( Date *) [anz];

 memcpy(tmp,cal->list,cal->max*sizeof(Date *));
 cal->max=anz;
 delete cal->list;
 cal->list=tmp;
}

#ifdef V037
void initDateShiftList(Date *d)
{
 d->shifts = new ( DateShift *) [DATEBLOCKSIZE];
 d->dateShiftMax = DATEBLOCKSIZE;
 d->dateShiftAnz = 0;
}

void extendDatShiftMasterList()
{
 DateShift **tmp;
 int anz;
 
 //FIXME
 anz=dateShiftMax  + DATEBLOCKSIZE;
 tmp= new ( DateShift *) [anz];

 memcpy(tmp,dateShiftList,dateShiftMax*sizeof(DateShift *));
 dateShiftMax=anz;
 delete dateShiftList;
 dateShiftList=tmp;
}
void extendDateShiftList(Date *d)
{
 DateShift **tmp;
 int anz;
 
 //FIXME
 anz= d->dateShiftMax + DATEBLOCKSIZE;
 tmp= new ( DateShift *) [anz];

 memcpy(tmp,d->shifts,d->dateShiftMax*sizeof(DateShift *));
 d->dateShiftMax=anz;
 delete d->shifts;
 d->shifts=tmp;
 
}

void clearDateShifts ()
{
 int i;
 for(i=0;i<dateAnz; i++)
  if(dateList[i]!=NULL)
   if(!dateList[i]->deleted)
    {
     dateList[i]->dateShiftAnz=0;
     dateList[i]->dateShiftMax=0;
     delete dateList[i]->shifts;
    }
 for(i=0;i<dateShiftAnz; i++)
  if(dateShiftList[i] != NULL)
   delete dateShiftList[i];
 dateShiftAnz=0;
 dateShiftMax=0;
 delete dateShiftList;
}

#endif
#ifdef V038
void initDateUserModification(User *usr)
{
 usr->dmodi    = new ( UserDateModification) [DATEBLOCKSIZE];
 usr->dmodiMax = DATEBLOCKSIZE;
 usr->dmodiAnz = 0;
}

void extendDateUserModification(User *usr)
{
 UserDateModification *tmp;
 int anz;
 
 anz= usr->dmodiMax + DATEBLOCKSIZE;
 tmp= new ( UserDateModification) [anz];

 memcpy(tmp,usr->dmodi,usr->dmodiMax*sizeof(UserDateModification));
 usr->dmodiMax=anz;
 delete usr->dmodi;
 usr->dmodi=tmp;
}
void initDateUserModification(UserDateModification *umodi)
{
 umodi -> ignored = false;
 umodi -> noReminder =false;
}

void clearDateUserModification ()
{
 int i;
 for(i=0;i<userAnz; i++)
  if(userList[i].id==i)
   {
    delete userList[i].dmodi;
    userList[i].dmodiAnz=0;
    userList[i].dmodiMax=0;
    }
}
#endif

int deleteDate(int socket,char *t)
{
 int did,uid,i,u;
 int del_ok=false;
 char *tp[8];

 split(t,tp,8);
 did =atoi(tp[0]);
 uid =uname2uid(tp[1]);
 if(uid<0)
  {
   send2Client(socket,"ERR user unknown, no permissions to delete");
   return(0);
  }
 if(dateList[did]->init.id == uid)
  del_ok=true;
 else
  {
   for(i=0; i<dateList[did]->partAnz; i++)
    if ( (dateList[did]->part[i].perm & DELE_DATE) == DELE_DATE)
     { del_ok=true; break ;}
 }

 if(!del_ok)
  {
   char tx[256];
   sprintf(tx,"ERR user %s has no permissions to delete this date",tp[1]);
   send2Client(socket,tx);
   return(0);
  }
 dateList[did]->deleted=true;

#ifdef V037
 // FIXME eleganter wird langsam bei vielen shifts
 for(i=0;i<dateShiftAnz;i++)
  if(dateShiftList[i]->did == did)
   {
    dateShiftList[i]=NULL;
   }
 // FIXME Garbage collection fehlt
 dateList[did]->dateShiftAnz=0;
#endif

#ifdef V038
 for(u=0;u<userAnz; u++)
  if(userList[u].id >=0)
   if(userList[u].dmodiAnz>0)
    {
     for(i=0;i<userList[u].dmodiAnz; i++)
      {
       if(userList[u].dmodi[i].did == did)
	userList[u].dmodi[i].did =-1;
      }
     userList[uid].dmodiDirty=true;
    }
#endif


 
 recreateReminderList();
 send2Client(socket,"done");
}

int addDate(char *ds)
{
 Date *d;
 char buffer[16384],*tp[64],*t,*s;

 int j;



 t=skip2nonWS(ds);
 if(*t!='{' && *t!='"')
  {
   s=buffer+1;
   buffer[0]=' ';
  }
 else
  s=buffer;
 strcpy(s,t);

 split(s,tp,64);

 // tp[0] enthlt die did, die bei add Date noch ungestetz ist
 if(!checkPermission(NULL,WRITE_NEW,uname2uid(tp[1])))
  return(false);

 d= new Date;
 fillUserInDate(&d->init,uname2uid(tp[2]),DATE_STAT_UKN,0,PERM_ALL);
 for(j=0;j<d->partAnz; j++)
  if(d->part[j].id >=ADDRESOFFSET && d->part[j].id<=MAX_ID)
   {
    int idx = aid2idx(d->part[j].id-ADDRESOFFSET);
    adrList[idx]->dateCount++;
   }

 d->partAnz = fillUserListInDateList(d->part,tp[3]);
 d-> startDate = atoi(tp[4]);
 d-> startTime = atoi(tp[5]);
 d-> stopDate = atoi(tp[6]);
 d-> stopTime = atoi(tp[ 7]);
 strcpy(d->descr,trimRight(tp[ 8]));
 d->tlen=strlen(tp[ 8])+1;
 strcpy(d->descr+d->tlen,trimRight(tp[9]));
 d->room = rname2rid(tp[10]);
 d->group = gname2gid(tp[11]);
 d->flags = DATE_FLAG_PRIVAT *atoi(tp[12]) + DATE_FLAG_GROUPINTERN *atoi(tp[13]) +
  DATE_FLAG_NOTIME *atoi(tp[20]) +DATE_FLAG_NONBLOCK * atoi(tp[21]);
 d->repeatTyp       = atoi(tp[14]);
 d->repeatCount     = atoi(tp[15]);
 d->repeatIntervall = atoi(tp[16]);
 d->repeatUnit      = atoi(tp[17]);
 d->priority        = atoi(tp[18]);
 addReminderList2Date(tp[19],d);

 strcpy(d->comm,"");
 d->deleted =false;
 
 dateList[dateAnz]=d;
 d->id=dateAnz;
 dateAnz++;
 if(dateAnz>dateMax)
  extendDateList();

//   printf("adding date :  %s  (%d, %d ..%d, %d) <- %d %d \n",
//  	d->descr,d->startDate,d->startTime,d->stopDate,d->stopTime,d->init.id,d->part[0].id);
 for(j=0;j<d->partAnz; j++)
  addDate2Calendar(d,d->part[j].id);
 addDate2RoomCalendar(d,d->room);

 lastDateChange =time(NULL);
 initDateShiftList(d);
 return(true);
}

int addReminderList2Date(char *t,Date *d)
{
 char *tp[256];
 int anz,i;

 if( strlen(trimRight(t))==0)
  return(true);

#ifdef V036
#ifdef V0372
 for(i=0;i<REMINDERS_IN_DATE; i++)
  d->reminder[i].ct.ctrl = NULL;
#else
 for(i=0;i<REMINDERS_IN_DATE; i++)
  d->reminder[i].ctrl = NULL;
#endif
#endif
 anz=split(t,tp,255);
 d->remAnz =0;
 for(i=0;i<anz; i++)
  addReminder2Date(d,tp[i]);
 updateReminderList();
 return(true);
}

int aquireDate(int socket,char *ds)
{
 int did,uid;
 char *tp[8];

 split(ds,tp,8);
 did = atoi (tp[1]);
 uid = uname2uid(tp[0]);
 // printf("%s aquired date %d for editing\n",tp[0],did);
 userList[uid].editDate = new Date;
 memcpy(userList[uid].editDate,dateList[did],sizeof(Date));
 send2Client(socket,"done");
}
int cancelEditDate (int socket,char *ds)
{
 int uid;
 uid = uname2uid(ds);
 delete userList[uid].editDate;
 send2Client(socket,"done");
}
 
		 

int modifyDate(int socket,char *ds)
{
 Date *d,*ed;
 char buffer[16384],*tp[64],*t,*s;
 char done[4096],reject[4096];
 int v1,v2;
 int j,did,uid;
 char tmp[4096];
 UserInDate tmpUiD[512];
 int tmpAnz;
 int mustRecalcReminder=false;
 int nb;

 t=skip2nonWS(ds);
 if(*t!='{' && *t!='"')
  {
   s=buffer+1;
   buffer[0]=' ';
  }
 else
  s=buffer;
 strcpy(s,t);

 split(s,tp,64);

 did = atoi (tp[0]);
 d= dateList[did];
 uid = uname2uid(tp[1]);
 ed =  userList[uid].editDate;
 // tp[2] enthlt den inititator, der bei Modify nicht gendert werden kann
 
 strcpy(done,"");
 strcpy(reject,"");

 tmpAnz = fillUserListInDateList(tmpUiD,tp[3]);
 for(j=0;j<d->partAnz; j++)
  if(d->part[j].id >=ADDRESOFFSET && d->part[j].id<=MAX_ID)
   {
    int idx = aid2idx(d->part[j].id-ADDRESOFFSET);
    adrList[idx]->dateCount--;
   }

 d->partAnz=modifyPartList(ed->part,ed->partAnz,d->part,d->partAnz,tmpUiD,tmpAnz,reject,done);
 for(j=0;j<ed->partAnz; j++)
  if( (ed->part[j].flags & UID_FLAG_DELETED) > 1)
   {
    int ruid;
    if(verbose)
     if(ed->part[j].id<GROUPOFFSET)
      {
       if ( userList[ed->part[j].id].id == ed->part[j].id)
        printf("removing Date %d from user %d/%s\n",d->id,ed->part[j].id,userList[ed->part[j].id].name);
       else
        printf("removing Date %d from user %d\n",d->id,ed->part[j].id);
      }
     else
      printf("removing Date %d from user %d\n",d->id,ed->part[j].id);
    removeDateFromUserCal(d,ed->part[j].id);
   }
 for(j=0;j<d->partAnz; j++)
  if(d->part[j].id >=ADDRESOFFSET && d->part[j].id<=MAX_ID)
   {
    int idx = aid2idx(d->part[j].id-ADDRESOFFSET);
    adrList[idx]->dateCount++;
   }





 v1= atoi(tp[4]);
 v2= atoi(tp[5]);
 if(changed(ed->startDate,ed->startTime,v1,v2))  // Wurde diese Feld gendert?
  {
   if(d->dateShiftAnz>0 && d->repeatTyp!= NO_REPEAT)  // Wenn zwischenzeitlich bei einem Wiederholungstermin
    strcat(reject,"Anfangszeit ");                    // ein Shift eingetragen wurden, drfen die
   //                                                    Anfangszeiten nicht mehr gendert werden

   if(!changed(ed->startDate,ed->startTime,d->startDate,d->startTime))// Wurde inzwischen dieses Feld gendert?
    {
     d-> startDate = v1;
     d-> startTime = v2;
     strcat(done,"Anfangszeit ");
     mustRecalcReminder=true;
    }
   else
    strcat(reject,"Anfangszeit ");
  }
 v1= atoi(tp[6]);
 v2= atoi(tp[ 7]);
 if(changed(ed->stopDate,ed->stopTime,v1,v2))  // Wurde diese Feld gendert?
  {
   if(!changed(ed->stopDate,ed->stopTime,d->stopDate,d->stopTime))// Wurde  inzwischen dieses Feld gendert?
    {
     d-> stopDate = v1;
     d-> stopTime = v2;
     strcat(done,"Endzeit ");
    }
   else
    strcat(reject,"Endzeit ");
  }

 if(changed(ed->descr,tp[ 8]))
  {
   if(!changed(ed->descr,d->descr))
    {
     strcpy(tmp,trimRight(tp[ 8]));
     strcat(done,"Titel ");
    }
   else
    {
     strcpy(tmp,d->descr);
     strcat(reject,"Titel ");
    }
  }
 else
  {
   strcpy(tmp,ed->descr);
  }
 v1 = strlen(tmp)+1;

 if(changed(ed->descr + ed->tlen, tp[ 9]))
  {
   if(!changed(ed->descr + ed->tlen,d->descr + d->tlen))
    {
     strcpy(tmp+v1,trimRight(tp[ 9]));
     strcat(done,"Details ");
    }
   else
    {
     strcpy(tmp+v1,d->descr + d->tlen);
     strcat(done,"Details ");
    }
  }
 else
  strcpy(tmp+v1,ed->descr + ed->tlen);

 strcpy(d->descr,tmp);
 d->tlen=v1;
 strcpy(d->descr+d->tlen,tmp+v1);

 v1 =rname2rid(tp[10]);
 if(changed(ed->room,v1))
  {
   if(!changed(ed->room,d->room))
    {
     d->room=v1;
     strcat(done,"Ort ");
    }
   else
     strcat(reject,"Ort ");
  }

 v1 =gname2gid(tp[11]);
 if(changed(ed->group,v1))
  {
   if(!changed(ed->group,d->group))
    {
     d->group=v1;
     strcat(done,"Gruppe ");
    }
   else
     strcat(reject,"Gruppe ");
  }


 int pr,gi,nt;
 v1  = DATE_FLAG_PRIVAT*atoi(tp[12]);
 if(changed(ed->flags&DATE_FLAG_PRIVAT,v1))
  {
   if(!changed(ed->flags&DATE_FLAG_PRIVAT,d->flags&DATE_FLAG_PRIVAT))
    {
     //     d->flags=v1;
     pr = v1;
     strcat(done,"Privat-Status ");
    }
   else
    {
     strcat(reject,"Privat-Status ");
     pr = d->flags&DATE_FLAG_PRIVAT;
    }
  }
 else
  pr = d->flags&DATE_FLAG_PRIVAT;

 v1 =DATE_FLAG_GROUPINTERN *atoi(tp[13]);
 if(changed(ed->flags&DATE_FLAG_GROUPINTERN,v1))
  {
   if(!changed(ed->flags&DATE_FLAG_GROUPINTERN,d->flags&DATE_FLAG_GROUPINTERN))
    {
     gi = v1;
     strcat(done,"Gruppenintern-Status ");
    }
   else
    {
     strcat(reject,"Gruppenintern-Status ");
     gi = d->flags&DATE_FLAG_GROUPINTERN;
    }
  }
 else
  gi = d->flags&DATE_FLAG_GROUPINTERN;

 v1 =DATE_FLAG_NOTIME *atoi(tp[20]);
 if(changed(ed->flags & DATE_FLAG_NOTIME,v1))
  {
   if(!changed(ed->flags& DATE_FLAG_NOTIME,d->flags& DATE_FLAG_NOTIME))
    {
     //     d->flags=v1;
     nt=v1;
     strcat(done,"Ganztgigkeit ");
    }
   else
    {
     strcat(reject,"Ganztgigkeit ");
     nt = d->flags& DATE_FLAG_NOTIME;
    }
  }
 else
  nt = d->flags& DATE_FLAG_NOTIME;

 v1 =DATE_FLAG_NONBLOCK *atoi(tp[21]);
 if(changed(ed->flags & DATE_FLAG_NONBLOCK,v1))
  {
   if(!changed(ed->flags& DATE_FLAG_NONBLOCK,d->flags& DATE_FLAG_NONBLOCK))
    {
     //     d->flags=v1;
     nb=v1;
     strcat(done,"Blockadestatus ");
    }
   else
    {
     strcat(reject,"Blockadestatus ");
     nb = d->flags& DATE_FLAG_NONBLOCK;
    }
  }
 else
  nb = d->flags& DATE_FLAG_NONBLOCK;

//  printf ("\t\t '%s' '%s' '%s' '%s' '%s' '%s' '%s' '%s' '%s'x\n",
// 	 tp[12],tp[13],tp[14],tp[15],tp[16],tp[17],tp[18],tp[19],tp[20]);

 // printf("FLAGS =%d (via %d %d %d %d ",d->flags,atoi(tp[12]),atoi(tp[13]),atoi(tp[20]),atoi(tp[21]));
 d->flags = pr+gi+nt+nb;
 // printf("FLAGS =%d \n",d->flags);

 

 v1=atoi(tp[14]);
 if(changed(ed->repeatTyp,v1))
  {
   if(d->dateShiftAnz>0 && v1== NO_REPEAT)  // Wenn zwischenzeitlich bei einem Wiederholungstermin ein Shift
    strcat(reject,"Anfangszeit ");          // eingetragen wurden, darf der REPEAT_TYP nicht NO_REPEAT werden.

   if(!changed(ed->repeatTyp,d->repeatTyp))
    {
     d->repeatTyp=v1;
     strcat(done,"Wiederholungart ");
    }
   else
     strcat(reject,"Wiederholungart ");
  }
 v1=atoi(tp[15]);
 if(changed(ed->repeatCount,v1))
  {
   if(!changed(ed->repeatCount,d->repeatCount))
    {
     d->repeatCount=v1;
     strcat(done,"Wiederholungshufigkeit ");
    }
   else
    strcat(reject,"Wiederholunsghufigkeit ");
  }
 v1=atoi(tp[16]);
 if(changed(ed->repeatIntervall,v1))
  {
   if(!changed(ed->repeatIntervall,d->repeatIntervall))
    {
     d->repeatIntervall=v1;
     strcat(done,"Wiederholungs-Sonderintervall ");
    }
   else
     strcat(reject,"Wiederholungs-Sonderintervall ");
  }
 v1=atoi(tp[17]);
 if(changed(ed->repeatUnit,v1))
  {
   if(!changed(ed->repeatUnit,d->repeatUnit))
    {
     d->repeatUnit=v1;
     strcat(done,"Wiederholungs-Sonderintervall-Einheit ");
    }
   else
     strcat(reject,"Wiederholungs-Sonderintervall-Einheit ");
  }
 v1=atoi(tp[18]);
 if(changed(ed->priority,v1))
  {
   if(!changed(ed->priority,d->priority))
    {
     d->priority=v1;
     strcat(done,"Prioritt ");
    }
   else
     strcat(reject,"Prioritt ");
  }

 modifyReminder(tp[19],d,ed,reject,done);
 recalcReminder(d);
//  if( mustRecalcReminder)
//   resetReminderStates(d);
 recreateReminderList();
 
 for(j=0;j<d->partAnz; j++)
  addDate2Calendar(d,d->part[j].id);
 addDate2RoomCalendar(d,d->room);

 delete userList[uid].editDate;

 if(strlen(reject)>0)
  {
   sprintf(buffer,"WARN: modify incomplete {%s} {%s}",done,reject);
   send2Client(socket,buffer);
  }
 else
  send2Client(socket,"OK");

 lastDateChange =time(NULL);

 return(true);
}

int modifyReminder(char *t,Date *cur, Date*ref,char *reject, char *done)
{
 char *tp[256],tx[256];
 int anz,i,ranz=0;
 Reminder *rem,tmp;
 int rc=0,dc=0,add;


 for(i=0;i<cur->remAnz; i++)
  if(! reminderIsInList (&cur->reminder[i],ref->reminder,ref->remAnz))
   if(! reminderIsInList (&cur->reminder[i],rem,ranz))
    if(ranz<512)
    {
     memcpy(&rem[ranz],&cur->reminder[i],sizeof(Reminder));
     ranz++;
    }

 if( strlen(trimRight(t))>0)
  {
   ranz=0;
   anz=split(t,tp,255);
   rem = new Reminder [512];
   for(i=0;i<anz; i++)
    {
     add=false;
     str2Reminder(&tmp,tp[i],cur);
     if(! reminderIsInList (&tmp,ref->reminder,ref->remAnz))
      {
       add=true;
       dc++;
      }
     else
      {
       if(! reminderIsInList (&tmp,cur->reminder,cur->remAnz))
	rc++;
       else
	{
	 add=true;
	 dc++;
	}
      }
     if(add)
      {
       if(ranz<512)
	{
	 tmp.status=REMINDER_WAITING;
	 memcpy(&rem[ranz],&tmp,sizeof(Reminder));
	 ranz++;
	};
      }
    }
  }

 
 memcpy(cur->reminder,rem,sizeof(Reminder)*ranz);
 cur->remAnz=ranz;

 if(dc>0)
   strcat(done,"Erinnerer ");
 if(rc>0)
  strcat(reject,"Erinnerer ");
 if(dc>0)

 return(true);
}

int  modifyPartList(UserInDate *ref,int refAnz, UserInDate *cur,int curAnz, UserInDate *chg,int chgAnz,char *reject, char* done)
{
 UserInDate tmp[512],*ruid,*cuid,*uid;
 int tmpAnz=0,i;
 int tryChange,add;
 char tx[256];

 // printf("anz vorher: %d\n",curAnz);
 
  for(i=0;i<refAnz; i++)
   ref[i].flags |= UID_FLAG_DELETED;

 for(i=0;i<chgAnz; i++)
  {
   uid = &chg[i];
   ruid = findEntry4User(uid->id,ref,refAnz);
   cuid = findEntry4User(uid->id,cur,curAnz);
   add=false;
   tryChange=false;
   
   if( ruid ==NULL)
    {
     if(cuid==NULL)
      add=true;
     else
      {
       sprintf(tx,"Teilnehmer.%s.all ",userList[uid->id].name); 
       strcat(reject,tx);
      }
    }
   else
    {
     if(cuid==NULL)
      {
       sprintf(tx,"Teilnehmer.%s.deleted ",userList[uid->id].name); 
       strcat(reject,tx);
      }
     else
      tryChange=true;
    }

   if(add)
    {
     char nam[128];
     memcpy(&tmp[tmpAnz],uid,sizeof(UserInDate));
     if(uid->id<GROUPOFFSET)
      sprintf(tx,"Teilnehmer.%s.added ",userList[uid->id].name); 
     else if (uid->id>=ADDRESOFFSET && uid->id<=MAX_ID)
      sprintf(tx,"Teilnehmer.%s.added ",aid2cname(uid->id-ADDRESOFFSET,nam)); 
     else
      sprintf(tx,"Teilnehmer.%s.added ",groupList[uid->id-GROUPOFFSET].name); 
     
     //     printf("%s ",tx);
     strcat(done,tx);
     tmpAnz++;
    }
   if(tryChange)
    {
     modifySingleUserInDate(ruid,cuid,uid,&tmp[tmpAnz],reject,done);
     tmpAnz++;
     ruid->flags &= (~UID_FLAG_DELETED);
    }
  }



 // Alle UiD bernehmen die in cur hinzugekommen sind, nachdem ref abgespeichert wurde
 for(i=0;i<curAnz; i++)
  {
   cuid = &cur[i];
   ruid = findEntry4User(cuid->id,ref,refAnz);
   if(ruid==NULL)
    {
     memcpy(&tmp[tmpAnz],cuid,sizeof(UserInDate));
     tmpAnz++;
     ruid->flags &= (~UID_FLAG_DELETED);
    }
  }
   
 memcpy(cur,tmp,sizeof(UserInDate)*tmpAnz);
 return(tmpAnz);
}
int removeDateFromUserCal(Date *d,int  uid)
{
 Date **t;
 int i,j;
 Calendar *cal;

 if(uid<GROUPOFFSET)
  cal = & userList[uid].cal;
 else if(uid<ROOMOFFSET)
  cal = & groupList[uid-GROUPOFFSET].cal;
 else if(uid<ADDRESOFFSET)
  cal = & roomList[uid-ROOMOFFSET].cal;
 else 
  return true;

 for(i=0;i<cal->anz;i++)
  if(d == cal->list[i])
   break;

 if (d == cal->list[i])
  for(j=i+1; j< cal->anz; j++)
   cal->list[j-1] =cal->list[j];
 
 cal->anz --;
}
int modifySingleUserInDate(UserInDate *ref,UserInDate *cur,UserInDate *chg,UserInDate *tmp,char *reject, char* done)
{
 char tx[256],name[128];
 

 if(chg->id>=ADDRESOFFSET && chg->id<=MAX_ID)
  strcpy(name,aid2cname(chg->id-ADDRESOFFSET,tx));
 else if(chg->id>=GROUPOFFSET)
  strcpy(name,groupList[chg->id-GROUPOFFSET].name);
 else 
  strcpy(name,userList[chg->id].name);

 tmp->id = chg->id;
 if(changed(ref->status,chg->status))
  {
   if(!changed(cur->status,ref->status))
    {
     sprintf(tx,"Teilnehmer.%s.status ",name); 
     strcat(done,tx);
     tmp->status=chg->status;
    }
   else
    {
     sprintf(tx,"Teilnehmer.%s.status ",name); 
     strcat(reject,tx);
     tmp->status=cur->status;
    }
  }
 else 
  tmp->status=ref->status;

 if(changed(ref->flags & UID_NONLOCAL_FLAG_MASK,chg->flags & UID_NONLOCAL_FLAG_MASK))
  {
   if(!changed(cur->flags & UID_NONLOCAL_FLAG_MASK,ref->flags & UID_NONLOCAL_FLAG_MASK))
    {
     sprintf(tx,"Teilnehmer.%s.flags ",name); 
     strcat(done,tx);
     tmp->flags=chg->flags;
    }
   else
    {
     sprintf(tx,"Teilnehmer.%s.flags ",name); 
     strcat(reject,tx);
     tmp->flags=cur->flags;
    }
  }
 else 
  tmp->flags=ref->flags;

 if(changed(ref->perm,chg->perm))
  {
   if(!changed(cur->perm,ref->perm))
    {
     sprintf(tx,"Teilnehmer.%s.perm ",name); 
     strcat(done,tx);
     tmp->perm=chg->perm;
    }
   else
    {
     sprintf(tx,"Teilnehmer.%s.perm ",name); 
     strcat(reject,tx);
     tmp->perm=cur->perm;
    }
  }
 else 
  tmp->perm=ref->perm;

 if(changed(ref->typ,chg->typ))
  {
   if(!changed(cur->typ,ref->typ))
    {
     sprintf(tx,"Teilnehmer.%s.typ ",name); 
     strcat(done,tx);
     tmp->typ=chg->typ;
    }
   else
    {
     sprintf(tx,"Teilnehmer.%s.typ ",name); 
     strcat(reject,tx);
     tmp->typ=cur->typ;
    }
  }
 else 
  tmp->typ=ref->typ;

//  if (tmp->id <GROUPOFFSET)
//  printf("%d/%16s:  (%d %d %d %d) / (%d %d %d %d) / (%d %d %d %d) \n\t\t\t=> (%d %d %d %d)=> r=/%s/ d=/%s/\n",
// 	tmp->id,userList[tmp->id].name,
// 	ref->status,ref->flags,ref->perm,ref->typ,
// 	cur->status,cur->flags,cur->perm,cur->typ,
//  	chg->status,chg->flags,chg->perm,chg->typ,
// 	tmp->status,tmp->flags,tmp->perm,tmp->typ,reject,done);
//  else
//  printf("%d/%16s:  (%d %d %d %d) / (%d %d %d %d) / (%d %d %d %d) \n\t\t\t=> (%d %d %d %d)=> r=/%s/ d=/%s/\n",
// 	tmp->id,groupList[tmp->id-GROUPOFFSET].name,
// 	ref->status,ref->flags,ref->perm,ref->typ,
// 	cur->status,cur->flags,cur->perm,cur->typ,
//  	chg->status,chg->flags,chg->perm,chg->typ,
// 	tmp->status,tmp->flags,tmp->perm,tmp->typ,reject,done);
 return(true);
}

UserInDate * findEntry4User(int id,UserInDate* list, int anz)
{
 int i;
 for(i=0; i<anz; i++)
  if(list[i].id == id)
   return(&list[i]);
 return(NULL);
}

int changed (int v1, int v2)
{
 if(v1 == v2)
  return false;
 return true;
}
int changed (int v1a,int v1b, int v2a, int v2b)
{
 if(v1a == v2a && v1b == v2b)
  return false;
 return true;
}
int changed (char* v1, char * v2)
{
 trimRight(v1);
 trimRight(v2);
//  printf("(\"%s\" = \"%s\") =%d\n",v1,v2,strcmp(v1,v2));
 if(strcmp(v1,v2)==0)
  return false;
 return true;
}
char * trimRight (char *t)
{
 char *s;
 s= t+strlen(t)-1;
 while (*s ==' ' || *s=='\n' || *s=='\t')
  s--;
 if(s[1] !='\0' && s>t)
  s[1]='\0';
 return(t);
}

char * strTrim (char *t)
{
 char *s,*z;

 s= t+strlen(t)-1;
 while (*s ==' ' || *s=='\n' || *s=='\t')
  s--;
 if(s[1] !='\0' && s>t)
  s[1]='\0';

 s=t;
 while(*s ==' ' || *s=='\n' || *s=='\t')
  s++;
 if(s>t)
  {
   z=t;
   while(*s!='\0')
    {
     *z=*s;
     z++;
     s++;
    }
   // t++;
   *z='\0';
  }
 return(t);
}

int fillUserListInDateList(UserInDate *uid,char *names)
{
 int i,anz,id,skipped=0;
 char *tp[257],*s;

 if(skip2nonWS(names) == NULL)
  return(0);

 anz = split(names,tp,257);
 for(i=0;i<anz; i++)
  if ( ! fillUserInDateList(&uid[i-skipped],tp[i]))
   skipped++;

 return(anz-skipped);
}

int fillUserInDateList(UserInDate *uid,char *str)
{
 int i,anz,id,skipped=0;
 char *tp[16],*s;

 if(skip2nonWS(str) == NULL)
  return(0);

 split(str,tp,16);
 if (atoi(tp[4])==1)
  {
   id = gname2gid(tp[0]);      // FIXME was ist mit externen
   if(id>=0)
    id+= GROUPOFFSET;
  }
 else if (atoi(tp[4])==2)
  {
   id = aname2aid(tp[0]);      // FIXME was ist mit externen
   if(id>=0)
    id+= ADDRESOFFSET;
  }
 else
  id = uname2uid(tp[0]);

 if(id>=0)
  {
   uid->id =id;
   uid->status=atoi(tp[1]);
   uid->flags=atoi(tp[2]);
   uid->perm=atoi(tp[3]);
   uid->typ=tp[5][0];
   return true;
  }
 return false;
}

void fillUserInDate(UserInDate *uid, int id,int stat,int flag,int perm)
{
 // printf("adding %d to date\n",id);
 uid->id=id;
 uid->status=stat;
 uid->perm =perm;
 uid->flags=flag;
}


void addComm(int socket,char *t)
{
 char *tp[64],text[8192];
 int did,r;

 split(t,tp,64);
 did =atoi(tp[0]);
 sprintf(text,"%s: %s\n",tp[1],trimRight(tp[2]));
 r = 8191 -strlen(dateList[did]->comm);
 if(strlen(text) > r)
  text[r]='\0';
 strcat(dateList[did]->comm,text);
 send2Client(socket,"OK");
}

void getComm (int socket,char *t)
{
 int did;
 char tx[8196];
 did =atoi(t);
 send2Client(socket,dateList[did]->comm);
}

int sendBriefDate(int socket, char *t)
{
 char *tp[8],buffer[65536];
 char eList[16384],tList[16384],aList[16384],iList[16384];
 static int uid,did;
 int privat=0,gintern=0,perm,noTime=0,baseDate,nonBlock=0;
 Date *d;
 UserInDate *self;
 CalendarItem ci,wci;
 UserDateModification *umodi;
 int noRem=false,igno=false;

 split(t,tp,8);
 uid = uname2uid(tp[0]);
 if(uid<0)
  { 
   send2Client(socket,"ERR: no such user (code 1)");
   return 0;
  }
 if(uid >userAnz)
  {
   send2Client(socket,"ERR: no such user (code 2)");
   return 0;
  }
 if(userList[uid].id<0)
  {
   send2Client(socket,"ERR: no such user (code 3)");
   return 0;
  }
 did = atoi(tp[1]); // FIXME check ob date existiert.
 if ( dateList[did] == NULL)
  {
   send2Client(socket,"ERR: no such date");
   return 0;
  }

 d=dateList[did];
 baseDate=atoi(tp[2]);
 perm = getPermission(d,uid,d->group);
#ifdef V038
 umodi = getUserModification4Date(d->id,uid);
 if(umodi!=NULL)
  {
   noRem = umodi->noReminder;
   igno  = umodi->ignored;
  }
#endif


 if( (d->flags & DATE_FLAG_PRIVAT)>0)
  privat=1;
 if( (d->flags & DATE_FLAG_GROUPINTERN)>0)
  gintern=1;
 if( (d->flags & DATE_FLAG_NOTIME)>0)
  noTime=1;
 

 if(d->repeatTyp == NO_REPEAT)
  {
   strcpy(tList,"");
   UiDlist2BriefStr(d->part,d,tList,d->partAnz,d->init.id,0,0);
   sprintf(buffer,"%d {%s} %d %d %d %d {%s}  {%s} %d %d {%s}  %s %d %d  %d %d  %d %d",
	   perm,d->descr,d->startDate,d->startTime,d->stopDate,d->stopTime,roomList[d->room].name,
	   d->descr+d->tlen,privat,gintern,tList,groupList[d->group].name,d->repeatTyp,noTime,
	   d->startDate,d->startTime,igno,noRem);
  } else {
   ci.startDate=d->startDate;
   ci.startTime=d->startTime;
   ci.stopDate =d->stopDate;
   ci.stopTime =d->stopTime;
   ci.count=0;
   ci.startwDay=weekDayByDate(ci.startDate);
   memcpy(&wci,&ci,sizeof(CalendarItem));
   d->dateShiftPtr =0;
   if(wci.stopDate<baseDate)
    {
     while(wci.stopDate<baseDate)
      if(!skip2next(&ci,&wci,d))
       break;
    } else  {
     shiftDateIfNeeded(&ci,&wci,d);
    }
   strcpy(tList,"");
   UiDlist2BriefStr(d->part,d,tList,d->partAnz,d->init.id,ci.startDate,ci.startTime);
   sprintf(buffer,"%d {%s} %d %d %d %d {%s}  {%s} %d %d {%s}  %s %d %d  %d %d  %d %d",
	   perm,d->descr,wci.startDate,wci.startTime,wci.stopDate,wci.stopTime,roomList[d->room].name,
	   d->descr+d->tlen,privat,gintern,tList,groupList[d->group].name,d->repeatTyp,noTime,
	   ci.startDate,ci.startTime,igno,noRem);
  }
 send2Client(socket,buffer);
}
int UiDlist2BriefStr(UserInDate *ul,Date *d, char *t,int anz,int init,int refDate,int refTime)
{
 char ent[256],name[128],ig,tp;
 int i,id;
 int status;

 for(i=0;i<anz; i++)
  {
   ig=0;
   if(ul[i].id == init)
    tp='I';
   else
    tp=(char) ul[i].typ;

   if(ul[i].id>=ADDRESOFFSET && ul[i].id<=MAX_ID)                 // FIXME externe
    {
     ig='a';
     strcpy(name,aid2name(ul[i].id-ADDRESOFFSET,ent));
     status = ul[i].status;
    }
   else if(ul[i].id>=GROUPOFFSET)                 // FIXME externe
    {
     ig='g';
     strcpy(name,groupList[ul[i].id-GROUPOFFSET].name);
     status = ul[i].status;
    }
   else
    {
     ig='u';
     strcpy(name,userList[ul[i].id].full);
     status = ul[i].status;
     if (d->repeatTyp != NO_REPEAT)
      {
       int j,k;
       for(j=0;j<d->dateShiftAnz; j++)
	if(d->shifts[j]->refDate == refDate && d->shifts[j]->refTime == refTime)
	 {
	  if( d->shifts[j]->partStatus[i] !=0)
	   status = d->shifts[j]->partStatus[i];
	 }
      }
    }
   sprintf(ent,"{%c {%s} %d %c }",tp,name,status,ig);
   strcat(t,ent);
   strcat(t," ");
  }
}

int sendDate(int socket, char *t)
{
 char *tp[8],buffer[65536];
 char tList[16384],rList[16384],txt[128];
 int uid,did,perm,i;
 int privat=0,gintern=0,noTime=0,nonBlock=0;
 Date *d;
 UserInDate *self;

 split(t,tp,8);
 uid = uname2uid(tp[0]);
 if(uid<0)
  { 
   send2Client(socket,"ERR: no such user (code 1)");
   return 0;
  }
 if(uid >userAnz)
  {
   send2Client(socket,"ERR: no such user (code 2)");
   return 0;
  }
 if(userList[uid].id<0)
  {
   send2Client(socket,"ERR: no such user (code 3)");
   return 0;
  }
 did = atoi(tp[1]); // FIXME check ob date existiert.
 if ( dateList[did] == NULL)
  {
   send2Client(socket,"ERR: no such date");
   return 0;
  }
 d=dateList[did];
 perm = getPermission(d,uid,d->group);

 strcpy(tList,"");
 UiDlist2str(d->part,tList,d->partAnz);

 if( (d->flags & DATE_FLAG_PRIVAT)>0)
  privat=1;
 if( (d->flags & DATE_FLAG_GROUPINTERN)>0)
  gintern=1;
 if( (d->flags & DATE_FLAG_NOTIME)>0)
  noTime=1;
 if( (d->flags & DATE_FLAG_NONBLOCK)>0)
  nonBlock=1;

 strcpy(rList,"");
 // printf("sendDate: %d reminder\n",d->remAnz);
 for (i=0;i<d->remAnz; i++)
  {
   strcat(rList,reminder2Str4Date(&d->reminder[i],txt));
   //   printf("RLIST(%d) %s  \t -> %s\n",i,txt,rList);
  }
 sprintf(buffer,"%d %s {%s} %d %d %d %d {%s} {%s} {%s} {%s} %d %d %d %d %d %d %d {%s} %d {%s} %d %d",
	 perm,userList[d->init.id].name,tList,d->startDate,d->startTime,d->stopDate,d->stopTime,
	 d->descr, d->descr+d->tlen,roomList[d->room].name,groupList[d->group].name,privat,gintern, 
	 d->repeatTyp,d->repeatCount,d->repeatIntervall,d->repeatUnit,d->priority,rList,noTime,d->comm,
	 d->dateShiftAnz,nonBlock);
 send2Client(socket,buffer);
}

int UiDlist2str(UserInDate *ul, char *t,int anz)
{
 char ent[256],name[128],ig,full[128];
 int i,id;
 for(i=0;i<anz; i++)
  {
   ig=0;
   if(ul[i].id>=ADDRESOFFSET && ul[i].id<=MAX_ID)                 // FIXME externe
    {
     ig='a';
     strcpy(name,aid2cname(ul[i].id-ADDRESOFFSET,ent));
     strcpy(full,aid2name(ul[i].id-ADDRESOFFSET,ent));  // Bei full werden Klammer untern gesetzt, da auch 'user' 
    }                                                   // diese braucht ;-)
   else if(ul[i].id>=GROUPOFFSET)                 // FIXME externe
    {
     ig='g';
     strcpy(name,groupList[ul[i].id-GROUPOFFSET].name);
     sprintf(full,"Gruppe %s",groupList[ul[i].id-GROUPOFFSET].name);
    }
   else
    {
     ig='u';
     strcpy(name,userList[ul[i].id].name);
     strcpy(full,userList[ul[i].id].full);
    }
   sprintf(ent,"{%s %d %d %d %c %c {%s}} ",name,ul[i].status,ul[i].flags,ul[i].perm,ig,ul[i].typ,full);
   //   printf("sending '%s' <- /%s/  /%s/\n",ent,name,full);
   strcat(t,ent);
//    printf("%d\n",ul[i].typ);
//    printf("%s\n",full);
//    printf("%s -> /%s/\n",ent,t);
  }
}

int split(char *txt,char **tp ,int max)
{
 int sc=0,bc=0,qc=0;
 int i=0,anz;
 char *s,*t;

 s=skip2nonWS(txt);
 if(s==NULL)
  tp[0]=txt;
 else
  {
   tp[i]=s;
   i++;

   for(t=s; *t!='\0'; t++)
    {
     // Alle "" '' {}-Blcke dedektieren
     if(sc==0 && qc==0) // In Quotes und strings nicht nach {}-Blcken suchen
      {
       if(*t=='{')
	bc++;
       if(*t=='}')
	bc--;
      }
     if(*t=='"')
      sc =sc ^1;
     if(*t=='\'')
      qc =qc ^1;

     //     printf("%s -> %s  /%d %d %d\n",txt,t,qc,sc,bc);
     if(sc==0 && qc==0 && bc==0)// In "" '' {}-Blcken  nicht nach WS suchen
      if(*t==' ' || *t=='\t')
       {
	//	printf("WS! %p %p\n",s,t);
	if(t==s)             // Falls t auf den Nachfolger des letzten tp zeigt (d.h. meherer WS hinter einander
	 {                   // verschiebe den letzten tp nur , sonst lege einen neunen an
	  tp[i-1]=t;
	  s=t+1;
	  //	  printf("shifting\n");
	 }
	else
	 {
	  tp[i]=t;
	  //	  printf("spliiting %d\n",i);
	  i++;
	  if(i==max)
	   break;
	  s=t+1;
	 }
       }	
    }
  }

//  for(i=0;i<anz;i++)
//   printf("%2d: '%s'\n",i,tp[i]);
 anz=i;
//   for(i=0;i<anz;i++)
//    printf("%2d: '%s'\n",i,tp[i]);
 for(i=0;i<anz;i++)
  {
   s=skip2nonWS(tp[i]);
   if(s==NULL)
    anz=i;
   else
    {
     tp[i]=s;
     s--;
     if(s>=txt)
      *s='\0';
    }
  }
//   for(i=0;i<anz;i++)
//    printf("%2d: '%s'\n",i,tp[i]);
 for(i=0;i<anz;i++)
  {
   //   printf("%2d: %c\n",i,*s);
   s=tp[i];
   if(*s=='{')
    {
     tp[i]=s+1;
     s=strrchr(tp[i],'}');
     *s='\0';
    }
   if(*s=='"')
    {
     tp[i]=s+1;
     s=strrchr(tp[i],'"');
     *s='\0';
    }
   if(*s=='\'')
    {
     tp[i]=s+1;
     s=strrchr(tp[i],'\'');
     *s='\0';
    }
  }


 if (anz >0)
  {
   s=tp[anz-1]+strlen(tp[anz-1])-1;
   while (*s== ' ' || *s =='\t')
    s--;
   s++;
   *s='\0';
  }
//  for(i=0;i<anz;i++)
//   printf("%2d: '%s'\n",i,tp[i]);
 return(anz);
}

void exportDate(Date *d,char *file)
{
 FILE *fp;
 int i;

 fp=fopen(file,"w");
 
 fprintf(fp,"TERMIN           : %s\n",d->descr);
 fprintf(fp,"Zeit             : %d %6.2f - %d %6.2f\n",d->startDate,(float)d->startTime/100,d->stopDate,(float)d->stopTime/100);
 fprintf(fp,"eingetragen durch: %s/%d\n",userList[d->init.id].name,d->init.id);
 fprintf(fp,"Teilnehmer:        ");
 if(d->partAnz>0)
  for(i=0;i<d->partAnz; i++)
   fprintf(fp,"%c %s/%d ",d->part[i].typ,id2string(d->part[i].id),d->part[i].id);
 else
  fprintf(fp,"N/A");
 fprintf(fp,"\n");
 fprintf(fp,"Erluterung     : %s\n",d->descr+d->tlen);
 fclose(fp);
}

char * id2string(int id)
{
 static char str[1024];
 if(id>=ADDRESOFFSET && id<=MAX_ID)
  aid2name(id,str);
 else if (id>=ROOMOFFSET)
  strcpy(str,roomList[id-ROOMOFFSET].name);
 else if (id>=GROUPOFFSET)
  strcpy(str,groupList[id-GROUPOFFSET].name);
 else 
  strcpy(str,userList[id].name);
 return(str);
}


void writeDates()
{
 FILE *fp;
 char file[4096],file2[4100];
 int i,j,r,rtim;
 ReminderControl *rctrl[512];

 sprintf(file,"%s/dates",dataDir);
 sprintf(file2,"%s.bak",file);
 rename(file,file2);
 usleep(500);
 fp=fopen(file,"w");
 if(fp==NULL)
  {
   printf("can't open %s\n",file);
   exit(-1);
  }
 for(i=0;i<dateAnz; i++)
  if(dateList[i]!=NULL)
   if(! dateList[i]->deleted)
    {
#ifdef V0372
     for(r=0;r<dateList[i]->remAnz ; r++)
      {
       rctrl[r]=dateList[i]->reminder[r].ct.ctrl;
       if (dateList[i]->reminder[r].ct.ctrl !=NULL)
	{
	 rtim = dateList[i]->reminder[r].ct.ctrl->lastSendTim;
	 dateList[i]->reminder[r].ct.tim = rtim;
	}
       else
	printf("Reminder %d of Date %s/%s has now controll\n",r,dateList[i]->id,dateList[i]->descr);
      }
#endif
     fwrite(dateList[i],sizeof(Date),1,fp);
#ifdef V0372
     for(r=0;r<dateList[i]->remAnz ; r++)
      {
       if (rctrl[r] !=NULL)
	dateList[i]->reminder[r].ct.ctrl = rctrl[r];
      }
#endif
    }
 fclose(fp);

#ifdef V037
 sprintf(file,"%s/dates.shift",dataDir);
 sprintf(file2,"%s.bak",file);
 rename(file,file2);
 usleep(500);
 fp=fopen(file,"w");
 if(fp==NULL)
  {
   printf("can't open %s\n",file);
   exit(-1);
  }
 for(i=0;i<dateShiftAnz; i++)
  if(dateShiftList[i]!=NULL)
   fwrite(dateShiftList[i],sizeof(DateShift),1,fp);

 fclose(fp);

#endif

#ifdef V038
 for (i=0; i<userAnz; i++)
  {
   if(userList[i].id==i)
    if(userList[i].dmodiDirty)
     {
      sprintf(file,"%s/userData/%d.usrmod",dataDir,i);
      fp = fopen(file,"w");
      if(verbose)
       printf("Write usermodification for %d/%s\n",i,userList[i].name);
      for(j=0;j<userList[i].dmodiAnz; j++)
       if(userList[i].dmodi[j].did>=0)
	{
	 if(verbose)
	  printf("writing mod #%d of %s for date #%d\n",j,userList[i].name,userList[i].dmodi[j].did);
	 fwrite(&userList[i].dmodi[j],sizeof(UserDateModification),1,fp);
	}
      else
       {
	if(verbose)
	 printf("skipping wiped out mod #%d of %s (date is %d)\n",j,userList[i].name,userList[i].dmodi[j].did);
       }
      userList[i].dmodiDirty =false;
      fclose(fp);
     }
  }
#endif
}

int readDates()
{
 FILE *fp;
 char file[4096];
 int i,anz,j,r;
 struct stat fstat;
 Date *d;
 int dateCount;

 sprintf(file,"%s/dates",dataDir);
 if((i=stat(file,&fstat))<0)
  {
   if(errno == ENOENT)
    {
     fp=fopen(file,"w");
     fclose(fp);
     if(stat(file,&fstat)<0)
      {
       printf("Can't open or create %s\n",file);
       exit(-1);
      }
    }
   else
    {
     char msg[1024];
     perror("");
     printf("Bad file  %s \n",file);
     exit(-1);
    }
  }
 
 dateAnz = (fstat.st_size/sizeof(Date));
 printf("reading %d dates (%d)\n",dateAnz,i);
 if(dateAnz==0)
  return(0);
 
 while(dateAnz>dateMax)
  extendDateList();

 fp=fopen(file,"r");
 if(fp==NULL)
  {
   printf("can't open %s\n",file);
   exit(-1);
  }

 d= new Date [dateAnz];
 fread(d,sizeof(Date),dateAnz,fp);
 fclose(fp);

 maxDid=dateAnz;
 for(i=0;i<dateAnz; i++)
  {
   int did;
   did = d[i].id;
   if(did>dateMax)
    extendDateList();
   if(did>maxDid)
     maxDid=did;
   dateList[did] = d +i; 
  }
 dateCount=dateAnz;
 dateAnz =maxDid+1;

 sortDateList(dateList,dateAnz);
 printf("\t\t\t\t %d date read\n",dateAnz);

 for(i=0;i<dateCount; i++)
  {
   for(j=0;j<d[i].partAnz; j++)
    addDate2Calendar(d+i,d[i].part[j].id);
   addDate2RoomCalendar(d+i,d[i].room);
   
#ifdef V0372
   for(r=0;r<REMINDERS_IN_DATE ; r++)
    {
     if(r<d[i].remAnz)
      {
       int lst = d[i].reminder[r].ct.tim;
       d[i].reminder[r].ct.ctrl = new ReminderControl;
       d[i].reminder[r].ct.ctrl->lastSendTim = lst;
      }
     else
	d[i].reminder[r].ct.ctrl=NULL;
    }
#else
   for(j=0;j<REMINDERS_IN_DATE; j++)
    d[i].reminder[j].ctrl=NULL;
#endif
   
   recalcReminder(d+i);
#ifdef V037
//    printf("init shift for %d\n",i);
   initDateShiftList(d+i);
#endif
  }
#ifdef V037
 printf("reading shifts\n");
 readDateShifts();
#endif
#ifdef V038
 for (i=0; i<userAnz; i++)
  {
   if(userList[i].id==i)
    {
     sprintf(file,"%s/userData/%d.usrmod",dataDir,i);
     fp = fopen(file,"r");
     //     printf("checking date modi for user %d (%s->%p)\n",i,file,fp);
     if(fp !=NULL)
      {
       if(stat(file,&fstat)==0)
	{
	 anz = (fstat.st_size/sizeof(UserDateModification));
	 while(anz > userList[i].dmodiMax)
	  extendDateUserModification(&userList[i]);
	 fread(userList[i].dmodi,sizeof(UserDateModification),anz,fp);
	 userList[i].dmodiAnz=anz;
	}
       else
	{
	 printf("error reading user modifications for user %d/%s\n",i,userList[i].name);
	}
      }
    }
  }
#endif
}
#ifdef V037
int readDateShifts()
{
 FILE *fp;
 char file[4096];
 int i,anz,j;
 struct stat fstat;
 DateShift *dsh;
 Date *d;


 sprintf(file,"%s/dates.shift",dataDir);
 if((i=stat(file,&fstat))<0)
  {
   if(errno == ENOENT)
    {
     fp=fopen(file,"w");
     fclose(fp);
     if(stat(file,&fstat)<0)
      {
       printf("Can't open or create %s\n",file);
       exit(-1);
      }
    }
   else
    {
     char msg[1024];
     perror("");
     printf("Bad file  %s \n",file);
     exit(-1);
    }
  }
 // printf("%d\n",fstat.st_size);
 
 dateShiftAnz = (fstat.st_size/sizeof(DateShift));
 printf("reading %d shifts \n",dateShiftAnz);
 if(dateShiftAnz==0)
  return(0);
 
 while(dateShiftAnz>dateShiftMax)
  extendDatShiftMasterList();

 fp=fopen(file,"r");
 if(fp==NULL)
  {
   printf("can't open %s\n",file);
   exit(-1);
  }

 dsh= new DateShift [dateShiftAnz];
 fread(dsh,sizeof(DateShift),dateShiftAnz,fp);
 fclose(fp);

 // for(i=0;i<dateShiftAnz; i++)

 for(i=0;i<dateShiftAnz; i++)
  {
   d =dateList[dsh[i].did];
   if(d !=NULL)
    {
     //     printf("got date shift for date %d\n",dsh[i].did);
     dateShiftList[i]=dsh+i;
     d->shifts[d->dateShiftAnz] = dsh+i;
     d->dateShiftAnz ++;
     if(d->dateShiftAnz >d->dateShiftMax)
      extendDateShiftList(d);
    }
   else
    printf("ignoring DateShift for non existing date %d\n",dsh->did);
  }

 for(i=0;i<dateAnz; i++)
  {
   d= dateList[i];
   if(d!=NULL)
    if(d->dateShiftAnz>0)
     
     qsort(d->shifts,d->dateShiftAnz,sizeof(DateShift *),compareDateShiftsByDate);
  }
}
#endif

void addDate2Calendar(Date*d, int id)
{
 if(id<ADDRESOFFSET)
  {
   if(id>=ROOMOFFSET)
    addDate2RoomCalendar(d,id-ROOMOFFSET);
   else if(id>=GROUPOFFSET)
    addDate2GroupCalendar(d,id-GROUPOFFSET);
   else 
    addDate2UserCalendar(d,id);
  }
}
int addDate2RoomCalendar(Date *d, int uid)
{
 if(uid >roomAnz)
  return(0);

 if(roomList[uid].id<0)
  return(0);
 
//  printf("adding Date %d to Room %s\n",d->id,roomList[uid].name);
 roomList[uid].cal.list[ roomList[uid].cal.anz] = d;
 roomList[uid].cal.anz++;
 if(roomList[uid].cal.anz >=  roomList[uid].cal.max)
  extendCalList(&roomList[uid].cal);
}
int addDate2UserCalendar(Date *d, int uid)
{
 Date *t;
 int i;
 if(uid >userAnz)
  return(0);
 if(userList[uid].id<0)
  return(0);
 for(i=0;i<userList[uid].cal.anz; i++)
  if(userList[uid].cal.list[ i] == d)
   return(0);


//  printf("\t\t add to %d/%s\n",uid,userList[uid].name);
 userList[uid].cal.list[ userList[uid].cal.anz] = d;
 userList[uid].cal.anz++;
 if(userList[uid].cal.anz >=  userList[uid].cal.max)
  extendCalList(&userList[uid].cal);
}
int addDate2GroupCalendar(Date *d, int gid)
{
 int i;
 if(gid >groupAnz)
  return(0);
 if(groupList[gid].id<0)
  return(0);

 for(i=0;i< groupList[gid].anz; i++)
  addDate2UserCalendar(d,groupList[gid].membr[i]);

 for(i=0;i<groupList[gid].cal.anz; i++)
  if(groupList[gid].cal.list[ i] == d)
   return(0);
//  printf("\t\t add to %d/%s\n",gid,groupList[gid].name);
 groupList[gid].cal.list[ groupList[gid].cal.anz] = d;
 groupList[gid].cal.anz++;
 if(groupList[gid].cal.anz >=  groupList[gid].cal.max)
  extendCalList(&groupList[gid].cal);
}


void sortDateList(Date **list,int anz)
{
 // qsort(list,anz,sizeof(Date *),compareDateByStartTime);
}

int compareDateByStartTime(const void * p1,const void *p2)
{
 Date *d1,*d2,**h1,**h2;

 h1= (Date **) p1;
 h2= (Date **) p2;
 d1= *h1;
 d2= *h2;
 
 if( d1->startDate < d2->startDate)
  return(-1);
 else if ( d1->startDate > d2->startDate)
  return(1);
 else
  {
   if( d1->startTime < d2->startTime)
    return(-1);
   else if ( d1->startTime > d2->startTime)
    return(1);
   else
    return(0);
  }
 return(0);
}
#ifdef V038
int suspendReminder(int socket,char *str)
{
 UserDateModification *umodi;
 int did,uid,stat;
 int anz;
 char *tp[64];
 
 
 anz = split(str,tp,64);

 did = atoi(tp[0]);
 if(dateList[did]==NULL)
  {
   send2Client(socket,"Error: no such date");
   return(-1);
  }

 uid = uname2uid(tp[1]);
 if(uid<0 || uid> userAnz)
  {
   send2Client(socket,"Error: no such user");
   return(-1);
  }
 stat =atoi(tp[2]);
 
 umodi=getUserModification4Date(did,uid);
 if(umodi==NULL)
  {
   umodi = &userList[uid].dmodi[userList[uid].dmodiAnz];
   userList[uid].dmodiAnz ++;
   if(userList[uid].dmodiAnz > userList[uid].dmodiMax)
    extendDateUserModification(&userList[uid]);
   initDateUserModification(umodi);
  }
 umodi->did = did;
 if(stat==1)
  umodi->noReminder = true;
 else
  umodi->noReminder = false;
 userList[uid].dmodiDirty=true;
 send2Client(socket,"done");
}
int ignoreDate(int socket,char *str)
{
 UserDateModification *umodi;
 int did,uid,stat;
 int anz;
 char *tp[64];
 
 
 anz = split(str,tp,64);

 did = atoi(tp[0]);
 if(dateList[did]==NULL)
  {
   send2Client(socket,"Error: no such date");
   return(-1);
  }

 uid = uname2uid(tp[1]);
 if(uid<0 || uid> userAnz)
  {
   send2Client(socket,"Error: no such user");
   return(-1);
  }
 stat =atoi(tp[2]);

 umodi=getUserModification4Date(did,uid);
 if(umodi==NULL)
  {
   umodi = &userList[uid].dmodi[userList[uid].dmodiAnz];
   userList[uid].dmodiAnz ++;
   if(userList[uid].dmodiAnz > userList[uid].dmodiMax)
    extendDateUserModification(&userList[uid]);
   initDateUserModification(umodi);
  }
 umodi->did = did;
 if(stat==1)
  umodi->ignored = true;
 else
  umodi->ignored = false;
 userList[uid].dmodiDirty=true;
 send2Client(socket,"done");
}
#endif
#ifdef V037
DateShift *getDateShift4Date(Date *d, int date, int stime,int create);
int compareDateShiftsByDate(const void *v1, const void * v2);

DateShift *getDateShift4Date(Date *d, int date, int stime,int create)
{
 int i;
 DateShift *dsh;

 for(i=0;i< d->dateShiftAnz; i++)
  if(d->shifts[i]->refDate ==date)
   if(d->shifts[i]->refTime ==stime)
    return(d->shifts[i]);
 
 if(create)
  {
   //   printf("creating new Shift for Date '%s'\n",d->descr);
   dsh = new DateShift;
   if(dsh==NULL)
    return(NULL);
   dsh->did  = d->id;
   dsh->deleted = false;
   dsh->refDate =dsh->startDate =dsh->stopDate =0;
   dsh->refTime =dsh->startTime =dsh->stopTime =0;
   dsh->room =-1;
   strcpy(dsh->addDetails,"");
   for(i=0;i< PARTANZ_IN_DATE;i++)
    dsh->partStatus[i]=0;

   d->shifts[d->dateShiftAnz] = dsh;
   d->dateShiftAnz ++;
   if (d->dateShiftAnz > d->dateShiftMax)
    extendDateShiftList(d);
   
   dateShiftList[dateShiftAnz]=dsh;
   dateShiftAnz++;
   if (dateShiftAnz > dateShiftMax)
    extendDatShiftMasterList();
   
   qsort(d->shifts,d->dateShiftAnz,sizeof(DateShift *),compareDateShiftsByDate);
  }
 else
  dsh =NULL;
 return(dsh);
}

int compareDateShiftsByDate(const void *v1, const void * v2)
{
 DateShift *dsh1,*dsh2;

 dsh1 = *((DateShift **) v1) ;
 dsh2 = *((DateShift **) v2) ;
 if( dsh1->startDate < dsh2->startDate)
  return(-1);
 else if ( dsh1->startDate > dsh2->startDate)
  return(1);
 else
  {
   if( dsh1->startTime < dsh2->startTime)
    return(-1);
   else if ( dsh1->startTime > dsh2->startTime)
    return(1);
   else
    return(0);
  }
 return(0);
}


// TCl Binding
// shiftDate did refDate refTime  startDate startTime stopdate stopTime room 'details'
//
int shiftDate(int socket, char * str)
{
 char *tp[64];
 int anz;
 int did,refDate,refTime;
 DateShift *dsh;
 Date *d;

 anz = split(str,tp,64);
 did = atoi(tp[0]);
 refDate = atoi(tp[1]);
 refTime = atoi(tp[2]);
 d = dateList[did];

 // Fixme intelligentes Modifiy
 dsh = getDateShift4Date(d,refDate,refTime,true);
 if(dsh == NULL)
  {
   send2Client(socket,"Error: No matching shift or can't create shift\n");
  }
 dsh->startDate = atoi(tp[3]);
 dsh->startTime = atoi(tp[4]);
 dsh->stopDate  = atoi(tp[5]);
 dsh->stopTime  = atoi(tp[6]);
 dsh->room = rname2rid(tp[7]);
 if(dsh->refDate ==0)
  {
   dsh->refDate   = refDate;
   dsh->refTime   = refTime;
  }
 strncpy(dsh->addDetails,tp[8],127);
 dsh->addDetails[127] = '\0';
 send2Client(socket,"done");
}

int getShiftDateInfo(int socket, char *str)
{
 char *tp[64], line[1024];
 int anz;
 int did,refDate,refTime;
 DateShift *dsh;
 Date *d;
 CalendarItem ci,wci;

 anz = split(str,tp,64);
 did = atoi(tp[0]);
 refDate = atoi(tp[1]);
 refTime = atoi(tp[2]);
 d = dateList[did];

 dsh =  getDateShift4Date(d,refDate,refTime,false);
 if( dsh == NULL)
  {
   initCalendarItem(d ,&ci);
   memcpy(&wci,&ci,sizeof(CalendarItem));
   while( ci.startDate!=refDate || ci.startTime != refTime)
    {
     if(!skip2next(&ci,d))
      {
       send2Client(socket,"Err: No such Date");
       return(-1);
      }
    }
   sprintf(line,"{%s} %d %d %d %d %s {}",d->descr,ci.startDate,ci.startTime,ci.stopDate,ci.stopTime,roomList[d->room].name);
  }
 else
    sprintf(line,"{%s} %d %d %d %d %s {%s}",d->descr,dsh->startDate,dsh->startTime,dsh->stopDate,dsh->stopTime,roomList[dsh->room].name,dsh->addDetails);
 send2Client(socket,line);
}

//TCL-Binding
// changeStatus did refdate refTime uid status-code
int changeDateStatus4User(int socket, char * str)
{
 char *tp[64];
 int anz;
 int did,refDate,refTime,uid,i;
 DateShift *dsh;
 Date *d;
 char *ug;

 anz = split(str,tp,64);
 did = atoi(tp[0]);
 refDate = atoi(tp[1]);
 refTime = atoi(tp[2]);
 d = dateList[did];
 ug  = tp[5]; 

 if(d->repeatTyp == NO_REPEAT)
  {
   if(*ug == 'u')
    uid = uname2uid(tp[3]); 
   else if (*ug == 'g')
    uid = gname2gid(tp[3]); 
   else 
    uid =-1;
   for(i=0;i<d->partAnz; i++)
    if(d->part[i].id == uid)
     {
      d->part[i].status = atoi(tp[4]);
      break;
     }
  }
 else
  {
   uid = uname2uid(tp[3]); 
   dsh = getDateShift4Date(d,refDate,refTime,true);
   for(i=0;i<d->partAnz; i++)
    if(d->part[i].id == uid)
     {
      dsh->partStatus[i] = atoi(tp[4]);
      if(dsh->refDate ==0)
       {
	dsh->refDate =refDate;
	dsh->refTime =refTime;
       }
      break;
     }
  }
 send2Client(socket,"done");
}

//TCL-Binding
// suspendDate did username refdate refTime 
int suspendDate(int socket, char * str)
{
 char *tp[64];
 int anz;
 int did,refDate,refTime,uid,i;
 DateShift *dsh;
 // Date *d;

 // printf("SUSPEND: %s\n",str);
 anz = split(str,tp,64);
 did = atoi(tp[0]);
 uid = uname2uid(tp[1]);
 if(uid<0)
  {
   send2Client(socket,"ERR Permission denied");
   return(-1);
  }
 refDate = atoi(tp[2]);
 refTime = atoi(tp[3]);

 dsh = getDateShift4Date(dateList[did],refDate,refTime,true);
 dsh->deleted =true;
 dsh->refDate = refDate;
 dsh->refTime = refTime;
 send2Client(socket,"done");
}

#endif

int getBlockedTimes(int socket,char *str)
{
 char *tp[8],*tp2[1024];
 int id;
 Calendar *cal;
 char buffer[16384];
 int startDay,stopDay;
 int i,anz,n,m;
 
 split(str,tp,8);

 startDay = atoi(tp[0]);
 stopDay  = atoi(tp[1]);
 strcpy(buffer,"");

 anz = split(tp[2],tp2,1023);
 for(n=0 ; n<anz ; n+=2)
  {
   m=n+1;
   if ( tp2[n][0] == 'g')
    {
     id=gname2gid(tp2[m]);
     if(id<0)
      {
       printf("getBlockedTimes: group '%s' unknown\n",tp2[m]);
       continue;
      }
     else
      cal    = & userList[id].cal;
    }
   else if( tp2[n][0] == 'r')
    {
     id=rname2rid(tp2[m]);
     if(id<0)
      {
       printf("getBlockedTimes: room '%s' unknown\n",tp2[m]);
       continue;
      }
     else
      cal    = & roomList[id].cal;
    }
   else if ( tp2[n][0] == 'a')
    continue;
   else 
    {
     id=uname2uid(tp2[m]);
     if(id<0)
      {
       printf("getBlockedTimes: user '%s' unknown\n",tp2[m]);
       continue;
      }
     else
      cal= & userList[id].cal;
    }
   strcat(buffer,"{ ");
   getBlockedTimes4User(startDay,stopDay,cal,buffer);
   strcat(buffer," } ");
  }
 send2Client(socket,buffer);
}



int getBlockedTimes4User(int startDay,int stopDay,Calendar *cal, char *buffer)
{
 int i,start,stop,tstop,tstart;
 char tx[1024];
 CalendarItem ci;


 for(i=0;i<cal->anz ; i++)
  {
   if( ! cal->list[i]->deleted )
    if( (cal->list[i]->flags & DATE_FLAG_NOTIME) == 0)
     if( (cal->list[i]->flags & DATE_FLAG_NONBLOCK) == 0)
      {
      //     start=cal->list[i]->startDate;
      //     stop =cal->list[i]->stopDate;
     //FIXME wiederholungtermine
//      printf("checking entry %d %d ... %d\n",i,start,stop);
       ci.startDate=cal->list[i]->startDate;
       ci.startTime=cal->list[i]->startTime;
       ci.stopDate =cal->list[i]->stopDate;
       ci.stopTime =cal->list[i]->stopTime;
       ci.count=0;
       ci.startwDay=weekDayByDate(ci.startDate);
       while(ci.stopDate<startDay)
	if(!skip2next(&ci,cal->list[i]))
	 break;
       start =ci.startDate;
       stop  =ci.stopDate;

       while( start<= stopDay && stop>=startDay)
	//     if( start<= stopDay && stop>=startDay)
	{
	 if(start<startDay)
	  {
	   start=startDay;
	   tstart=0;
	  }
	 else
	  tstart = cal->list[i]->startTime;
	 if(stop>stopDay)
	  {
	   stop=stopDay;
	   tstop=24;
	  }
	 else
	  tstop = cal->list[i]->stopTime;
       
	 sprintf(tx,"{%d %d %d %d} ",start,tstart,stop,tstop);
	 strcat(buffer,tx);

	 if(!skip2next(&ci,cal->list[i]))
	  break;
	 start =ci.startDate;
	 stop  =ci.stopDate;
	}
    }
  }
}


void getUserCal(char *str,int socket)
{
 int uid,start,stop,igno,cid,wuc,ignoInfo;
 char *tp[8];

 //printf("Getting Calendar\n");
 split(str,tp,8);
 uid = uname2uid(tp[0]);
 start = atoi(tp[2]);
 stop  = atoi(tp[3]);
 igno  = atoi(tp[4]);
 ignoInfo =atoi(tp[5]);
 if(uid<0)
  send2Client(socket,"ERR: user unknown");
 else 
  { 
   strTrim(tp[1]);
   cid = uname2uid(tp[1]);
   if(cid>=0)
    sendUserCal(socket,uid,cid,start,stop,igno,ignoInfo);
   else 
    {
     cid = gname2gid(tp[1]);
     if(cid>=0)
      {
       wuc=false;
       if (atoi(tp[6])==1)
	wuc=true;
       //       wuc=true;
       sendGroupCal(socket,uid,cid,start,stop,igno,wuc,ignoInfo);
      }
     else 
      {
       cid = rname2rid(tp[1]);
       if(cid>=0)
	sendRoomCal(socket,uid,cid,start,stop,igno,ignoInfo);
       else 
	send2Client(socket,"ERR: no such user ");
      }
    }
  }
}

UserInDate * findUserInDate(Date *d,int uid)
{
 int i;
 for(i=0;i<d->partAnz; i++)
  {
   if(d->part[i].id==uid)
    return(&d->part[i]);
  }
 return(NULL);
}


int nextDateAfterNow(CalendarItem *ci,Date *d)
{
 char tstr[64],*t;
 int heute,jetzt;
 CalendarItem wci;
 int ret;

 time_t tim=time(NULL);
 strftime(tstr,255,"%Y%m%d %H%M",localtime(&tim));0;   
 t=strchr(tstr+4,' ');
 if(t!=NULL)
  *t='\0';
 heute = atoi(tstr);
 jetzt = atoi(t+1);
 ret = nextDateAfterDate(ci,&wci,d,heute,0);
 // printf("next afternow: %d / %d\n",ci->startDate,wci.startDate);
 memcpy(ci,&wci,sizeof(CalendarItem));
 return( ret);
}
int nextDateAfterDate (CalendarItem *ci,CalendarItem *wci,Date *d, int datum, int tim)
{
 char tstr[64],*t;

 ci->startDate=d->startDate;
 ci->startTime=d->startTime;
 ci->stopDate =d->stopDate;
 ci->stopTime =d->stopTime;
 ci->count=0;
 ci->startwDay = weekDayByDate(ci->startDate);
 d->dateShiftPtr=0;
 memcpy(wci,ci,sizeof(CalendarItem));

 while(true)
  {
   //   printf("\nchecking %d/%d\n",ci->startDate,wci->startDate);
   if(wci->startDate>datum || (wci->startDate==datum && wci->startTime > tim))
    return(true);
   if( ! skip2next(ci,wci,d))
     break;
  }
 return(false);
}
#ifdef V037
int skip2next(CalendarItem *ici,CalendarItem *oci,Date *d)
{
 CalendarItem *ci;

 do
  {
   if(!skip2next(ici,d))
    return(false);
   ci = shiftDateIfNeeded(ici,oci,d);
  }while(ci == NULL);
 return(true);
}
#endif

int skip2next(CalendarItem *ci,Date *d)
{
 char otyp[8]="hdwmy";
 char wds[8][8]={"Mo","Di","Mi","Do","Fr","Sa","So"};
 int wc,wd;

 ci->count++;
 if(ci->count >  d->repeatCount && d->repeatCount >0)
  return(false);

 if(ci->startDate <0  || ci->stopDate<0 || (ci->startDate % 10000 > 1231) || (ci->stopDate % 10000 > 1231) )
  {
   printf("Strange Date(s) : %d %d; skipping repaet \n", ci->startDate,ci->stopDate);
   return(false);
   
  }

 switch(d->repeatTyp)
  {
  case NO_REPEAT:
   return(false);
   break;
  case REPEAT_TAGL:
   calcDate(&ci->startDate,&ci->startTime,1,0,'d');
   calcDate(&ci->stopDate ,&ci->stopTime ,1,0,'d');
   break;
  case REPEAT_WTAGL:
   do
    {
     calcDate(&ci->startDate,&ci->startTime,1,0,'d');
     calcDate(&ci->stopDate ,&ci->stopTime ,1,0,'d');
     ci->startwDay ++;
     if(ci->startwDay>6)
      ci->startwDay-=7;
    }while(ci->startwDay>4);
   break;
  case REPEAT_WOCHE:
   calcDate(&ci->startDate,&ci->startTime,1,0,'w');
   calcDate(&ci->stopDate ,&ci->stopTime ,1,0,'w');
   break;
  case REPEAT_MONAT:
   calcDate(&ci->startDate,&ci->startTime,1,0,'M');
   calcDate(&ci->stopDate ,&ci->stopTime ,1,0,'M');
   break;
  case REPEAT_ALLE:
   calcDate(&ci->startDate,&ci->startTime,d->repeatIntervall,0,otyp[d->repeatUnit]);
   calcDate(&ci->stopDate, &ci->stopTime, d->repeatIntervall,0,otyp[d->repeatUnit]);
   break;
  case REPEAT_JEDEN: 
   getWeekDayInMonth(&wc,&wd,ci->startDate);
   calcDate(&ci->startDate,&ci->startTime,1,0,'M');
   ci->startDate = getCountedWeekDayDatum(wc,wd,ci->startDate);
//    printf("old date was %d. %s new is %d\n",wc+1,wds[wd],ci->startDate);
   

   getWeekDayInMonth(&wc,&wd,ci->stopDate);
   calcDate(&ci->stopDate ,&ci->stopTime ,1,0,'M');
   ci->stopDate = getCountedWeekDayDatum(wc,wd,ci->stopDate);
   break;
  }
 return(true);
}
#ifdef V037
CalendarItem *shiftDateIfNeeded(CalendarItem *ici,CalendarItem *oci,Date *d)
{
 DateShift *dsh;

 if(d->dateShiftPtr < d->dateShiftAnz)
  {
   dsh = d->shifts[d->dateShiftPtr];
   if(ici->startDate == dsh->refDate && ici->startTime == dsh->refTime)
    {
     if(dsh->deleted)
      return(NULL);
     oci->startDate = dsh->startDate;
     oci->startTime = dsh->startTime;
     oci->stopDate = dsh->stopDate;
     oci->stopTime = dsh->stopTime;
     d->dateShiftPtr++;
    }
   else
    memcpy(oci,ici,sizeof(CalendarItem));
  }
 else
  memcpy(oci,ici,sizeof(CalendarItem));
 return(oci);
}
#endif


#ifdef V037
void initCalendarItem(Date *d ,CalendarItem *ci)
{
 ci->startDate=d->startDate;
 ci->startTime=d->startTime;
 ci->stopDate =d->stopDate;
 ci->stopTime =d->stopTime;
 ci->count=0;
 ci->startwDay=weekDayByDate(ci->startDate);
 d->dateShiftPtr =0;
}

void sendUserCal(int socket, int uid,int cid, int startDay, int stopDay,int igno,int ignoInfo)
{
 char buffer[16384],tx[1024];
 int start,stop;
 int tstart,tstop;
 int notime;
 int i,status,perm;
 int privatDateIsClosed2Me;
 UserInDate *self;
 CalendarItem ci,wci;

 strcpy(buffer,"");
 sortDateList(userList[cid].cal.list,userList[cid].cal.anz);
 for(i=0;i<userList[cid].cal.anz ; i++)
  {
   if( ! userList[cid].cal.list[i]->deleted )
    {
#ifdef V038
     if(ignoInfo == 1)
      if(dateOnlyAsInfo(userList[cid].cal.list[i],uid))
       continue;
#endif
     self=findUserInDate(userList[cid].cal.list[i],uid);
     if(self != NULL)
      status = self->status ;
     else
      status =0;
     
     privatDateIsClosed2Me = dateIs2Privat2Me(userList[cid].cal.list[i],uid);
     perm = getPermission(userList[cid].cal.list[i],uid,cid);
#ifdef V038
     if( !dateIsIgnoredByMe(userList[cid].cal.list[i]->id,uid) || igno == 1)
#else
     if( status != DATE_STAT_IGNORIEREN || igno ==1)  // FIXME Permissions
#endif
      if( (perm & READ_TIMES) == READ_TIMES )
       if(!privatDateIsClosed2Me)
	{
	 ci.startDate=userList[cid].cal.list[i]->startDate;
	 ci.startTime=userList[cid].cal.list[i]->startTime;
	 ci.stopDate =userList[cid].cal.list[i]->stopDate;
	 ci.stopTime =userList[cid].cal.list[i]->stopTime;
	 ci.count=0;
	 ci.startwDay=weekDayByDate(ci.startDate);
	 memcpy(&wci,&ci,sizeof(CalendarItem));
	 userList[cid].cal.list[i]->dateShiftPtr =0;
	 if(wci.stopDate<startDay)
	  {
	   while(wci.stopDate<startDay)
	    if(!skip2next(&ci,&wci,userList[cid].cal.list[i]))
	     break;
	  }
	 else 
	   shiftDateIfNeeded(&ci,&wci,userList[cid].cal.list[i]);
	 start =wci.startDate;
	 stop  =wci.stopDate;
	 while( start<= stopDay && stop>=startDay)
	  {
	   if(start<startDay)
	    {
	     start=startDay;
	     tstart=0;
	    }
	   else
	    //	    tstart = userList[cid].cal.list[i]->startTime;
	    tstart = wci.startTime;
	   if(stop>stopDay)
	    {
	     stop=stopDay;
	     tstop=2359;
	    }
	   else
	    tstop  = wci.stopTime;
	   //	    tstop = userList[cid].cal.list[i]->stopTime;
	   
	   notime = (userList[cid].cal.list[i]->flags & DATE_FLAG_NOTIME) >> DATE_FLAG_NOTIME_SHIFT;
	   if( (perm & READ_HEADS) == READ_HEADS )
	    sprintf(tx,"{%d %d %d %d %d \"%s\" %d %d %d} ",
		    start,tstart,stop,tstop,notime,userList[cid].cal.list[i]->descr,userList[cid].cal.list[i]->id,
		    userList[cid].cal.list[i]->repeatTyp,userList[cid].cal.list[i]->priority);
	   else
	    sprintf(tx,"{%d %d %d %d %d \"%s\" %d %d %d} ",
		    start,tstart,stop,tstop,notime," ",userList[cid].cal.list[i]->id,
		    userList[cid].cal.list[i]->repeatTyp,userList[cid].cal.list[i]->priority);
	   
	   strcat(buffer,tx);

	   if(!skip2next(&ci,&wci,userList[cid].cal.list[i]))
	    break;
	   start =wci.startDate;
	   stop  =wci.stopDate;
	  }
      }
    }
  }
//  printf("send User Cal '%s'\n",buffer);
 send2Client(socket,buffer);
}
void sendGroupCal(int socket, int uid,int cid, int startDay, int stopDay,int igno,int withUserDates,int ignoInfo)
{
 char buffer[250000],tx[1024];
 int start,stop;
 int tstart,tstop;
 int notime;
 int status,perm;
 int i,privatDateIsClosed2Me;
 UserInDate *self;
 CalendarItem ci,wci;

 strcpy(buffer,"");
 // sortDateList(groupList[cid].cal.list,groupList[cid].cal.anz);
 for(i=0;i<groupList[cid].cal.anz ; i++)
  {
   if( ! groupList[cid].cal.list[i]->deleted )
    {
#ifdef V038
     if(ignoInfo == 1)
      if(dateOnlyAsInfo(groupList[cid].cal.list[i],uid))
       continue;
#endif
     self=findUserInDate(groupList[cid].cal.list[i],uid);
     if(self != NULL)
      status = self->status;
     else
      status= 0; // Wenn der User nur via Gruppe dabei ist

     privatDateIsClosed2Me = dateIs2Privat2Me(groupList[cid].cal.list[i],uid);
     perm = getPermission(groupList[cid].cal.list[i],uid,cid);
#ifdef V038
     if( !dateIsIgnoredByMe(groupList[cid].cal.list[i]->id,uid) || igno == 1)
#else
     if( status != DATE_STAT_IGNORIEREN || igno ==1)  // FIXME Permissions
#endif
      if( (perm & READ_TIMES) == READ_TIMES )
       if(!privatDateIsClosed2Me)
	{
	 ci.startDate=groupList[cid].cal.list[i]->startDate;
	 ci.startTime=groupList[cid].cal.list[i]->startTime;
	 ci.stopDate =groupList[cid].cal.list[i]->stopDate;
	 ci.stopTime =groupList[cid].cal.list[i]->stopTime;
	 ci.count=0;
	 ci.startwDay=weekDayByDate(ci.startDate);
	 groupList[cid].cal.list[i]->dateShiftPtr =0;
	 memcpy(&wci,&ci,sizeof(CalendarItem));
	 if(wci.stopDate<startDay)
	  {
	   while(wci.stopDate<startDay)
	    if(!skip2next(&ci,&wci,groupList[cid].cal.list[i]))
	     break;
	  }
	 else 
	   shiftDateIfNeeded(&ci,&wci,groupList[cid].cal.list[i]);
	 start =wci.startDate;
	 stop  =wci.stopDate;

	 while( start<= stopDay && stop>=startDay)
	  {
	   if(start<startDay)
	    {
	     start=startDay;
	     tstart=0;
	    }
	   else
	    tstart = wci.startTime;
	   //	    tstart = groupList[cid].cal.list[i]->startTime;
	   if(stop>stopDay)
	    {
	     stop=stopDay;
	     tstop=2359;
	    }
	   else
	    tstop = wci.stopTime;
	   //	    tstop = groupList[cid].cal.list[i]->stopTime;
	   
	   notime = (groupList[cid].cal.list[i]->flags & DATE_FLAG_NOTIME) >> DATE_FLAG_NOTIME_SHIFT;
	   if( (perm & READ_HEADS) == READ_HEADS )
	    sprintf(tx,"{%d %d %d %d %d \"%s\" %d %d %d} ",
		    start,tstart,stop,tstop,notime,groupList[cid].cal.list[i]->descr,groupList[cid].cal.list[i]->id,
		    groupList[cid].cal.list[i]->repeatTyp,groupList[cid].cal.list[i]->priority);
	   else
	    sprintf(tx,"{%d %d %d %d %d \"%s\" %d %d %d} ",
		    start,tstart,stop,tstop,notime," ",groupList[cid].cal.list[i]->id,
		    groupList[cid].cal.list[i]->repeatTyp,groupList[cid].cal.list[i]->priority);
	   strcat(buffer,tx);

	   if(!skip2next(&ci,&wci,groupList[cid].cal.list[i]))
	    break;
	   start =wci.startDate;
	   stop  =wci.stopDate;
	  }
	}
    }
  }
 if(withUserDates)
  for(i=0;i<groupList[cid].anz; i++)
   addUserCal2Buffer(uid,groupList[cid].membr[i],cid,startDay,stopDay,igno,buffer,ignoInfo);
//  printf("send group Cal '%s'\n",buffer);
 send2Client(socket,buffer);
}

void addUserCal2Buffer(int uid,int cid,int gid, int startDay, int stopDay,int igno,char *buffer,int ignoInfo)
{
 char tx[1024];
 int start,stop;
 int tstart,tstop;
 int notime;
 int i,status,perm;
 int privatDateIsClosed2Me;
 UserInDate *self;
 CalendarItem ci,wci;

 int j;

 // sortDateList(userList[cid].cal.list,userList[cid].cal.anz);
 for(i=0;i<userList[cid].cal.anz ; i++)
  //   printf ("\tchecking '%s' -> %p\n",userList[cid].cal.list[i]->descr,findUserInDate(userList[cid].cal.list[i],gid+GROUPOFFSET));
  if( ! userList[cid].cal.list[i]->deleted )
   if (findUserInDate(userList[cid].cal.list[i],gid+GROUPOFFSET) == NULL) // Es sollen nur solche Termin addiert 
    { //                                                        werden,in den die Gruppe gid nicht schon vorkommt
#ifdef V038
     if(ignoInfo == 1)
      if(dateOnlyAsInfo(userList[cid].cal.list[i],uid))
       continue;
#endif
     self=findUserInDate(userList[cid].cal.list[i],uid);
     if(self != NULL)
      status = self->status ;
     else
      status =0;
     
     privatDateIsClosed2Me = dateIs2Privat2Me(userList[cid].cal.list[i],uid);
     perm = getPermission(userList[cid].cal.list[i],uid,cid);
#ifdef V038
     if( !dateIsIgnoredByMe(userList[cid].cal.list[i]->id,cid) || igno == 1)
#else
     if( status != DATE_STAT_IGNORIEREN || igno ==1)  
#endif
      if( (perm & READ_TIMES) == READ_TIMES )
       if(!privatDateIsClosed2Me)
	{
	 ci.startDate=userList[cid].cal.list[i]->startDate;
	 ci.startTime=userList[cid].cal.list[i]->startTime;
	 ci.stopDate =userList[cid].cal.list[i]->stopDate;
	 ci.stopTime =userList[cid].cal.list[i]->stopTime;
	 ci.count=0;
	 ci.startwDay=weekDayByDate(ci.startDate);
	 userList[cid].cal.list[i]->dateShiftPtr =0;
	 memcpy(&wci,&ci,sizeof(CalendarItem));
	 if(wci.stopDate<startDay)
	  {
	   while(wci.stopDate<startDay)
	    if(!skip2next(&ci,&wci,userList[cid].cal.list[i]))
	     break;
	  }
	 else 
	  shiftDateIfNeeded(&ci,&wci,userList[cid].cal.list[i]);
	 start =wci.startDate;
	 stop  =wci.stopDate;
	 while( start<= stopDay && stop>=startDay)
	  {
	   if(start<startDay)
	    {
	     start=startDay;
	     tstart=0;
	    }
	   else
	    tstart = wci.startTime;
	   //tstart = userList[cid].cal.list[i]->startTime;
	   if(stop>stopDay)
	    {
	     stop=stopDay;
	     tstop=2359;
	    }
	   else
	    tstop = wci.stopTime;
	   //	   tstop = userList[cid].cal.list[i]->stopTime;
	   
	   notime = (userList[cid].cal.list[i]->flags & DATE_FLAG_NOTIME) >> DATE_FLAG_NOTIME_SHIFT;
	   if( (perm & READ_HEADS) == READ_HEADS )
	    sprintf(tx,"{%d %d %d %d %d \"%s\" %d %d %d} ",
		    start,tstart,stop,tstop,notime,userList[cid].cal.list[i]->descr,userList[cid].cal.list[i]->id,
		    userList[cid].cal.list[i]->repeatTyp,userList[cid].cal.list[i]->priority);
	   else
	    sprintf(tx,"{%d %d %d %d %d \"%s\" %d %d %d} ",
		    start,tstart,stop,tstop,notime," ",userList[cid].cal.list[i]->id,
		    userList[cid].cal.list[i]->repeatTyp,userList[cid].cal.list[i]->priority);
	   
	   strcat(buffer,tx);

	   if(!skip2next(&ci,&wci,userList[cid].cal.list[i]))
	    break;
	   start =wci.startDate;
	   stop  =wci.stopDate;
	  }
	}
    }
}
void sendRoomCal(int socket, int uid, int cid, int startDay, int stopDay,int igno,int ignoInfo)
{
 char buffer[16384],tx[1024];
 int start,stop;
 int tstart,tstop;
 int notime;
 int i,perm;
 UserInDate *self;
 CalendarItem ci,wci;

 strcpy(buffer,"");
 sortDateList(roomList[cid].cal.list,roomList[cid].cal.anz);
//  printf("Cal-size for room %d/%s %d\n",cid,roomList[cid].name,roomList[cid].cal.anz);
 for(i=0;i<roomList[cid].cal.anz ; i++)
  {
   if( ! roomList[cid].cal.list[i]->deleted )
    {
#ifdef V038
     if(ignoInfo == 1)
      if(dateOnlyAsInfo(roomList[cid].cal.list[i],uid))
       continue;
#endif
     perm = getPermission(roomList[cid].cal.list[i],uid,cid);
     if( (perm & READ_TIMES) == READ_TIMES )
      {
       ci.startDate=roomList[cid].cal.list[i]->startDate;
       ci.startTime=roomList[cid].cal.list[i]->startTime;
       ci.stopDate =roomList[cid].cal.list[i]->stopDate;
       ci.stopTime =roomList[cid].cal.list[i]->stopTime;
       ci.count=0;
       ci.startwDay=weekDayByDate(ci.startDate);
       roomList[cid].cal.list[i]->dateShiftPtr =0;
       memcpy(&wci,&ci,sizeof(CalendarItem));
       if(wci.stopDate<startDay)
	{
	 while(wci.stopDate<startDay)
	  if(!skip2next(&ci,&wci,roomList[cid].cal.list[i]))
	   break;
	}
       else 
	shiftDateIfNeeded(&ci,&wci,roomList[cid].cal.list[i]);
       start =wci.startDate;
       stop  =wci.stopDate;

       while( start<= stopDay && stop>=startDay)
	{
	 if(start<startDay)
	  {
	   start=startDay;
	   tstart=0;
	  }
	 else
	  tstart = wci.startTime;
	  //	  tstart = roomList[cid].cal.list[i]->startTime;
	 if(stop>stopDay)
	  {
	   stop=stopDay;
	   tstop=2359;
	  }
	 else
	  tstop = wci.stopTime;
	  //	  tstop = roomList[cid].cal.list[i]->stopTime;
	 
	 notime = (roomList[cid].cal.list[i]->flags & DATE_FLAG_NOTIME) >> DATE_FLAG_NOTIME_SHIFT;
	 if( (perm & READ_HEADS) == READ_HEADS )
	  sprintf(tx,"{%d %d %d %d %d \"%s\" %d %d %d} ",
		  start,tstart,stop,tstop,notime,roomList[cid].cal.list[i]->descr,roomList[cid].cal.list[i]->id,
		  roomList[cid].cal.list[i]->repeatTyp,roomList[cid].cal.list[i]->priority);
	 else
	  sprintf(tx,"{%d %d %d %d %d \"%s\" %d %d %d} ",
		  start,tstart,stop,tstop,notime," ",roomList[cid].cal.list[i]->id,
		    roomList[cid].cal.list[i]->repeatTyp,roomList[cid].cal.list[i]->priority);

	 strcat(buffer,tx);
	 if(!skip2next(&ci,&wci,roomList[cid].cal.list[i]))
	  break;
	 start =wci.startDate;
	 stop  =wci.stopDate;
	}
      }
    }
  }
//  printf("send room Cal '%s'\n",buffer);
 send2Client(socket,buffer);
}
#else
void sendUserCal(int socket, int uid,int cid, int startDay, int stopDay,int igno)
{
 char buffer[16384],tx[1024];
 int start,stop;
 int tstart,tstop;
 int notime;
 int i,status,perm;
 int privatDateIsClosed2Me;
 UserInDate *self;
 CalendarItem ci;

 strcpy(buffer,"");
 sortDateList(userList[cid].cal.list,userList[cid].cal.anz);
 for(i=0;i<userList[cid].cal.anz ; i++)
  {
   if( ! userList[cid].cal.list[i]->deleted )
    {
     self=findUserInDate(userList[cid].cal.list[i],uid);
     if(self != NULL)
      status = self->status ;
     else
      status =0;
     
     privatDateIsClosed2Me = dateIs2Privat2Me(userList[cid].cal.list[i],uid);
     perm = getPermission(userList[cid].cal.list[i],uid,cid);
     if( status != DATE_STAT_IGNORIEREN || igno ==1)  // FIXME Permissions
      if( (perm & READ_TIMES) == READ_TIMES )
       if(!privatDateIsClosed2Me)
	{
	 ci.startDate=userList[cid].cal.list[i]->startDate;
	 ci.startTime=userList[cid].cal.list[i]->startTime;
	 ci.stopDate =userList[cid].cal.list[i]->stopDate;
	 ci.stopTime =userList[cid].cal.list[i]->stopTime;
	 ci.count=0;
	 ci.startwDay=weekDayByDate(ci.startDate);
	 while(ci.stopDate<startDay)
	  if(!skip2next(&ci,userList[cid].cal.list[i]))
	   break;
	 start =ci.startDate;
	 stop  =ci.stopDate;
	 while( start<= stopDay && stop>=startDay)
	  {
	   if(start<startDay)
	    {
	     start=startDay;
	     tstart=0;
	    }
	   else
	    tstart = userList[cid].cal.list[i]->startTime;
	   if(stop>stopDay)
	    {
	     stop=stopDay;
	     tstop=2359;
	    }
	   else
	    tstop = userList[cid].cal.list[i]->stopTime;
	   
	   notime = (userList[cid].cal.list[i]->flags & DATE_FLAG_NOTIME) >> DATE_FLAG_NOTIME_SHIFT;
	   if( (perm & READ_HEADS) == READ_HEADS )
	    sprintf(tx,"{%d %d %d %d %d \"%s\" %d %d %d} ",
		    start,tstart,stop,tstop,notime,userList[cid].cal.list[i]->descr,userList[cid].cal.list[i]->id,
		    userList[cid].cal.list[i]->repeatTyp,userList[cid].cal.list[i]->priority);
	   else
	    sprintf(tx,"{%d %d %d %d %d \"%s\" %d %d %d} ",
		    start,tstart,stop,tstop,notime," ",userList[cid].cal.list[i]->id,
		    userList[cid].cal.list[i]->repeatTyp,userList[cid].cal.list[i]->priority);
	   
	   strcat(buffer,tx);

	   if(!skip2next(&ci,userList[cid].cal.list[i]))
	    break;
	   start =ci.startDate;
	   stop  =ci.stopDate;
	  }
      }
    }
  }
//  printf("send User Cal '%s'\n",buffer);
 send2Client(socket,buffer);
}

void sendGroupCal(int socket, int uid,int cid, int startDay, int stopDay,int igno,int withUserDates)
{
 char buffer[250000],tx[1024];
 int start,stop;
 int tstart,tstop;
 int notime;
 int status,perm;
 int i,privatDateIsClosed2Me;
 UserInDate *self;
 CalendarItem ci;

 strcpy(buffer,"");
 // sortDateList(groupList[cid].cal.list,groupList[cid].cal.anz);
 for(i=0;i<groupList[cid].cal.anz ; i++)
  {
   if( ! groupList[cid].cal.list[i]->deleted )
    {
     self=findUserInDate(groupList[cid].cal.list[i],uid);
     if(self != NULL)
      status = self->status;
     else
      status= 0; // Wenn der User nur via Gruppe dabei ist

     privatDateIsClosed2Me = dateIs2Privat2Me(groupList[cid].cal.list[i],uid);
     perm = getPermission(groupList[cid].cal.list[i],uid,cid);
     if( status != DATE_STAT_IGNORIEREN || igno ==1)  // FIXME Permissions
      if( (perm & READ_TIMES) == READ_TIMES )
       if(!privatDateIsClosed2Me)
	{
	 ci.startDate=groupList[cid].cal.list[i]->startDate;
	 ci.startTime=groupList[cid].cal.list[i]->startTime;
	 ci.stopDate =groupList[cid].cal.list[i]->stopDate;
	 ci.stopTime =groupList[cid].cal.list[i]->stopTime;
	 ci.count=0;
	 ci.startwDay=weekDayByDate(ci.startDate);
	 while(ci.stopDate<startDay)
	  if(!skip2next(&ci,groupList[cid].cal.list[i]))
	   break;
	 start =ci.startDate;
	 stop  =ci.stopDate;

	 while( start<= stopDay && stop>=startDay)
	  {
	   if(start<startDay)
	    {
	     start=startDay;
	     tstart=0;
	    }
	   else
	    tstart = groupList[cid].cal.list[i]->startTime;
	   if(stop>stopDay)
	    {
	     stop=stopDay;
	     tstop=2359;
	    }
	   else
	    tstop = groupList[cid].cal.list[i]->stopTime;
	   
	   notime = (groupList[cid].cal.list[i]->flags & DATE_FLAG_NOTIME) >> DATE_FLAG_NOTIME_SHIFT;
	   if( (perm & READ_HEADS) == READ_HEADS )
	    sprintf(tx,"{%d %d %d %d %d \"%s\" %d %d %d} ",
		    start,tstart,stop,tstop,notime,groupList[cid].cal.list[i]->descr,groupList[cid].cal.list[i]->id,
		    groupList[cid].cal.list[i]->repeatTyp,groupList[cid].cal.list[i]->priority);
	   else
	    sprintf(tx,"{%d %d %d %d %d \"%s\" %d %d %d} ",
		    start,tstart,stop,tstop,notime," ",groupList[cid].cal.list[i]->id,
		    groupList[cid].cal.list[i]->repeatTyp,groupList[cid].cal.list[i]->priority);
	   strcat(buffer,tx);

	   if(!skip2next(&ci,groupList[cid].cal.list[i]))
	    break;
	   start =ci.startDate;
	   stop  =ci.stopDate;
	  }
	}
    }
  }
 if(withUserDates)
  for(i=0;i<groupList[cid].anz; i++)
   addUserCal2Buffer(uid,groupList[cid].membr[i],cid,startDay,stopDay,igno,buffer);
//  printf("send group Cal '%s'\n",buffer);
 send2Client(socket,buffer);
}

void addUserCal2Buffer(int uid,int cid,int gid, int startDay, int stopDay,int igno,char *buffer)
{
 char tx[1024];
 int start,stop;
 int tstart,tstop;
 int notime;
 int i,status,perm;
 int privatDateIsClosed2Me;
 UserInDate *self;
 CalendarItem ci;

 int j;

 // sortDateList(userList[cid].cal.list,userList[cid].cal.anz);
 for(i=0;i<userList[cid].cal.anz ; i++)
  //   printf ("\tchecking '%s' -> %p\n",userList[cid].cal.list[i]->descr,findUserInDate(userList[cid].cal.list[i],gid+GROUPOFFSET));
  if( ! userList[cid].cal.list[i]->deleted )
   if (findUserInDate(userList[cid].cal.list[i],gid+GROUPOFFSET) == NULL) // Es sollen nur solche Termin addiert 
    { //                                                        werden,in den die Gruppe gid nicht schon vorkommt
     self=findUserInDate(userList[cid].cal.list[i],uid);
     if(self != NULL)
      status = self->status ;
     else
      status =0;
     
     privatDateIsClosed2Me = dateIs2Privat2Me(userList[cid].cal.list[i],uid);
     perm = getPermission(userList[cid].cal.list[i],uid,cid);
     if( status != DATE_STAT_IGNORIEREN || igno ==1)  
      if( (perm & READ_TIMES) == READ_TIMES )
       if(!privatDateIsClosed2Me)
	{
	 ci.startDate=userList[cid].cal.list[i]->startDate;
	 ci.startTime=userList[cid].cal.list[i]->startTime;
	 ci.stopDate =userList[cid].cal.list[i]->stopDate;
	 ci.stopTime =userList[cid].cal.list[i]->stopTime;
	 ci.count=0;
	 ci.startwDay=weekDayByDate(ci.startDate);
	 while(ci.stopDate<startDay)
	  if(!skip2next(&ci,userList[cid].cal.list[i]))
	   break;
	 start =ci.startDate;
	 stop  =ci.stopDate;
	 while( start<= stopDay && stop>=startDay)
	  {
	   if(start<startDay)
	    {
	     start=startDay;
	     tstart=0;
	    }
	   else
	    tstart = userList[cid].cal.list[i]->startTime;
	   if(stop>stopDay)
	    {
	     stop=stopDay;
	     tstop=2359;
	    }
	   else
	    tstop = userList[cid].cal.list[i]->stopTime;
	   
	   notime = (userList[cid].cal.list[i]->flags & DATE_FLAG_NOTIME) >> DATE_FLAG_NOTIME_SHIFT;
	   if( (perm & READ_HEADS) == READ_HEADS )
	    sprintf(tx,"{%d %d %d %d %d \"%s\" %d %d %d} ",
		    start,tstart,stop,tstop,notime,userList[cid].cal.list[i]->descr,userList[cid].cal.list[i]->id,
		    userList[cid].cal.list[i]->repeatTyp,userList[cid].cal.list[i]->priority);
	   else
	    sprintf(tx,"{%d %d %d %d %d \"%s\" %d %d %d} ",
		    start,tstart,stop,tstop,notime," ",userList[cid].cal.list[i]->id,
		    userList[cid].cal.list[i]->repeatTyp,userList[cid].cal.list[i]->priority);
	   
	   strcat(buffer,tx);

	   if(!skip2next(&ci,userList[cid].cal.list[i]))
	    break;
	   start =ci.startDate;
	   stop  =ci.stopDate;
	  }
	}
    }
}
void sendRoomCal(int socket, int uid, int cid, int startDay, int stopDay,int igno)
{
 char buffer[16384],tx[1024];
 int start,stop;
 int tstart,tstop;
 int notime;
 int i,perm;
 UserInDate *self;
 CalendarItem ci;

 strcpy(buffer,"");
 sortDateList(roomList[cid].cal.list,roomList[cid].cal.anz);
//  printf("Cal-size for room %d/%s %d\n",cid,roomList[cid].name,roomList[cid].cal.anz);
 for(i=0;i<roomList[cid].cal.anz ; i++)
  {
   if( ! roomList[cid].cal.list[i]->deleted )
    {
     perm = getPermission(roomList[cid].cal.list[i],uid,cid);
     if( (perm & READ_TIMES) == READ_TIMES )
      {
       ci.startDate=roomList[cid].cal.list[i]->startDate;
       ci.startTime=roomList[cid].cal.list[i]->startTime;
       ci.stopDate =roomList[cid].cal.list[i]->stopDate;
       ci.stopTime =roomList[cid].cal.list[i]->stopTime;
       ci.count=0;
       ci.startwDay=weekDayByDate(ci.startDate);
	 while(ci.stopDate<startDay)
	if(!skip2next(&ci,roomList[cid].cal.list[i]))
	 break;
       start =ci.startDate;
       stop  =ci.stopDate;

       while( start<= stopDay && stop>=startDay)
	{
	 if(start<startDay)
	  {
	   start=startDay;
	   tstart=0;
	  }
	 else
	  tstart = roomList[cid].cal.list[i]->startTime;
	 if(stop>stopDay)
	  {
	   stop=stopDay;
	   tstop=2359;
	  }
	 else
	  tstop = roomList[cid].cal.list[i]->stopTime;
	 
	 notime = (userList[cid].cal.list[i]->flags & DATE_FLAG_NOTIME) >> DATE_FLAG_NOTIME_SHIFT;
	 if( (perm & READ_HEADS) == READ_HEADS )
	  sprintf(tx,"{%d %d %d %d %d \"%s\" %d %d %d} ",
		  start,tstart,stop,tstop,notime,roomList[cid].cal.list[i]->descr,roomList[cid].cal.list[i]->id,
		  roomList[cid].cal.list[i]->repeatTyp,roomList[cid].cal.list[i]->priority);
	 else
	  sprintf(tx,"{%d %d %d %d %d \"%s\" %d %d %d} ",
		  start,tstart,stop,tstop,notime," ",roomList[cid].cal.list[i]->id,
		    roomList[cid].cal.list[i]->repeatTyp,roomList[cid].cal.list[i]->priority);

	 strcat(buffer,tx);
	 if(!skip2next(&ci,roomList[cid].cal.list[i]))
	  break;
	 start =ci.startDate;
	 stop  =ci.stopDate;
	}
      }
    }
  }
//  printf("send room Cal '%s'\n",buffer);
 send2Client(socket,buffer);
}
#endif


#ifdef V038
UserDateModification *getUserModification4Date(int did,int uid)
{
 int i;
 User *usr;

 usr =&userList[uid];
 for(i=0;i<usr->dmodiAnz; i++)
  if(usr->dmodi[i].did == did)
   return(&usr->dmodi[i]);

 return(NULL);
}
int dateIsIgnoredByMe(int did,int uid)
{
 int i;
 User *usr;

 usr =&userList[uid];
 for(i=0;i<usr->dmodiAnz; i++)
  if(usr->dmodi[i].did == did)
   return(usr->dmodi[i].ignored);

 return(false);
}

int dateOnlyAsInfo(Date *d,int uid)
{
 int i,j,gid;

 for(i=0;i<d->partAnz; i++)
  {
   if(d->part[i].id <GROUPOFFSET)
    {
     if(d->part[i].id==uid)
      if(d->part[i].typ != UID_TYP_INFO)
       return(false);
    }
   else
    {
     gid = d->part[i].id-GROUPOFFSET;
     for(j=0;j<userList[uid].ganz; j++)
      if(userList[uid].groups[j] == gid)
       if(d->part[i].typ != UID_TYP_INFO)
	return(false);
    }
  }
 return(true);
}

#endif
