#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <unistd.h>  
#include <errno.h>    
#include <netinet/in.h>  
#include <fcntl.h>  
#include <time.h>       
#include <signal.h>     

#define ___MAIN
#include "termin.h"

#define MAX_CLIENTS 100
#define MASTERPORT  41999
 
struct sockaddr_in MasterSocketAddress;
struct sockaddr_in clientSocketAddress[MAX_CLIENTS];
int port[MAX_CLIENTS],masterPort;
int clientSocket[MAX_CLIENTS],tcSocket[MAX_CLIENTS],masterSocket,tmpSocket,portused[MAX_CLIENTS];
int freeSince[MAX_CLIENTS];
int doReload=false;
char tclMsg[16384];
int localVerbose=false;


int ckeck4ClientOnMasterPort( );
void initSockets();
int  openSocket2Client(int cid);
void openMasterSocket();
void acceptClient( int cid );
int send2Client(int socket,char *msg);
int send2Client_(int socket,char *msg);
int check4ClientMessage(int socket,char *t, int l);
int check4ClientMessageVerbose(int socket,char *t, int l);
int nextFreeCID();
void initReload(int value);
void closeAllConnection(int value);
int freeSockets(int cid);
void getToday ( );


int main(int argc, char *argv[])
{
 char buffer[16384],*p,*s;
 int l,canz,tmpSocket;
 int cid,i,stat;
 char *t;
 int stim,rtim,rctim,tim,ulistUpdateTim;
 FILE *fp;


 fp=fopen("/var/run/minkowsky.pid","w");
 if(fp==NULL)
  {
   printf("Can't open /var/run/minkowsky.pid");
   exit(-1);
  }
 fprintf(fp,"%d",getpid());
 fclose(fp);

 verbose=false;
 noReminder=false;
 strcpy(progName,"Minkowsky Raum/Zeit Verwaltung");
 strcpy(company,"");
 dataDir=NULL;
 fp=fopen("/etc/minkowsky","r");
 if(fp == NULL)
  fp=fopen("/etc/terminator","r");
 if(fp!=NULL)
  {
   p=fgets(buffer,8190,fp);
   while(p!=NULL)
    {
     //     printf("reading resource: %s (%d)\n",buffer,verbose);
     if(strncmp(buffer,"DATA_PATH",15)==0)
      {
       t=skip2nonWS(buffer+16);
       s= t+strlen(t)-1;
       if(*s=='\n')
	*s='\0';
       dataDir = new char [strlen(t)+4];
       strcpy(dataDir,t);
      }
     else if(strncmp(buffer,"TERMIN_DATA_PATH",15)==0)
      {
       t=skip2nonWS(buffer+16);
       s= t+strlen(t)-1;
       if(*s=='\n')
	*s='\0';
       dataDir = new char [strlen(t)+4];
       strcpy(dataDir,t);
      }
     else if(strncmp(buffer,"SERVER_BIN_PATH",15)==0)
      {
       t=skip2nonWS(buffer+16);
       s= t+strlen(t)-1;
       if(*s=='\n')
	*s='\0';
       serverBinPath = new char [strlen(t)+4];
       mail2smtp = new char [strlen(t)+32];
       strcpy(serverBinPath,t);
       sprintf(mail2smtp,"%s/mail2smtp",serverBinPath);
      }
     else if(strncmp(buffer,"VERBOSE",7)==0)
      {
       s=skip2nonWS(buffer+8);
       //       printf("s=%s\n",s);
       if(strncasecmp(s,"on",2)==0)
	verbose=true;
      }
     else if(strncmp(buffer,"COMPANY",7)==0)
      {
       t=skip2nonWS(buffer+8);
       s= t+strlen(t)-1;
       if(*s=='\n')
	*s='\0';
       if(strlen(s)>127)
	{
	 strncpy(company,s,127);
	 company[127]='\0';
	}
       else
	 strcpy(company,s);
      }
     else if(strncmp(buffer,"REPLY_ADDRESS",13)==0)
      {
       t=skip2nonWS(buffer+14);
       strcpy(replyAddress,t);
      }
     else if(strncmp(buffer,"MYSELF",7)==0)
      {
       t=skip2nonWS(buffer+8);
       s= t+strlen(t)-1;
       if(*s=='\n')
	*s='\0';
       if(strlen(s)>63)
	{
	 strncpy(progName,s,63);
	 progName[63]='\0';
	}
       else
	 strcpy(progName,s);
      }
     p=fgets(buffer,8190,fp);
    }
   fclose(fp);
  }
 else
  printf("Can't open /etc/minkowsky (%p)\n",fp);
 // printf("dataDir=%p\n",dataDir);
 if(dataDir==NULL)
  {
   dataDir= new char [32];
   strcpy(dataDir,"/usr/local/share/termine");
  }


 if(argc>1)
  {
   int ac=1;
   while(ac<argc)
    {
     if(strcmp(argv[ac],"-v")==0)
      verbose=true;
     else if(strcmp(argv[ac],"-nr")==0)
      noReminder=true;
     ac++;
    }
  }


 if(verbose)
  printf("Running in Verbose Mode\n");


 mailMaskEinlExternText=NULL;
 mailMaskEinlExternSubj=NULL;
 mailMaskEinlInternText=NULL;
 mailMaskEinlInternSubj=NULL;
 mailMaskErinExternText=NULL;
 mailMaskErinExternSubj=NULL;
 mailMaskErinInternText=NULL;
 mailMaskErinInternSubj=NULL;
 mailMaskErinToDoText=NULL;
 mailMaskErinToDoSubj=NULL;
 mailMaskMahnToDoText=NULL;
 mailMaskMahnToDoSubj=NULL;






 readLists();
 initDateList();
 initReminderList();
 initAdrList();
 initTodoList();
 initProjList();
 readAdrList();
 readDates();
 readTodoList();
 readProjList();
 recreateReminderList();
 updateDateCountsInAddress();
 lastDateChange =time(NULL);
 ulistUpdateTim = stim = lastReminderListCreation = rtim = time(NULL);
 signal(SIGUSR1,initReload);  
 signal(SIGTERM,closeAllConnection);  
 signal(SIGINT ,closeAllConnection);  

 


 if(verbose)
  for(i=0;i<roomAnz;i++)
   if(roomList[i].id>=0)
    printf("Termine in '%s'/%d : %d\n",roomList[i].name,i,roomList[i].cal.anz);
 
 initSockets();
 // watch for request
 for(;;)
  {
   // check Master Port
   if( (tmpSocket=ckeck4ClientOnMasterPort()) >=0)
    {
     if(verbose)
      printf("Masterport connection on %d\n",tmpSocket);
     if( (canz=check4ClientMessageVerbose(tmpSocket,buffer,16383)) >0)
      {
       buffer[16383]='\0';
       if(verbose)
	printf("Got: %s\n",buffer);
       
       if(strncmp(buffer,"connect",7)==0)
	{ // reqPort
	 char user[32],pwd[32],dummy[32],dummy2[32],npwd[32],salt[4];
	 int uid;
	 
	 if(verbose)
	  printf("Connecting via '%s'\n",buffer);

	 sscanf(buffer,"%s %s %s %s",dummy,user,pwd); //FIXME AUTH
	 uid=uname2uid(user);
	 if(uid<0)
	  {
	   if(verbose)
	    printf("no such user %s\n",user);
	   send2Client(tmpSocket,"denied");
	   continue;
	  }
	 strncpy(salt,userList[uid].pwd,2);
	 salt[2]='\0';
	 strcpy(npwd,text2Pwd(pwd,salt));
	 if(strcmp(pwd,"")!=0 || strlen(userList[uid].pwd)>0)
	  if(strcmp(npwd,userList[uid].pwd)!=0)
	   {
	    if(verbose)
	     printf("AUTH error '%s' '%s'\n",userList[uid].pwd,text2Pwd(pwd,userList[uid].pwd));
	    send2Client(tmpSocket,"denied");
	    continue;
	   }
	 cid=nextFreeCID();
	 if(cid<0)
	  {
	   send2Client(tmpSocket,"noResource");
	   continue;
	  }
	 tcSocket[cid]= tmpSocket;
	 freeSince[cid]=-1;
	 userList[uid].lastAction = (int) time(NULL);
	 portused[cid]=true;  // Kann Wegfallen, wenn 'req port' Connection wegfallen
	 send2Client(tcSocket[cid],"connected");
	}
       else
	shutdown(tmpSocket,2);
      }
     if(verbose)
      printf ("canz=%d from %d (%d) \n",canz,masterSocket,tmpSocket);
    }

   for(cid=0;cid<MAX_CLIENTS; cid++)
    if(portused[cid])
     {
      if(freeSince[cid]>0)
       {
	tim=time(NULL);
	if(tim - freeSince[cid] > 120)
	 {
	  if(verbose)
	   printf("freeing port %d\n",cid);
	  portused[cid]=false;
	  freeSince[cid]=-1;
	 }
       }
      if( (canz=check4ClientMessage(tcSocket[cid],buffer,16383)) >0)
       {
	buffer[16383]='\0';
	if(verbose)
	 printf("Got: %s\n",buffer);
	if (strcmp(buffer,"client connected")==0)
	 send2Client(tcSocket[cid],"connection verified");

	else if(strncmp(buffer,"addDate",7)==0)
	 {
	  if(addDate(buffer+8))
	   send2Client(tcSocket[cid],"OK");
	  else
	   send2Client(tcSocket[cid],"denied");
	 }
	else if(strncmp(buffer,"modifyDate",10)==0)
	 {
	  modifyDate(tcSocket[cid],buffer+11);
	 }
	else if (strncmp(buffer,"aquireDate",10)==0)
	  aquireDate(tcSocket[cid],buffer+11 );
	else if (strncmp(buffer,"cancelEditDate",14)==0)
	  cancelEditDate(tcSocket[cid],buffer+15 );
	else if (strncmp(buffer,"shiftDateInfo",13)==0)
	  getShiftDateInfo(tcSocket[cid],buffer+14 );
	else if (strncmp(buffer,"shiftDate",9)==0)
	  shiftDate(tcSocket[cid],buffer+10 );
	else if (strncmp(buffer,"changeStatus",12)==0)
	  changeDateStatus4User(tcSocket[cid],buffer+13 );
	else if (strncmp(buffer,"suspendDate",11)==0)
	  suspendDate(tcSocket[cid],buffer+12 );
	
	
	else if(strncmp(buffer,"getUserCal",10)==0)
	 getUserCal(buffer+11,tcSocket[cid]);
 	else if(strncmp(buffer,"getUserPrefs",12)==0)
	 getUserPrefs(buffer+13,tcSocket[cid]);
  	else if(strncmp(buffer,"saveUserPrefs",13)==0)
	 saveUserPrefs(buffer+14,tcSocket[cid]);
  	else if(strncmp(buffer,"getLists",8)==0)
	 getLists(tcSocket[cid]);
  	else if(strncmp(buffer,"getMemberLists",14)==0)
	 getGroupMembersList(tcSocket[cid]);
  	else if(strncmp(buffer,"getUserList",11)==0)
	 getUserList(tcSocket[cid]);
  	else if(strncmp(buffer,"getGroupList",12)==0)
	 getGroupList(tcSocket[cid]);
  	else if(strncmp(buffer,"getRoomList",11)==0)
	 getRoomList(tcSocket[cid]);
   	else if(strncmp(buffer,"getFullUserName",15)==0)
	 getFullUserName(tcSocket[cid],buffer+16);
	else if (strncmp(buffer,"groupListByUser",15)==0)
	 getGroupsOfUser(tcSocket[cid],buffer+16);
	else if (strncmp(buffer,"usersOfGroup",12)==0)
	 getUsersOfGroup(tcSocket[cid],buffer+13);
	else if (strncmp(buffer,"deleteDate",10)==0)
	  deleteDate(tcSocket[cid],buffer+11);
	else if (strncmp(buffer,"getDate",7)==0)
	  sendDate(tcSocket[cid],buffer+8 );
	else if (strncmp(buffer,"getBriefDate",12)==0)
	  sendBriefDate(tcSocket[cid],buffer+13 );
	else if (strncmp(buffer,"getBlockedTimes",15)==0)
	  getBlockedTimes(tcSocket[cid],buffer+16 );
	else if (strncmp(buffer,"ignoreDate",10)==0)
	  ignoreDate(tcSocket[cid],buffer+11 );
	else if (strncmp(buffer,"doNotremind",11)==0)
	  suspendReminder(tcSocket[cid],buffer+12 );
	else if (strncmp(buffer,"lastUListUpdate",15)==0)
	 {
	  sprintf(tclMsg,"%d",ulistUpdateTim);
	  send2Client(tcSocket[cid],tclMsg);
	 }
	else if (strncmp(buffer,"addComm",7)==0)
	  addComm(tcSocket[cid],buffer+8 );
	else if (strncmp(buffer,"updateComm",10)==0)
	  getComm(tcSocket[cid],buffer+10 );
	else if (strncmp(buffer,"lastChangeDate",14)==0)
	 {
	  sprintf(tclMsg,"%d",lastDateChange);
	  send2Client(tcSocket[cid],tclMsg);
	 }

	else if (strncmp(buffer,"changeAdr", 9)==0)
	  changeAdress(tcSocket[cid],buffer+10 );
	else if (strncmp(buffer,"getAdrList",10)==0)
	  sendAddresssList(tcSocket[cid],buffer+11 );
	else if (strncmp(buffer,"getBriefAdrList",15)==0)
	  sendBriefAdressList(tcSocket[cid],buffer+16 );
	else if (strncmp(buffer,"getAdr", 6)==0)
	  sendAddress(tcSocket[cid],buffer+ 7 );
	else if (strncmp(buffer,"delAdr", 6)==0)
	  deleteAddress(tcSocket[cid],buffer+ 7 );
	else if (strncmp(buffer,"addNotiz", 8)==0)
	  addNotiz(tcSocket[cid],buffer+ 9 );
	else if (strncmp(buffer,"getNotiz", 8)==0)
	  getNotiz(tcSocket[cid],buffer+ 9 );

	else if (strncmp(buffer,"changeTodo",10)==0)
	 changeToDo(tcSocket[cid],buffer+11);
	else if (strncmp(buffer,"changeStatus4Todo",17)==0)
	 changeTodoStatus(tcSocket[cid],buffer+18);
	else if (strncmp(buffer,"changeProject",13)==0)
	 changeProject(tcSocket[cid],buffer+14);
	else if (strncmp(buffer,"getTODO", 7)==0)
	 sendTodo(tcSocket[cid],buffer+ 8);
	else if (strncmp(buffer,"getProject",10)==0)
	 sendProject(tcSocket[cid],buffer+11);
	else if (strncmp(buffer,"getProjLists",12)==0)
	 sendProjectAndTodoLists(tcSocket[cid],buffer+13);
	else if (strncmp(buffer,"getLastProjTodoChange",21)==0)
	 getLastProjTodoChange(tcSocket[cid]);
	else if (strncmp(buffer,"deleteTodo",10)==0)
	 deleteTodo(tcSocket[cid],buffer+11);
	else if (strncmp(buffer,"deleteProject",13)==0)
	 deleteProject(tcSocket[cid],buffer+14);

	else if (strncmp(buffer,"ServerUp?",9)==0)
	  send2Client(tcSocket[cid],"ServerIsUp");
	else if (strncmp(buffer,"exit",4)==0)
	 freeSockets(cid);
	else
	 send2Client(tcSocket[cid],"Err unknown Command");
      }      
     }


   usleep(250000);
   tim =  time(NULL);   
   if( (tim %60)<15)
    if(tim-rtim>30)
     {
      rtim=tim;
      check4Reminder();
      getToday();
     }
   if(tim -stim >60)
    {
     stim=tim;
     writeDates();
     printf("dates written\n");
    }
   if(tim-lastReminderListCreation >3600)
    {
     recreateReminderList();
     updateDateCountsInAddress();
    }
   if(doReload)
    {
     writeAdrList();
     writeDates();
     sleep(1);
     clearDateList();
     clearTodoList();
     clearProjList();
     clearLists();
     clearReminderList();
     clearAdrList();


     readLists();
     initDateList();
     initAdrList();
     initTodoList();
     initProjList();
     readAdrList();
     readDates();
     readTodoList();
     readProjList();
     initReminderList();
     recreateReminderList();
     ulistUpdateTim=stim =time(NULL);
     doReload=false;
    }
  }
}


void initSockets()
{
 int i;
 for(i=0;i<MAX_CLIENTS; i++)
  {
   portused[i]=false;
   port[i]=MASTERPORT+1+i;
  }
 masterPort=MASTERPORT;
 openMasterSocket();
}

void openMasterSocket()
{
 unsigned int addrlen;
 int ret,i;

 masterSocket=socket(AF_INET,SOCK_STREAM,0);
 if(masterSocket<0)
  {
   printf("Can't create masterSocket\n\tReason: Error #%d ; '%s'\n",errno,strerror(errno));
   exit(-1);
  }
 if(verbose)
  printf("Master Socket created id=%d\n",masterSocket);

 MasterSocketAddress.sin_family = AF_INET;
 MasterSocketAddress.sin_addr.s_addr = INADDR_ANY;
 // Port festlegen
 MasterSocketAddress.sin_port = htons(masterPort);

 ret = bind(masterSocket,(struct sockaddr *)&MasterSocketAddress,sizeof(MasterSocketAddress));
 while(ret<0)
  {
   int tmp;
   printf("Can't bind  masterSocket to port %d \n\tReason: Error #%d ; '%s'\n",
          masterPort,errno,strerror(errno));
   printf("\tWaiting for port to become free\n\n");
   sleep(5);
   ret = bind(masterSocket,(struct sockaddr *)&MasterSocketAddress,sizeof(MasterSocketAddress));
  }
 for(i=0; i<3; i++)
  {
   printf("%c",'G'-'@');
   fflush(stdout);
   usleep(200000);
  }
 
 if(verbose)
  printf("Master Scocket(%d) bound to port %d : %d\n",masterSocket,masterPort,ret);
 if(ret<0)
  printf("Error :%d/%s\n",errno,strerror(errno));
 // Lausche ob jemand mit dir quatschen will
 ret=listen(masterSocket,3);
 if(ret<0)
  {
   printf("Can't listen on  masterSocket\n\tReason: Error #%d ; '%s'\n",errno,strerror(errno))
;
   exit(-1);
  }
 if(verbose)
  printf("Master Scocket(%d) listening : %d\n",masterSocket,ret);
 fcntl(masterSocket, F_SETFL, O_NONBLOCK);
}
int ckeck4ClientOnMasterPort( )
{
 struct sockaddr_in address;
 socklen_t len;
 int socket;

 address.sin_family = AF_INET;
 address.sin_addr.s_addr = INADDR_ANY;
 address.sin_port = htons(masterPort);
 len = sizeof(struct sockaddr_in);
 socket = accept(masterSocket, (struct sockaddr *)&address,&len);
 if(socket<0)
  {
   return(socket);
  }

 if(verbose)
  printf("Connection established on socket %d\n",socket);
 fcntl(socket, F_SETFL, O_NONBLOCK);
 return(socket);
}


void acceptClient( int cid )
{
 struct sockaddr_in address;
 socklen_t len;
 int socket;

 address.sin_family = AF_INET;
 address.sin_addr.s_addr = INADDR_ANY;
 address.sin_port = htons(masterPort);
 len = sizeof(struct sockaddr_in);
 tcSocket[cid] = accept(clientSocket[cid], (struct sockaddr *)&address,&len);
 if(socket<0)
  {
   printf("ERROR: #%d, '%s' \t\tretrying\n",errno,strerror(errno));
   // FIX ME Error handler
  }
 else
  {
   if(verbose)
    printf("Connection established on socket %d\n",tcSocket[cid]);
 // fcntl(mySocket, F_SETFL, O_NONBLOCK);
   fcntl(tcSocket[cid], F_SETFL, O_NONBLOCK);
  }
}

int openSocket2Client(int cid)
{
 unsigned int addrlen;
 int ret;

 clientSocket[cid]=socket(AF_INET,SOCK_STREAM,0);
 if(clientSocket[cid]<0)
  {
   printf("Can't create masterSocket\n\tReason: Error #%d ; '%s'\n",errno,strerror(errno));
   freeSince[cid]=time(NULL);
   portused[cid]=true;
   return(false);
  }
 if(verbose)
  printf("Master Socket created id=%d\n",clientSocket[cid]);

 clientSocketAddress[cid].sin_family = AF_INET;
 clientSocketAddress[cid].sin_addr.s_addr = INADDR_ANY;
 // Port festlegen
 clientSocketAddress[cid].sin_port = htons(port[cid]);

 ret = bind(clientSocket[cid],(struct sockaddr *)&clientSocketAddress[cid],sizeof(clientSocketAddress[cid]));
 if(ret<0)
  {
   int tmp;
   printf("Can't can't bind  clientSocket to port %d \n\tReason: Error #%d ; '%s'\n",
          port[cid],errno,strerror(errno));
   freeSince[cid]=time(NULL);
   portused[cid]=true;
   return(false);
  }
 if(verbose)
  printf("Master Scocket(%d) bound to port %d : %d\n",clientSocket[cid],port[cid],ret);
 if(ret<0)
  printf("Error :%d/%s\n",errno,strerror(errno));
 // Lausche ob jemand mit dir quatschen will
 ret=listen(clientSocket[cid],3);
 if(ret<0)
  {
   printf("Can't can't listen on  masterSocket\n\tReason: Error #%d ; '%s'\n",errno,strerror(errno))
;
   freeSince[cid]=time(NULL);
   portused[cid]=true;
   return(false);
  }
 if(verbose)
  printf("Master Scocket(%d) listening : %d\n",clientSocket[cid],ret);

 // fcntl(clientSocket[cid], F_SETFL, O_NONBLOCK);
}

int send2Client(int socket,char *msg)
{
 int ret;
 ret=send(socket,msg,strlen(msg)+1,0);
 ret=send(socket,"EOT",4,0);
 if(verbose)
  printf("sen to Client: ''%sEOT''\n",msg);
 return(ret);
}
int send2Client_(int socket,char *msg)
{
 int ret;
 ret=send(socket,msg,strlen(msg)+1,0);
 return(ret);
}


int check4ClientMessage(int socket,char *t, int l)
{
 char buffer[16384];
 int ret,tl,ttl=16,st=2000;
 ret=recv(socket,t,l,0);
 if(ret>0)
  {
   tl=ret;
   while(t[tl-1] !='\0')
    {
     ret=recv(socket,buffer,1024,0);
     if(ret>0)
      {
       strcat(t,buffer);
       tl +=ret;
      }
     else
      {
       if(ttl<=0)
	break;
       printf("trying to get data from client ; ttl=%d\n",ttl);
       usleep(st);
       st =st*2;
       ttl--;
      }
    }
   return(ret);
  }
//  if(verbose)
//   printf("givving up\n");
 return(-1);
}
int check4ClientMessageVerbose(int socket,char *t, int l)
{
 char buffer[16384];
 int ret,tl,ttl=16,st=2000;
 // printf("waint for message on socket %d\n",socket);
 ret=recv(socket,t,l,0);
 // printf("got ret=%d\n");
 if(ret>0)
  {
   tl=ret;
   while(t[tl-1] !='\0')
    {
     ret=recv(socket,buffer,1024,0);
     if(ret>0)
      {
       strcat(t,buffer);
       tl +=ret;
      }
     else
      {
       if(ttl<=0)
	break;
       printf("trying to get data from client ; ttl=%d\n",ttl);
       usleep(st);
       st =st*2;
       ttl--;
      }
    }
   return(ret);
  }
 printf("givving up\n");
 return(-1);
}

int nextFreeCID()
{
 int i;

 for(i=0; i<MAX_CLIENTS; i++)
  {
   if(verbose)
    printf("port %d : %d %d %d\n",i,portused[i],freeSince[i],time(NULL)-freeSince[i]);
   if(!portused[i])
    return(i);
  }
 return(-1);
}

int freeSockets(int cid)
{
 int ret;
 if(verbose)
  printf("freeing Socket %d\t",cid);
 ret = shutdown(tcSocket[cid],2);
 ret = shutdown(clientSocket[cid],2);
 ret = close(tcSocket[cid]);
 if(verbose)
  printf("%d\t",ret);
 ret = close(clientSocket[cid]);
 if(verbose)
  printf("%d\n",ret);
 freeSince[cid] = time(NULL);
 // portused[cid]=false;
}


void initReload(int value)
{
 doReload=true;
}

void closeAllConnection (int vlaue)
{
 int cid;

//  for(cid=0;cid<MAX_CLIENTS; cid++)
//   if(portused[cid])
//    {
//     send2Client(tcSocket[cid],"down");
//    }
 writeAdrList();
 writeDates();

 printf("shutting down connections\n");
 for(cid=0;cid<MAX_CLIENTS; cid++)
  if(portused[cid])
   {
    shutdown(tcSocket[cid],2);
    shutdown(clientSocket[cid],2);
    close(tcSocket[cid]);
    close(clientSocket[cid]);
   }
 
 shutdown(masterSocket,2);
 shutdown(tmpSocket,2);
 close(tmpSocket);
 close(masterSocket);
 printf("done\n");
 writeDates();
 sleep(1);
 exit(0);
}

void getToday ( )
{
 char tstr[64];
 time_t tim=time(NULL);
 strftime(tstr,255,"%Y%m%d",localtime(&tim));0;   
 today=atoi(tstr);
}
