#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <sys/types.h>
#include <sys/stat.h>
//#include <unistd.h>
#define _XOPEN_SOURCE
#include <unistd.h>
#include <crypt.h>
 
 
#include "termin.h"

void saveStandardPrefs(FILE *fp);


int getUserPrefs (char *str,int socket)
{
 char buffer[16384],*t;
 char gpermList[16000],tx[256],txt[256];
 int uid,i;

 t=skip2WS(str+2);
 *t='\0';
 uid = uname2uid(str);
 if(uid<0)
  {
   sprintf(buffer,"ERR: No User '%s' registerd\n",str);
   send2Client(socket,buffer);
   return(0);
  }

 readUserPrefs(uid);
 sprintf(gpermList,"{default %s}",perm2str(userList[uid].calPerm,tx));
 for(i=0 ; i<userList[uid].gpanz; i++)
  {
   sprintf(txt," {%s %s}",groupList[userList[uid].gPerm[i].id].name,perm2str(userList[uid].gPerm[i].perm,tx));
   strcat(gpermList,txt);
  }
 sprintf(buffer,"{%s} %d %s {%s} {%s} %d %d %d",
	 userList[uid].defPermStr,userList[uid].sig.beep,userList[uid].sig.cmd,gpermList,userList[uid].calFormat
	 ,userList[uid].displayIgnore,userList[uid].displayInfo,userList[uid].displayToolTips);
 send2Client(socket,buffer);
}
int readUserPrefs(int uid)
{
 char file[2096],buffer[16384] ,*tp[64],*t,*tp2[8],*s;
 FILE *fp;
 int ret,gpanz,gid;

 sprintf(file,"%s/prefs/%d.prefs",dataDir,uid);
 fp=fopen(file,"r");
 // printf("-> %p (%s)\n",fp,file);
 if(fp==NULL)
  {
   fp=fopen(file,"w");
   perror(NULL);
   if(fp==NULL)
    {
     printf("ERR: Can;t write default-Prefs");
     return(false);
    }
   else
    {
     //     printf("saving default prefs\n");
     saveStandardPrefs(fp);
     fclose(fp);
     fp=fopen(file,"r");
    }
  }

 // printf("-> %p\n",fp);
 if(fp==NULL)
  {
   printf("ERR: Can;t open Prefs");
   return(false);
  }
 else
  {
   gpanz=0;
   t=fgets(buffer,16383,fp);
   strChop(t);
   while(t!=NULL)
    {
     if(strncmp(buffer,"DEFPERM",7)==0)
      {
       t=skip2nonWS(buffer+8);
       strcpy(userList[uid].defPermStr,t);
      }
     else if (strncmp(buffer,"FLAGS",5)==0)
      {
       t=skip2nonWS(buffer+6);
       split(t,tp2,8);
       userList[uid].displayIgnore   =atoi(tp2[0]);
       userList[uid].displayInfo     =atoi(tp2[1]);
       userList[uid].displayToolTips =atoi(tp2[2]);
      }
     else if (strncmp(buffer,"SIGNAL",6)==0)
      {
       int l;
       t=skip2nonWS(buffer+7);
       split(t,tp2,8);
       userList[uid].sig.beep =atoi(tp2[0]);
       l = strlen(tp2[1]);
       if(userList[uid].sig.cmd !=NULL)
	delete userList[uid].sig.cmd;
       userList[uid].sig.cmd = new char [l+4];
       strcpy(userList[uid].sig.cmd,tp2[1]);
      }
     else if (strncmp(buffer,"GROUPPERM",9)==0)
      {
       t=fgets(buffer,16383,fp);
       while(t!=NULL && strcmp(buffer,"ENDGROUPPERM")!= 0)
	{
	 split(buffer,tp2,8);
	 trimRight(tp2[0]);
	 if(strcmp(tp2[0],"default")==0)
	  {
	   userList[uid].calPerm = perm2val(tp2[1]);
	  }
	 else
	  {
	   gid = gname2gid(tp2[0]);
	   if(gid>=0)
	    {
	     userList[uid].gPerm[gpanz].id   = gid;
	     userList[uid].gPerm[gpanz].perm = perm2val(tp2[1]);
	     //	     printf("got groupPrem for %s @ %s : %s->%d",groupList[gid].name,userList[uid].name,tp2[1],userList[uid].gPerm[gpanz].perm);
	     gpanz++;
	    }
	  }
	 t=fgets(buffer,16383,fp);
	}
     }
     else if (strncmp(buffer,"PWD",3)==0)
      {
       s=skip2nonWS(buffer+3);
       strcpy(userList[uid].pwd,strTrim(s));
      }
     else if (strncmp(buffer,"CALFORMAT",9)==0)
      {
       s=skip2nonWS(buffer+9);
       strcpy(userList[uid].calFormat,strTrim(s));
       //       printf("got CALFORMAT '%s // %s'",s,userList[uid].calFormat);
      }
     if(t!=NULL)
      {
       t=fgets(buffer,16383,fp);
       strChop(t);
      }
    }
   userList[uid].gpanz =gpanz;
   fclose(fp);
  }
 return(true);
}

void saveStandardPrefs(FILE *fp)
{
 fprintf(fp,"DEFPERM ztkztk- ztk---k- ztk----- ztk-----\n");
 fprintf(fp,"SIGNAL 1 beep\n");
 fprintf(fp,"CALFORMAT 7 20 3 3 2 3\n");
 fprintf(fp,"FLAGS 0 1 1\n");
 fprintf(fp,"GROUPPERM\n");
 fprintf(fp,"default ztk-----\n");
 fprintf(fp,"ENDGROUPPERM\n");
}
int  saveUserPrefs (char *str,int socket)
{
 char file[2096],buffer[16384] ,*tp[64],*tp2[200],cpwd[17],salt[3];
 char calFormat[64];
 int uid,anz,l,gpanz,i,gid;
 int havePWD=true;
 FILE *fp;

 anz= split(str,tp,16);
 
 uid = uname2uid(tp[0]);
 if(uid<0)
  {
   send2Client(socket,"ERR: No such user");
   return(-1);
  }

 sprintf(userList[uid].defPermStr,"%s %s %s %s\n",tp[1],tp[2],tp[3],tp[4]);
 userList[uid].sig.beep =atoi(tp[5]);
 l = strlen(tp[6]);
 if(userList[uid].sig.cmd !=NULL)
  delete userList[uid].sig.cmd;
 userList[uid].sig.cmd = new char [l+4];
 strcpy(userList[uid].sig.cmd,tp[6]);

 gpanz=0;
 anz=split(tp[7],tp2,200);
 for(i=0 ; i<anz; i+=2)
  {
   if(strcmp(tp2[i],"default")==0)
    userList[uid].calPerm = perm2val(tp2[i+1]);
   else
    {
     gid = gname2gid(tp2[i]);
     if(gid>=0)
      {
       userList[uid].gPerm[gpanz].id   = gid;
       userList[uid].gPerm[gpanz].perm = perm2val(tp2[i+1]);
       gpanz++;
      }
    }
  }
 userList[uid].gpanz =gpanz;

 strcpy(salt,"kp");
 strTrim(tp[8]);
 printf("PWD -------> /%s/ %d \n",tp[8],strlen(tp[8]));
 if(strlen(tp[8])<=0)
  havePWD=false;
 else
  strcpy(userList[uid].pwd,text2Pwd(tp[8],salt));
 strcpy(calFormat,tp[9]);
 
 userList[uid].displayIgnore   = atoi(tp[10]);
 userList[uid].displayInfo     = atoi(tp[11]);
 userList[uid].displayToolTips = atoi(tp[12]);

 sprintf(file,"%s/prefs/%d.prefs",dataDir,uid);
 fp=fopen(file,"w");
 if(verbose)
  printf("saveing prefs to %s\n",file);
 if(fp==NULL)
  send2Client(socket,"ERR: Can;t write Prefs");
 else
  {
   fprintf(fp,"DEFPERM %s\n",userList[uid].defPermStr);
   fprintf(fp,"SIGNAL %d %s\n",userList[uid].sig.beep,userList[uid].sig.cmd);
   if(havePWD)
    fprintf(fp,"PWD %s\n",userList[uid].pwd);
   fprintf(fp,"CALFORMAT %s\n",calFormat);
   fprintf(fp,"FLAGS %d %d %d\n",userList[uid].displayIgnore,userList[uid].displayInfo,userList[uid].displayToolTips);
   fprintf(fp,"GROUPPERM\n");
   fprintf(fp,"default %s\n",perm2str(userList[uid].calPerm,buffer));
   for(i=0 ; i<userList[uid].gpanz; i++)
     fprintf(fp,"%s %s\n",groupList[userList[uid].gPerm[i].id].name,perm2str(userList[uid].gPerm[i].perm,buffer));
   fprintf(fp,"ENDGROUPPERM\n");
   fclose(fp);
  }
 send2Client(socket,"done");
}

char *text2Pwd(char *t,char *salt)
{
 char cpwd[9],*s;
 strncpy(cpwd,t,8);
 cpwd[8]='0';
 s =crypt(cpwd,salt); 
 // printf("'%s' -> '%s' via '%s'  -> '%s'\n",t,cpwd,salt,s);
 return(s);
}

// int checkAuth(char *pwd, int uid)
// {
//  char npwd[32];
 
//  if(strcmp(pwd,"") && strlen(userList[uid].pwd)

//  strcpy(npwd,text2Pwd(pwd,userList[uid].pwd));
// }


